library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity Testgenerator is
    Port ( 
		STOP_GENERATOR : in STD_LOGIC;
		DATA_DATA 		: out STD_LOGIC_VECTOR(7 downto 0);
		DATA_VALID		: out STD_LOGIC;

		Reset 			: in STD_LOGIC;
		Clk 				: in  STD_LOGIC);
		
end Testgenerator;

architecture Behavioral of Testgenerator is
        type STATE_Type is (
				SM_RESET,
				SM_ENTRAINMENT_0,
				SM_ENTRAINMENT_1,
				SM_ENTRAINMENT_2,
				SM_ENTRAINMENT_3,
				SM_ENTRAINMENT_4,
				SM_ENTRAINMENT_5,
				SM_ENTRAINMENT_6,
				SM_ENTRAINMENT_7,
				SM_ENTRAINMENT_8,
				SM_ENTRAINMENT_9,
				SM_ENTRAINMENT_10,
            SM_ENTRAINMENT_11,
            SM_INIT_TRANSFER_A,
				SM_INIT_TRANSFER_B,
            SM_ADDRESS,
				SM_BYTE_01,
				SM_BYTE_02,
				SM_BYTE_03,
				SM_BYTE_04,
				SM_BYTE_05,
				SM_BYTE_06,
				SM_BYTE_07,
				SM_BYTE_08,
				SM_BYTE_09,
				SM_BYTE_10,
				SM_BYTE_11,
				SM_BYTE_12,
				SM_BYTE_13,
				SM_BYTE_14,
				SM_BYTE_15,
				SM_BYTE_16,
				SM_BYTE_17,
				SM_BYTE_18,
				SM_BYTE_19,
				SM_BYTE_20,
				SM_BYTE_21,
				SM_BYTE_22,
				SM_BYTE_23,
				SM_BYTE_24,
				SM_BYTE_25,
				SM_BYTE_26,
				SM_BYTE_27,
				SM_BYTE_28,
				SM_BYTE_29,
				SM_BYTE_30,
				SM_BYTE_31,
				SM_BYTE_32,
				SM_BYTE_33,
				SM_BYTE_34,
				SM_BYTE_35,
				SM_BYTE_36,
				SM_BYTE_37,
				SM_BYTE_38,
				SM_BYTE_39,
				SM_BYTE_40,
				SM_BYTE_41,
				SM_BYTE_42,
				SM_BYTE_43,
				SM_BYTE_44,
				SM_BYTE_45,
				SM_BYTE_46,
				SM_BYTE_47,
				SM_BYTE_48,
				SM_BYTE_49,
            SM_BYTE_50,
            SM_BYTE_51,
            SM_BYTE_52,
            SM_BYTE_53,
            SM_COOLDOWN
        );
        signal SPIMACHINE_STATE : STATE_TYPE;

        constant ENTRAINMENT_0          : STD_LOGIC_VECTOR(7 downto 0) := "10101010";
        constant ENTRAINMENT_1          : STD_LOGIC_VECTOR(7 downto 0) := "11001010";
        constant ENTRAINMENT_2          : STD_LOGIC_VECTOR(7 downto 0) := "11010101";
        constant ENTRAINMENT_3          : STD_LOGIC_VECTOR(7 downto 0) := "01001010";
        constant ENTRAINMENT_4          : STD_LOGIC_VECTOR(7 downto 0) := "10101001";
        constant ENTRAINMENT_5          : STD_LOGIC_VECTOR(7 downto 0) := "10011100";
        constant ENTRAINMENT_6          : STD_LOGIC_VECTOR(7 downto 0) := "11100011";
        constant ENTRAINMENT_7          : STD_LOGIC_VECTOR(7 downto 0) := "10101111";
        constant ENTRAINMENT_8          : STD_LOGIC_VECTOR(7 downto 0) := "00101010";
        constant ENTRAINMENT_9          : STD_LOGIC_VECTOR(7 downto 0) := "00000000";
		  constant ENTRAINMENT_10         : STD_LOGIC_VECTOR(7 downto 0) := "00000000";
		  constant ENTRAINMENT_11         : STD_LOGIC_VECTOR(7 downto 0) := "00000000";
        constant INIT_TRANSFER_A        : STD_LOGIC_VECTOR(7 downto 0) := "11111111";
		  constant INIT_TRANSFER_B        : STD_LOGIC_VECTOR(7 downto 0) := "10101010";

		  signal Counter 						 : unsigned (15 downto 0) := (others => '0');
begin

        TestGeneratorProcess: process(Reset,Clk)
        begin
			if (Reset = '1') then
				SPIMACHINE_STATE <= SM_RESET;
				DATA_DATA <= (others => '0');
				DATA_VALID <= '0';	
				Counter <= (others => '0');
				
         elsif (rising_edge(Clk)) then
			
				-- Default:
				DATA_DATA <= (others => '0');
				DATA_VALID <= '0';
				Counter <= Counter;
				
				case SPIMACHINE_STATE is
					when SM_RESET =>
						SPIMACHINE_STATE <= SM_ENTRAINMENT_0;
						
					when SM_ENTRAINMENT_0 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_0;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_1;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_0;
						end if;
					
					when SM_ENTRAINMENT_1 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_1;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_2;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_1;
						end if;
						
					when SM_ENTRAINMENT_2 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_2;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_3;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_2;
						end if;
						
					when SM_ENTRAINMENT_3 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_3;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_4;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_3;
						end if;
						
					when SM_ENTRAINMENT_4 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_4;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_5;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_4;
						end if;
						
					when SM_ENTRAINMENT_5 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_5;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_6;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_5;
						end if;
						
					when SM_ENTRAINMENT_6 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_6;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_7;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_6;
						end if;
						
					when SM_ENTRAINMENT_7 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_7;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_8;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_7;
						end if;
						
					when SM_ENTRAINMENT_8 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_8;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_9;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_8;
						end if;
						
					when SM_ENTRAINMENT_9 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_9;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_10;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_9;
						end if;
						
					when SM_ENTRAINMENT_10 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_10;
						else
							SPIMACHINE_STATE <= SM_ENTRAINMENT_11;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_10;
						end if;
						
            	when SM_ENTRAINMENT_11 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ENTRAINMENT_11;
						else
							SPIMACHINE_STATE <= SM_INIT_TRANSFER_A;
							DATA_VALID <= '1';
							DATA_DATA <= ENTRAINMENT_11;
						end if;
						
            	when SM_INIT_TRANSFER_A =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_INIT_TRANSFER_A;
						else
							SPIMACHINE_STATE <= SM_INIT_TRANSFER_B;
							DATA_VALID <= '1';
							DATA_DATA <= INIT_TRANSFER_A;
						end if;
						
					when SM_INIT_TRANSFER_B =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_INIT_TRANSFER_B;
						else
							SPIMACHINE_STATE <= SM_ADDRESS;
							DATA_VALID <= '1';
							DATA_DATA <= INIT_TRANSFER_B;
						end if;
						
            	when SM_ADDRESS =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_ADDRESS;
						else
							SPIMACHINE_STATE <= SM_BYTE_01;
							DATA_VALID <= '1';
							DATA_DATA <= "00000001";
						end if;
						
					when SM_BYTE_01 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_01;
						else
							SPIMACHINE_STATE <= SM_BYTE_02;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;					
					
					when SM_BYTE_02 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_02;
						else
							SPIMACHINE_STATE <= SM_BYTE_03;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_03 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_03;
						else
							SPIMACHINE_STATE <= SM_BYTE_04;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_04 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_04;
						else
							SPIMACHINE_STATE <= SM_BYTE_05;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_05 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_05;
						else
							SPIMACHINE_STATE <= SM_BYTE_06;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
						
					when SM_BYTE_06 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_06;
						else
							SPIMACHINE_STATE <= SM_BYTE_07;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
						
					when SM_BYTE_07 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_07;
						else
							SPIMACHINE_STATE <= SM_BYTE_08;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
						
					when SM_BYTE_08 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_08;
						else
							SPIMACHINE_STATE <= SM_BYTE_09;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
						
					when SM_BYTE_09 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_09;
						else
							SPIMACHINE_STATE <= SM_BYTE_10;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
						
					when SM_BYTE_10 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_10;
						else
							SPIMACHINE_STATE <= SM_BYTE_11;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_11 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_11;
						else
							SPIMACHINE_STATE <= SM_BYTE_12;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_12 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_12;
						else
							SPIMACHINE_STATE <= SM_BYTE_13;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_13 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_13;
						else
							SPIMACHINE_STATE <= SM_BYTE_14;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_14 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_14;
						else
							SPIMACHINE_STATE <= SM_BYTE_15;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_15 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_15;
						else
							SPIMACHINE_STATE <= SM_BYTE_16;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_16 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_16;
						else
							SPIMACHINE_STATE <= SM_BYTE_17;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_17 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_17;
						else
							SPIMACHINE_STATE <= SM_BYTE_18;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_18 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_18;
						else
							SPIMACHINE_STATE <= SM_BYTE_19;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_19 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_19;
						else
							SPIMACHINE_STATE <= SM_BYTE_20;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_20 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_20;
						else
							SPIMACHINE_STATE <= SM_BYTE_21;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_21 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_21;
						else
							SPIMACHINE_STATE <= SM_BYTE_22;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_22 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_22;
						else
							SPIMACHINE_STATE <= SM_BYTE_23;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_23 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_23;
						else
							SPIMACHINE_STATE <= SM_BYTE_24;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_24 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_24;
						else
							SPIMACHINE_STATE <= SM_BYTE_25;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_25 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_25;
						else
							SPIMACHINE_STATE <= SM_BYTE_26;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_26 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_26;
						else
							SPIMACHINE_STATE <= SM_BYTE_27;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_27 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_27;
						else
							SPIMACHINE_STATE <= SM_BYTE_28;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_28 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_28;
						else
							SPIMACHINE_STATE <= SM_BYTE_29;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_29 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_29;
						else
							SPIMACHINE_STATE <= SM_BYTE_30;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_30 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_30;
						else
							SPIMACHINE_STATE <= SM_BYTE_31;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_31 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_31;
						else
							SPIMACHINE_STATE <= SM_BYTE_32;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_32 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_32;
						else
							SPIMACHINE_STATE <= SM_BYTE_33;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_33 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_33;
						else
							SPIMACHINE_STATE <= SM_BYTE_34;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_34 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_34;
						else
							SPIMACHINE_STATE <= SM_BYTE_35;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_35 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_35;
						else
							SPIMACHINE_STATE <= SM_BYTE_36;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_36 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_36;
						else
							SPIMACHINE_STATE <= SM_BYTE_37;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_37 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_37;
						else
							SPIMACHINE_STATE <= SM_BYTE_38;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_38 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_38;
						else
							SPIMACHINE_STATE <= SM_BYTE_39;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_39 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_39;
						else
							SPIMACHINE_STATE <= SM_BYTE_40;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_40 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_40;
						else
							SPIMACHINE_STATE <= SM_BYTE_41;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(7 downto 0));
						end if;
						
					when SM_BYTE_41 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_41;
						else
							SPIMACHINE_STATE <= SM_BYTE_42;
							DATA_VALID <= '1';
							DATA_DATA <= std_logic_vector(Counter(15 downto 8));
						end if;
						
					when SM_BYTE_42 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_42;
						else
							SPIMACHINE_STATE <= SM_BYTE_43;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_43 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_43;
						else
							SPIMACHINE_STATE <= SM_BYTE_44;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_44 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_44;
						else
							SPIMACHINE_STATE <= SM_BYTE_45;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_45 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_45;
						else
							SPIMACHINE_STATE <= SM_BYTE_46;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_46 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_46;
						else
							SPIMACHINE_STATE <= SM_BYTE_47;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_47 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_47;
						else
							SPIMACHINE_STATE <= SM_BYTE_48;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_48 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_48;
						else
							SPIMACHINE_STATE <= SM_BYTE_49;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
					when SM_BYTE_49 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_49;
						else
							SPIMACHINE_STATE <= SM_BYTE_50;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
            	when SM_BYTE_50 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_50;
						else
							SPIMACHINE_STATE <= SM_BYTE_51;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
            	when SM_BYTE_51 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_51;
						else
							SPIMACHINE_STATE <= SM_BYTE_52;
							DATA_VALID <= '1';
							DATA_DATA <= "11111111";
						end if;
						
            	when SM_BYTE_52 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_52;
						else
							SPIMACHINE_STATE <= SM_BYTE_53;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
						
            	when SM_BYTE_53 =>
						if STOP_GENERATOR = '1' then
							SPIMACHINE_STATE <= SM_BYTE_53;
						else
							SPIMACHINE_STATE <= SM_COOLDOWN;
							DATA_VALID <= '1';
							DATA_DATA <= "00000000";
						end if;
				
            	when SM_COOLDOWN	=>				
						SPIMACHINE_STATE <= SM_INIT_TRANSFER_A;
						Counter <= Counter + 1;
				
				end case;
			end if;
        end process TestGeneratorProcess;


end Behavioral;


