library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;

 
ENTITY Testgenerator16Bit_UUT IS
END Testgenerator16Bit_UUT;
 
ARCHITECTURE behavior OF Testgenerator16Bit_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Testgenerator16Bit
    PORT(
         STOP_GENERATOR : IN  std_logic;
         DATA_DATA : OUT  std_logic_vector(15 downto 0);
         DATA_VALID : OUT  std_logic;
         Reset : IN  std_logic;
         Clk : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal STOP_GENERATOR : std_logic := '0';
   signal Reset : std_logic := '0';
   signal Clk : std_logic := '0';

 	--Outputs
   signal DATA_DATA : std_logic_vector(15 downto 0);
   signal DATA_VALID : std_logic;

   signal MasterCounter : unsigned(127 downto 0) := (others=>'0');
	
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Testgenerator16Bit PORT MAP (
          STOP_GENERATOR => STOP_GENERATOR,
          DATA_DATA => DATA_DATA,
          DATA_VALID => DATA_VALID,
          Reset => Reset,
          Clk => Clk
        );
		  
TheMasterClock : process
	begin
    clockloop: for i in 0 to 500000 loop
        clk <= NOT clk;
        wait for 4ns;
    end loop clockloop;
    wait;
	end process TheMasterClock;



TheSecondClock : process(clk)
begin
    if rising_edge(clk) then
   
        MasterCounter <= MasterCounter + 1;
   
        if MasterCounter < to_unsigned(5,128) then
            Reset <= '1';
        else
            Reset <= '0';
        end if;

        if (MasterCounter > to_unsigned(12,128)) AND (MasterCounter < to_unsigned(50,128)) then
            STOP_GENERATOR <= '1';
        else
            STOP_GENERATOR <= '0';
        end if;


    end if;
end process TheSecondClock;

END;
