library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

 

entity AD5360_Controller is
    Port ( 
			ChannelID 	    : in STD_LOGIC_VECTOR(3 downto 0);
			Value			: in STD_LOGIC_VECTOR(15 downto 0);
			Valid			: in STD_LOGIC;
			SetMode		    : in STD_LOGIC_VECTOR(1 downto 0);
			
			StartWrite 	    : in STD_LOGIC;
			Busy_EXTERNAL   : out STD_LOGIC;
	 
	 		MOSI			: out STD_LOGIC;
			SCLK			: out STD_LOGIC;
			CS				: out STD_LOGIC;

            UpdateSwitch    : out STD_LOGIC;
            
			Clk 			: in  STD_LOGIC;
            Reset 		    : in  STD_LOGIC
			
		);
end AD5360_Controller;

architecture Behavioral of AD5360_Controller is

-- Buffer Input
	signal Buffer_00_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_01_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_02_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_03_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_04_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_05_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_06_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_07_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_08_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_09_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_10_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_11_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_12_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_13_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_14_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_15_Input : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Mode_00_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_01_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_02_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_03_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_04_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_05_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_06_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_07_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_08_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_09_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_10_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_11_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_12_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_13_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_14_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_15_Input : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	
-- Buffer Ouput
	signal Buffer_00_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_01_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_02_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_03_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_04_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_05_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_06_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_07_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_08_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_09_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_10_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_11_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_12_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_13_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_14_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Buffer_15_Output : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	signal Mode_00_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_01_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_02_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_03_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_04_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_05_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_06_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_07_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_08_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_09_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_10_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_11_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_12_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_13_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_14_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	signal Mode_15_Output : STD_LOGIC_VECTOR(1 downto 0) := (others => '0');
	
	constant Channel_Group_ID_A : STD_LOGIC_VECTOR(1 downto 0) := "01";
	constant Channel_Group_ID_B : STD_LOGIC_VECTOR(1 downto 0) := "10";
	constant A5_Bit				: STD_LOGIC := '0';
	signal Output_24BitString	: STD_LOGIC_VECTOR(23 downto 0) := (others => '0');
    signal Output_24BitString_Output	: STD_LOGIC_VECTOR(23 downto 0) := (others => '0');

	signal Output_Valid			: STD_LOGIC := '0';
	signal Output_Valid_Last	: STD_LOGIC := '0';
	signal Output_Busy			: STD_LOGIC := '0';
	
	type STATE_Type is (
		SM_RESET,
		SM_IDLE,
        SM_GPIO,
		SM_CHANNEL_00,
		SM_CHANNEL_01,
		SM_CHANNEL_02,
		SM_CHANNEL_03,
		SM_CHANNEL_04,
		SM_CHANNEL_05,
		SM_CHANNEL_06,
		SM_CHANNEL_07,
		SM_CHANNEL_08,
		SM_CHANNEL_09,
		SM_CHANNEL_10,
		SM_CHANNEL_11,
		SM_CHANNEL_12,
		SM_CHANNEL_13,
		SM_CHANNEL_14,
		SM_CHANNEL_15
	);	
	signal SPIMACHINE_STATE : STATE_TYPE;
	
	signal Busy : STD_LOGIC := '0';
    signal GPIO : STD_LOGIC := '0';
	
begin
	Busy_EXTERNAL <= Busy OR Output_Busy;
	
	MyDAC: entity work.AD5360_PHY 
    Port MAP ( 
		Value 		=> Output_24BitString_Output,
		Valid  		=> Output_Valid,
		Busy			=> Output_Busy,
		MOSI			=> MOSI,
		SCLK			=> SCLK,
		CS				=> CS,
		Reset			=> Reset,
		Clk 			=> Clk
	);

    Output_24BitString_Output <= Output_24BitString;

	-- Organize the incomming data and store it 
	StoreValues: process(Reset,Clk)
	begin
		if (Reset = '1') then
			Buffer_00_Input <= (others => '0');
			Buffer_01_Input <= (others => '0');
			Buffer_02_Input <= (others => '0');
			Buffer_03_Input <= (others => '0');
			Buffer_04_Input <= (others => '0');
			Buffer_05_Input <= (others => '0');
			Buffer_06_Input <= (others => '0');
			Buffer_07_Input <= (others => '0');
			Buffer_08_Input <= (others => '0');
			Buffer_09_Input <= (others => '0');
			Buffer_10_Input <= (others => '0');
			Buffer_11_Input <= (others => '0');
			Buffer_12_Input <= (others => '0');
			Buffer_13_Input <= (others => '0');
			Buffer_14_Input <= (others => '0');
			Buffer_15_Input <= (others => '0');
			Mode_00_Input <= (others => '0');
			Mode_01_Input <= (others => '0');
			Mode_02_Input <= (others => '0');
			Mode_03_Input <= (others => '0');
			Mode_04_Input <= (others => '0');
			Mode_05_Input <= (others => '0');
			Mode_06_Input <= (others => '0');
			Mode_07_Input <= (others => '0');
			Mode_08_Input <= (others => '0');
			Mode_09_Input <= (others => '0');
			Mode_10_Input <= (others => '0');
			Mode_11_Input <= (others => '0');
			Mode_12_Input <= (others => '0');
			Mode_13_Input <= (others => '0');
			Mode_14_Input <= (others => '0');
			Mode_15_Input <= (others => '0');
			
		elsif (rising_edge(Clk)) then
			Buffer_00_Input <= Buffer_00_Input;
			Buffer_01_Input <= Buffer_01_Input;
			Buffer_02_Input <= Buffer_02_Input;
			Buffer_03_Input <= Buffer_03_Input;
			Buffer_04_Input <= Buffer_04_Input;
			Buffer_05_Input <= Buffer_05_Input;
			Buffer_06_Input <= Buffer_06_Input;
			Buffer_07_Input <= Buffer_07_Input;
			Buffer_08_Input <= Buffer_08_Input;
			Buffer_09_Input <= Buffer_09_Input;
			Buffer_10_Input <= Buffer_10_Input;
			Buffer_11_Input <= Buffer_11_Input;
			Buffer_12_Input <= Buffer_12_Input;
			Buffer_13_Input <= Buffer_13_Input;
			Buffer_14_Input <= Buffer_14_Input;
			Buffer_15_Input <= Buffer_15_Input;
			Mode_00_Input <= Mode_00_Input;
			Mode_01_Input <= Mode_01_Input;
			Mode_02_Input <= Mode_02_Input;
			Mode_03_Input <= Mode_03_Input;
			Mode_04_Input <= Mode_04_Input;
			Mode_05_Input <= Mode_05_Input;
			Mode_06_Input <= Mode_06_Input;
			Mode_07_Input <= Mode_07_Input;
			Mode_08_Input <= Mode_08_Input;
			Mode_09_Input <= Mode_09_Input;
			Mode_10_Input <= Mode_10_Input;
			Mode_11_Input <= Mode_11_Input;
			Mode_12_Input <= Mode_12_Input;
			Mode_13_Input <= Mode_13_Input;
			Mode_14_Input <= Mode_14_Input;
			Mode_15_Input <= Mode_15_Input;
			
			case ChannelID is
				when "0000" => 
					if Valid = '1' then
						Buffer_00_Input <= Value;
						Mode_00_Input <= SetMode;
					else
						null;
					end if;
					
				when "0001" =>	
					if Valid = '1' then
						Buffer_01_Input <= Value;
						Mode_01_Input <= SetMode;
					else
						null;
					end if;
					
				when "0010" =>	
					if Valid = '1' then
						Buffer_02_Input <= Value;
						Mode_02_Input <= SetMode;
					else
						null;
					end if;
					
				when "0011" =>	
					if Valid = '1' then
						Buffer_03_Input <= Value;
						Mode_03_Input <= SetMode;
					else
						null;
					end if;
					
				when "0100" =>	
					if Valid = '1' then
						Buffer_04_Input <= Value;
						Mode_04_Input <= SetMode;
					else
						null;
					end if;
				
				when "0101" =>				
					if Valid = '1' then	
						Buffer_05_Input <= Value;
						Mode_05_Input <= SetMode;
					else
						null;
					end if;
				
				when "0110" =>
					if Valid = '1' then
						Buffer_06_Input <= Value;
						Mode_06_Input <= SetMode;
					else
						null;
					end if;
					
				when "0111" =>	
					if Valid = '1' then
						Buffer_07_Input <= Value;
						Mode_07_Input <= SetMode;
					else
						null;
					end if;

				when "1000" =>
					if Valid = '1' then
						Buffer_08_Input <= Value;
						Mode_08_Input <= SetMode;
					else
						null;
					end if;
					
				when "1001" =>	
					if Valid = '1' then
						Buffer_09_Input <= Value;
						Mode_09_Input <= SetMode;
					else
						null;
					end if;
					
				when "1010" =>	
					if Valid = '1' then
						Buffer_10_Input <= Value;
						Mode_10_Input <= SetMode;
					else
						null;
					end if;
					
				when "1011" =>	
					if Valid = '1' then
						Buffer_11_Input <= Value;
						Mode_11_Input <= SetMode;
					else
						null;
					end if;
					
				when "1100" =>	
					if Valid = '1' then	
						Buffer_12_Input <= Value;
						Mode_12_Input <= SetMode;
					else
						null;
					end if;
					
				when "1101" =>	
					if Valid = '1' then
						Buffer_13_Input <= Value;
						Mode_13_Input <= SetMode;
					else
						null;
					end if;
					
				when "1110" =>	
					if Valid = '1' then
						Buffer_14_Input <= Value;
						Mode_14_Input <= SetMode;
					else
						null;
					end if;
					
				when "1111" =>	
					if Valid = '1' then
						Buffer_15_Input <= Value;	
						Mode_15_Input <= SetMode;						
					else
						null;
					end if;
				
				when others =>
					null;
			end case;
			
		end if;
	end process StoreValues;

	-- FSM for writing all 16 values to the device 
	WriteValues: process(Reset,Clk)
	begin
		if (Reset = '1') then
            SPIMACHINE_STATE <= SM_RESET;
			Buffer_00_Output <= (others => '0');
			Buffer_01_Output <= (others => '0');
			Buffer_02_Output <= (others => '0');
			Buffer_03_Output <= (others => '0');
			Buffer_04_Output <= (others => '0');
			Buffer_05_Output <= (others => '0');
			Buffer_06_Output <= (others => '0');
			Buffer_07_Output <= (others => '0');
			Buffer_08_Output <= (others => '0');
			Buffer_09_Output <= (others => '0');
			Buffer_10_Output <= (others => '0');
			Buffer_11_Output <= (others => '0');
			Buffer_12_Output <= (others => '0');
			Buffer_13_Output <= (others => '0');
			Buffer_14_Output <= (others => '0');
			Buffer_15_Output <= (others => '0');
			Mode_00_Output <= (others => '0');
			Mode_01_Output <= (others => '0');
			Mode_02_Output <= (others => '0');
			Mode_03_Output <= (others => '0');
			Mode_04_Output <= (others => '0');
			Mode_05_Output <= (others => '0');
			Mode_06_Output <= (others => '0');
			Mode_07_Output <= (others => '0');
			Mode_08_Output <= (others => '0');
			Mode_09_Output <= (others => '0');
			Mode_10_Output <= (others => '0');
			Mode_11_Output <= (others => '0');
			Mode_12_Output <= (others => '0');
			Mode_13_Output <= (others => '0');
			Mode_14_Output <= (others => '0');
			Mode_15_Output <= (others => '0');
			Output_Valid <= '0';
			Output_Valid_Last <= '0';
			Busy <= '1';
			Output_24BitString <= (others => '0');
            GPIO <= '0';
            UpdateSwitch <= '0';
			
		elsif (rising_edge(Clk)) then
			SPIMACHINE_STATE <= SM_RESET;
			Buffer_00_Output <= Buffer_00_Output;
			Buffer_01_Output <= Buffer_01_Output;
			Buffer_02_Output <= Buffer_02_Output;
			Buffer_03_Output <= Buffer_03_Output;
			Buffer_04_Output <= Buffer_04_Output;
			Buffer_05_Output <= Buffer_05_Output;
			Buffer_06_Output <= Buffer_06_Output;
			Buffer_07_Output <= Buffer_07_Output;
			Buffer_08_Output <= Buffer_08_Output;
			Buffer_09_Output <= Buffer_09_Output;
			Buffer_10_Output <= Buffer_10_Output;
			Buffer_11_Output <= Buffer_11_Output;
			Buffer_12_Output <= Buffer_12_Output;
			Buffer_13_Output <= Buffer_13_Output;
			Buffer_14_Output <= Buffer_14_Output;
			Buffer_15_Output <= Buffer_15_Output;
			Mode_00_Output <= Mode_00_Output;
			Mode_01_Output <= Mode_01_Output;
			Mode_02_Output <= Mode_02_Output;
			Mode_03_Output <= Mode_03_Output;
			Mode_04_Output <= Mode_04_Output;
			Mode_05_Output <= Mode_05_Output;
			Mode_06_Output <= Mode_06_Output;
			Mode_07_Output <= Mode_07_Output;
			Mode_08_Output <= Mode_08_Output;
			Mode_09_Output <= Mode_09_Output;
			Mode_10_Output <= Mode_10_Output;
			Mode_11_Output <= Mode_11_Output;
			Mode_12_Output <= Mode_12_Output;
			Mode_13_Output <= Mode_13_Output;
			Mode_14_Output <= Mode_14_Output;
			Mode_15_Output <= Mode_15_Output;
			Output_Valid <= '0';
			Busy <= '1';
			Output_24BitString <= Output_24BitString;
			
			Output_Valid_Last <= Output_Valid;
			GPIO <= GPIO;
            UpdateSwitch <= '0';
			
			case SPIMACHINE_STATE is
				when SM_RESET =>
					SPIMACHINE_STATE <= SM_IDLE;
               
				when SM_IDLE =>
					if (StartWrite = '1') then
						SPIMACHINE_STATE <= SM_GPIO;
                        UpdateSwitch <= '1';
					else
						SPIMACHINE_STATE <= SM_IDLE;
						Busy <= '0';
					end if;

					Buffer_00_Output <= Buffer_00_Input;
					Buffer_01_Output <= Buffer_01_Input;
					Buffer_02_Output <= Buffer_02_Input;
					Buffer_03_Output <= Buffer_03_Input;
					Buffer_04_Output <= Buffer_04_Input;
					Buffer_05_Output <= Buffer_05_Input;
					Buffer_06_Output <= Buffer_06_Input;
					Buffer_07_Output <= Buffer_07_Input;
					Buffer_08_Output <= Buffer_08_Input;
					Buffer_09_Output <= Buffer_09_Input;
					Buffer_10_Output <= Buffer_10_Input;
					Buffer_11_Output <= Buffer_11_Input;
					Buffer_12_Output <= Buffer_12_Input;
					Buffer_13_Output <= Buffer_13_Input;
					Buffer_14_Output <= Buffer_14_Input;
					Buffer_15_Output <= Buffer_15_Input;
					Mode_00_Output <= Mode_00_Input;
					Mode_01_Output <= Mode_01_Input;
					Mode_02_Output <= Mode_02_Input;
					Mode_03_Output <= Mode_03_Input;
					Mode_04_Output <= Mode_04_Input;
					Mode_05_Output <= Mode_05_Input;
					Mode_06_Output <= Mode_06_Input;
					Mode_07_Output <= Mode_07_Input;
					Mode_08_Output <= Mode_08_Input;
					Mode_09_Output <= Mode_09_Input;
					Mode_10_Output <= Mode_10_Input;
					Mode_11_Output <= Mode_11_Input;
					Mode_12_Output <= Mode_12_Input;
					Mode_13_Output <= Mode_13_Input;
					Mode_14_Output <= Mode_14_Input;
					Mode_15_Output <= Mode_15_Input;
				
                when SM_GPIO => 
                    if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then
                        Output_24BitString <= "00" & "001101" & "00000000000000" & "1" & GPIO;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_00;
                        GPIO <= NOT GPIO;
					else
						SPIMACHINE_STATE <= SM_GPIO;
					end if;

				when SM_CHANNEL_00 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then
						Output_24BitString <= Mode_00_Output & A5_Bit & Channel_Group_ID_A & "000" & Buffer_00_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_01;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_00;
					end if;


				when SM_CHANNEL_01 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_01_Output & A5_Bit & Channel_Group_ID_A & "001" & Buffer_01_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_02;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_01;
					end if;
										
				when SM_CHANNEL_02 =>				
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_02_Output & A5_Bit & Channel_Group_ID_A & "010" & Buffer_02_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_03;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_02;
					end if;
										
				when SM_CHANNEL_03 =>	
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_03_Output & A5_Bit & Channel_Group_ID_A & "011" & Buffer_03_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_04;
 					else
						SPIMACHINE_STATE <= SM_CHANNEL_03;
					end if;
										
				when SM_CHANNEL_04 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_04_Output & A5_Bit & Channel_Group_ID_A & "100" & Buffer_04_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_05;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_04;
					end if;
										--
				when sm_channel_05 =>
					if (output_busy = '0') and (output_valid = '0') and (output_valid_last = '0') then				
						output_24bitstring <= mode_05_output & a5_bit & channel_group_id_a & "101" & buffer_05_output;
						output_valid <= '1';
						spimachine_state <= sm_channel_06;
					else
						spimachine_state <= sm_channel_05;
					end if;
										
				when sm_channel_06 =>
					if (output_busy = '0') and (output_valid = '0') and (output_valid_last = '0') then				
						output_24bitstring <= mode_06_output & a5_bit & channel_group_id_a & "110" & buffer_06_output;
						output_valid <= '1';
						spimachine_state <= sm_channel_07;
					else
						spimachine_state <= sm_channel_06;
					end if;
										
				when sm_channel_07 =>
					if (output_busy = '0') and (output_valid = '0') and (output_valid_last = '0') then				
						output_24bitstring <= mode_07_output & a5_bit & channel_group_id_a & "111" & buffer_07_output;
						output_valid <= '1';
						spimachine_state <= sm_channel_08;
					else
						spimachine_state <= sm_channel_07;
					end if;
										--
				when SM_CHANNEL_08 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_08_Output & A5_Bit & Channel_Group_ID_B & "000" & Buffer_08_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_09;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_08;
					end if;
										
				when SM_CHANNEL_09 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then
						Output_24BitString <= Mode_09_Output & A5_Bit & Channel_Group_ID_B & "001" & Buffer_09_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_10;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_09;
					end if;
										--
				when SM_CHANNEL_10 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_10_Output & A5_Bit & Channel_Group_ID_B & "010" & Buffer_10_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_11;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_10;
					end if;
										
				when SM_CHANNEL_11 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_11_Output & A5_Bit & Channel_Group_ID_B & "011" & Buffer_11_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_12;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_11;
					end if;
										
				when SM_CHANNEL_12 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_12_Output & A5_Bit & Channel_Group_ID_B & "100" & Buffer_12_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_13;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_12;
					end if;
										--
				when SM_CHANNEL_13 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_13_Output & A5_Bit & Channel_Group_ID_B & "101" & Buffer_13_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_14;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_13;
					end if;
										
				when SM_CHANNEL_14 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_14_Output & A5_Bit & Channel_Group_ID_B & "110" & Buffer_14_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_CHANNEL_15;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_14;
					end if;
										
				when SM_CHANNEL_15 =>
					if (Output_Busy = '0') AND (Output_Valid = '0') AND (Output_Valid_Last = '0') then				
						Output_24BitString <= Mode_15_Output & A5_Bit & Channel_Group_ID_B & "111" & Buffer_15_Output;
						Output_Valid <= '1';
						SPIMACHINE_STATE <= SM_IDLE;
					else
						SPIMACHINE_STATE <= SM_CHANNEL_15;
					end if;
										
				--when others =>
					--SPIMACHINE_STATE <= SM_RESET;
			end case;
		end if;
	end process WriteValues;		

end Behavioral;

