-- Byte 01:
-- Mode_00_Input <= INPUT_VALUE(1 downto 0);
-- Mode_01_Input <= INPUT_VALUE(3 downto 2);
-- Mode_02_Input <= INPUT_VALUE(5 downto 4);
-- Mode_03_Input <= INPUT_VALUE(7 downto 6);
-- Byte 02:
-- Mode_04_Input <= INPUT_VALUE(1 downto 0);
-- Mode_05_Input <= INPUT_VALUE(3 downto 2);
-- Mode_06_Input <= INPUT_VALUE(5 downto 4);
-- Mode_07_Input <= INPUT_VALUE(7 downto 6);
-- Byte 03:
-- Mode_08_Input <= INPUT_VALUE(1 downto 0);
-- Mode_09_Input <= INPUT_VALUE(3 downto 2);
-- Mode_10_Input <= INPUT_VALUE(5 downto 4);
-- Mode_11_Input <= INPUT_VALUE(7 downto 6);
-- Byte 04:
-- Mode_12_Input <= INPUT_VALUE(1 downto 0);
-- Mode_13_Input <= INPUT_VALUE(3 downto 2);
-- Mode_14_Input <= INPUT_VALUE(5 downto 4);
-- Mode_15_Input <= INPUT_VALUE(7 downto 6);
-- Byte 05: PauseCounter_INTERNAL(7 downto 0) <= INPUT_VALUE;
-- Byte 06: PauseCounter_INTERNAL(15 downto 8) <= INPUT_VALUE;
-- Byte 07: PauseCounter_INTERNAL(23 downto 16) <= INPUT_VALUE;
-- Byte 08: PauseCounter_INTERNAL(31 downto 24) <= INPUT_VALUE;
-- Byte 09: PauseCounter_INTERNAL(39 downto 32) <= INPUT_VALUE;
-- Byte10: Value00[7:0]
-- Byte11: Value00[15:8]
-- Byte12: Value01[7:0]
-- Byte13: Value01[15:8]
-- Byte14: Value02[7:0]
-- Byte15: Value02[15:8]
-- Byte16: Value03[7:0]
-- Byte17: Value03[15:8]
-- Byte18: Value04[7:0]
-- Byte19: Value04[15:8]
-- Byte20: Value05[7:0]
-- Byte21: Value05[15:8]
-- Byte22: Value06[7:0]
-- Byte23: Value06[15:8]
-- Byte24: Value07[7:0]
-- Byte25: Value07[15:8]
-- Byte26: Value08[7:0]
-- Byte27: Value08[15:8]
-- Byte28: Value09[7:0]
-- Byte29: Value09[15:8]
-- Byte30: Value10[7:0]
-- Byte31: Value10[15:8]
-- Byte32: Value11[7:0]
-- Byte33: Value11[15:8]
-- Byte34: Value12[7:0]
-- Byte35: Value12[15:8]
-- Byte36: Value13[7:0]
-- Byte37: Value13[15:8]
-- Byte38: Value14[7:0]
-- Byte39: Value14[15:8]
-- Byte40: Value15[7:0]
-- Byte41: Value15[15:8]
-- Byte42: SwitchA[7:0]
-- Byte43: SwitchA[15:8]
-- Byte44: SwitchB[7:0]
-- Byte45: SwitchB[15:8]
-- Byte46: SwitchC[7:0]
-- Byte47: SwitchC[15:8]
-- Byte48: SwitchD[7:0]
-- Byte49: SwitchD[15:8]
----------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity TestPackageGenerator is
    Port ( 
	 
            INPUT_FULL        				    : in STD_LOGIC;
			INPUT_DATA         				    : out  STD_LOGIC_VECTOR(8 downto 0);
			INPUT_DATA_VALID    				: out  STD_LOGIC;

			CLK									: in  STD_LOGIC;
			Reset 								: in  STD_LOGIC
		);
end TestPackageGenerator;

architecture Behavioral of TestPackageGenerator is

	type STATE_Type is (
			SM_RESET,
			SM_BYTE_01,
			SM_BYTE_02,
			SM_BYTE_03,
			SM_BYTE_04,
			SM_BYTE_05,
			SM_BYTE_06,
			SM_BYTE_07,
			SM_BYTE_08,
			SM_BYTE_09,
			SM_BYTE_10,
			SM_BYTE_11,
			SM_BYTE_12,
			SM_BYTE_13,
			SM_BYTE_14,
			SM_BYTE_15,
			SM_BYTE_16,
			SM_BYTE_17,
			SM_BYTE_18,
			SM_BYTE_19,
			SM_BYTE_20,
			SM_BYTE_21,
			SM_BYTE_22,
			SM_BYTE_23,
			SM_BYTE_24,
			SM_BYTE_25,
			SM_BYTE_26,
			SM_BYTE_27,
			SM_BYTE_28,
			SM_BYTE_29,
			SM_BYTE_30,
			SM_BYTE_31,
			SM_BYTE_32,
			SM_BYTE_33,
			SM_BYTE_34,
			SM_BYTE_35,
			SM_BYTE_36,
			SM_BYTE_37,
			SM_BYTE_38,
			SM_BYTE_39,
			SM_BYTE_40,
			SM_BYTE_41,
			SM_BYTE_42,
			SM_BYTE_43,
			SM_BYTE_44,
			SM_BYTE_45,
			SM_BYTE_46,
			SM_BYTE_47,
			SM_BYTE_48,
			SM_BYTE_49,
			SM_COOLDOWN			
	);	
	signal SPIMACHINE_STATE : STATE_TYPE;	
	constant ModeSetting : STD_LOGIC_VECTOR(1 downto 0) := "11";
	constant TimerSetting : STD_LOGIC_VECTOR(39 downto 0) := "0000000000" & 
																				"0000000000" & 
																				"0000000000" & 
																				"0000000000" ;
	signal Counter : unsigned(15 downto 0) := (others => '0');
	signal Counter_STD : STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
	
	constant SWITCH_A : STD_LOGIC_VECTOR(15 downto 0) := "10101111" & "10000110";
	constant SWITCH_B : STD_LOGIC_VECTOR(15 downto 0) := "00101010" & "11010100";
	constant SWITCH_C : STD_LOGIC_VECTOR(15 downto 0) := "11001010" & "11000110";
	constant SWITCH_D : STD_LOGIC_VECTOR(15 downto 0) := "00001111" & "00011101";
	
begin
	 Counter_STD <= STD_LOGIC_VECTOR(Counter);
	 
    TESTGENERATOR : process(Reset,CLK)
    begin
        if (Reset = '1') then

            SPIMACHINE_STATE <= SM_RESET;
				INPUT_DATA_VALID <= '0';
				INPUT_DATA <= (others => '0');
				Counter <= (others => '0');
				
        elsif (rising_edge(CLK)) then
            -- DEFAULT:
            SPIMACHINE_STATE <= SM_RESET;
				INPUT_DATA_VALID <= '0';
				INPUT_DATA <= (others => '0');
				Counter <= Counter;
				
            case SPIMACHINE_STATE is
					when SM_RESET => 
						SPIMACHINE_STATE <= SM_BYTE_01;
						
					when SM_BYTE_01 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_01;
						else
							SPIMACHINE_STATE <= SM_BYTE_02;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "1" & ModeSetting & ModeSetting & ModeSetting & ModeSetting;
						
					when SM_BYTE_02 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_02;
						else
							SPIMACHINE_STATE <= SM_BYTE_03;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & ModeSetting & ModeSetting & ModeSetting & ModeSetting;
						
					when SM_BYTE_03 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_03;
						else
							SPIMACHINE_STATE <= SM_BYTE_04;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & ModeSetting & ModeSetting & ModeSetting & ModeSetting;
						
					when SM_BYTE_04 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_04;
						else
							SPIMACHINE_STATE <= SM_BYTE_05;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & ModeSetting & ModeSetting & ModeSetting & ModeSetting;
						
					when SM_BYTE_05 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_05;
						else
							SPIMACHINE_STATE <= SM_BYTE_06;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & TimerSetting(7 downto 0);
						
					when SM_BYTE_06 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_06;
						else
							SPIMACHINE_STATE <= SM_BYTE_07;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & TimerSetting(15 downto 8);
						
					when SM_BYTE_07 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_07;
						else
							SPIMACHINE_STATE <= SM_BYTE_08;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & TimerSetting(23 downto 16);
						
					when SM_BYTE_08 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_08;
						else
							SPIMACHINE_STATE <= SM_BYTE_09;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & TimerSetting(31 downto 24);
						
					when SM_BYTE_09 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_09;
						else
							SPIMACHINE_STATE <= SM_BYTE_10;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & TimerSetting(39 downto 32);
					
					--------
					
					when SM_BYTE_10 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_10;
						else
							SPIMACHINE_STATE <= SM_BYTE_11;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_11 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_11;
						else
							SPIMACHINE_STATE <= SM_BYTE_12;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_12 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_12;
						else
							SPIMACHINE_STATE <= SM_BYTE_13;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_13 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_13;
						else
							SPIMACHINE_STATE <= SM_BYTE_14;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_14 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_14;
						else
							SPIMACHINE_STATE <= SM_BYTE_15;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_15 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_15;
						else
							SPIMACHINE_STATE <= SM_BYTE_16;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_16 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_16;
						else
							SPIMACHINE_STATE <= SM_BYTE_17;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_17 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_17;
						else
							SPIMACHINE_STATE <= SM_BYTE_18;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_18 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_18;
						else
							SPIMACHINE_STATE <= SM_BYTE_19;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_19 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_19;
						else
							SPIMACHINE_STATE <= SM_BYTE_20;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_20 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_20;
						else
							SPIMACHINE_STATE <= SM_BYTE_21;
							INPUT_DATA_VALID <= '1';
						end if;					
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
					
					when SM_BYTE_21 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_21;
						else
							SPIMACHINE_STATE <= SM_BYTE_22;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_22 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_22;
						else
							SPIMACHINE_STATE <= SM_BYTE_23;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_23 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_23;
						else
							SPIMACHINE_STATE <= SM_BYTE_24;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_24 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_24;
						else
							SPIMACHINE_STATE <= SM_BYTE_25;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_25 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_25;
						else
							SPIMACHINE_STATE <= SM_BYTE_26;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_26 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_26;
						else
							SPIMACHINE_STATE <= SM_BYTE_27;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_27 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_27;
						else
							SPIMACHINE_STATE <= SM_BYTE_28;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_28 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_28;
						else
							SPIMACHINE_STATE <= SM_BYTE_29;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_29 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_29;
						else
							SPIMACHINE_STATE <= SM_BYTE_30;
							INPUT_DATA_VALID <= '1';
						end if;					
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
					
					when SM_BYTE_30 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_30;
						else
							SPIMACHINE_STATE <= SM_BYTE_31;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_31 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_31;
						else
							SPIMACHINE_STATE <= SM_BYTE_32;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
					
					when SM_BYTE_32 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_32;
						else
							SPIMACHINE_STATE <= SM_BYTE_33;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_33 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_33;
						else
							SPIMACHINE_STATE <= SM_BYTE_34;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_34 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_34;
						else
							SPIMACHINE_STATE <= SM_BYTE_35;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_35 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_35;
						else
							SPIMACHINE_STATE <= SM_BYTE_36;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_36 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_36;
						else
							SPIMACHINE_STATE <= SM_BYTE_37;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_37 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_37;
						else
							SPIMACHINE_STATE <= SM_BYTE_38;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_38 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_38;
						else
							SPIMACHINE_STATE <= SM_BYTE_39;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_39 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_39;
						else
							SPIMACHINE_STATE <= SM_BYTE_40;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_40 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_40;
						else
							SPIMACHINE_STATE <= SM_BYTE_41;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(7 downto 0);
						
					when SM_BYTE_41 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_41;
						else
							SPIMACHINE_STATE <= SM_BYTE_42;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & Counter_STD(15 downto 8);
						
					when SM_BYTE_42 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_42;
						else
							SPIMACHINE_STATE <= SM_BYTE_43;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_A(7 downto 0);
						
						
					when SM_BYTE_43 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_43;
						else
							SPIMACHINE_STATE <= SM_BYTE_44;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_A(15 downto 8);
						
					when SM_BYTE_44 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_44;
						else
							SPIMACHINE_STATE <= SM_BYTE_45;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_B(7 downto 0);
						
					when SM_BYTE_45 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_45;
						else
							SPIMACHINE_STATE <= SM_BYTE_46;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_B(15 downto 8);
						
					when SM_BYTE_46 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_46;
						else
							SPIMACHINE_STATE <= SM_BYTE_47;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_C(7 downto 0);
						
					when SM_BYTE_47 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_47;
						else
							SPIMACHINE_STATE <= SM_BYTE_48;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_C(15 downto 8);
						
					when SM_BYTE_48 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_48;
						else
							SPIMACHINE_STATE <= SM_BYTE_49;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_D(7 downto 0);
						
					when SM_BYTE_49 => 
						if INPUT_FULL = '1' then
							SPIMACHINE_STATE <= SM_BYTE_49;
						else
							SPIMACHINE_STATE <= SM_COOLDOWN;
							INPUT_DATA_VALID <= '1';
						end if;
						INPUT_DATA <= "0" & SWITCH_D(15 downto 8);
						
					when SM_COOLDOWN => 					
						SPIMACHINE_STATE <= SM_BYTE_01;
						Counter <= Counter + 1;

                --when others => 
                    --SPIMACHINE_STATE <= SM_RESET;
             end case;

        end if;
        
    end process TESTGENERATOR;


end Behavioral;

