library IEEE;
library UNISIM;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use UNISIM.VComponents.all;
 
ENTITY FIFO_UUT IS
END FIFO_UUT;
 
ARCHITECTURE behavior OF FIFO_UUT IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT FIFO
    PORT(
         rst : IN  std_logic;
         wr_clk : IN  std_logic;
         rd_clk : IN  std_logic;
         din : IN  std_logic_vector(7 downto 0);
         wr_en : IN  std_logic;
         rd_en : IN  std_logic;
         dout : OUT  std_logic_vector(7 downto 0);
         full : OUT  std_logic;
         empty : OUT  std_logic;
         prog_full : OUT  std_logic;
         prog_empty : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal rst : std_logic := '0';
   signal wr_clk : std_logic := '0';
   signal rd_clk : std_logic := '0';
   signal din : std_logic_vector(7 downto 0) := (others => '0');
   signal wr_en : std_logic := '0';
   signal rd_en : std_logic := '0';

 	--Outputs
   signal dout : std_logic_vector(7 downto 0);
   signal full : std_logic;
   signal empty : std_logic;
   signal prog_full : std_logic;
   signal prog_empty : std_logic;

   signal Clk : std_logic := '0';
	signal Reset : std_logic := '0';
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0');
BEGIN

TheMasterClock : process
begin
	clockloop: for i in 0 to 200000 loop
		Clk <= NOT Clk;
		wait for 21ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 
 
	-- Instantiate the Unit Under Test (UUT)
   uut: FIFO PORT MAP (
          rst => Reset,
          wr_clk => Clk,
          rd_clk => Clk,
          din => din,
          wr_en => wr_en,
          rd_en => rd_en,
          dout => dout,
          full => full,
          empty => empty,
          prog_full => prog_full,
          prog_empty => prog_empty
        );

TheSecondClock : process(Clk)
begin
	if rising_edge(Clk) then

		if MasterCounter < to_unsigned(20,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;
		
		if MasterCounter = to_unsigned(30,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(31,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(32,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(33,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(34,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(35,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(36,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(37,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(38,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(39,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(40,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(41,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(42,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(43,128) then
			din <= (others => '1');
			wr_en <= '1';
		elsif MasterCounter = to_unsigned(70,128) then
			din <= (others => '1');
			wr_en <= '1';			
		else
			din <= (others => '0');
			wr_en <= '0';
		end if;

		if MasterCounter = to_unsigned(60,128) then
			rd_en <= '1';
		elsif MasterCounter = to_unsigned(25,128) then
			rd_en <= '1';
		else
			rd_en <= '0';
		end if;
		
	MasterCounter <= MasterCounter + 1;
	
	end if;	
end process TheSecondClock;

END;
