

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity IGLOO_TOP_UUT is
end IGLOO_TOP_UUT;

architecture BEHAVIOURAL of IGLOO_TOP_UUT is
    signal GPIO                 : STD_LOGIC := '0';
    signal NOT_BUSY             : STD_LOGIC := '0';
	signal NOT_BIN			    : STD_LOGIC := '0';

    signal MISO                 : STD_LOGIC := '0';
	signal NOT_LDAC 	        : STD_LOGIC := '0';
	signal NOT_CLR			    : STD_LOGIC := '0';
	signal NOT_RESET_DAC	    : STD_LOGIC := '0';
   
    signal NOT_PEC              : STD_LOGIC := '0';
	signal MOSI			        : STD_LOGIC := '0';
	signal SCLK			        : STD_LOGIC := '0';
	signal CS				    : STD_LOGIC := '0';

	signal NOT_OD 		        : STD_LOGIC := '0';


------------
    signal DEBUG_GPIO           : STD_LOGIC := '0';
    signal DEBUG_NOT_BUSY       : STD_LOGIC := '0';
    signal DEBUG_NOT_BIN        : STD_LOGIC := '0';

    signal DEBUG_MISO           : STD_LOGIC := '0';
    signal DEBUG_NOT_LDAC       : STD_LOGIC := '0';
    signal DEBUG_NOT_CLR        : STD_LOGIC := '0';
    signal DEBUG_NOT_RESET_DAC  : STD_LOGIC := '0';

    signal DEBUG_NOT_PEC        : STD_LOGIC := '0';
    signal DEBUG_MOSI           : STD_LOGIC := '0';
    signal DEBUG_SCLK           : STD_LOGIC := '0';
    signal DEBUG_CS             : STD_LOGIC := '0';

    signal Reset                : STD_LOGIC := '0';
    signal Clk                  : STD_LOGIC := '0';


    signal Counter : unsigned(10 downto 0) := (others=>'0'); 
	signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 
begin

UUT : entity work.IGLOO_TOP
  port MAP (


    GPIO                => GPIO,
    NOT_BUSY            => NOT_BUSY,
	NOT_BIN			    => NOT_BIN,

    MISO                => MISO,
	NOT_LDAC 	        => NOT_LDAC,
	NOT_CLR			    => NOT_CLR,
	NOT_RESET_DAC	    => NOT_RESET_DAC,
   
    NOT_PEC             => NOT_PEC,
	MOSI			    => MOSI,
	SCLK			    => SCLK,
	CS				    => CS,

	NOT_OD 		        => NOT_OD,


------------
    DEBUG_GPIO          => DEBUG_GPIO,
    DEBUG_NOT_BUSY      => DEBUG_NOT_BUSY,
    DEBUG_NOT_BIN       => DEBUG_NOT_BIN,

    DEBUG_MISO          => DEBUG_MISO,
    DEBUG_NOT_LDAC      => DEBUG_NOT_LDAC,
    DEBUG_NOT_CLR       => DEBUG_NOT_CLR,
    DEBUG_NOT_RESET_DAC => DEBUG_NOT_RESET_DAC,

    DEBUG_NOT_PEC       => DEBUG_NOT_PEC,
    DEBUG_MOSI          => DEBUG_MOSI,
    DEBUG_SCLK          => DEBUG_SCLK,
    DEBUG_CS            => DEBUG_CS,

    Reset               => Reset,
    Clk                 => Clk
);

 TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 20ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 

Stimulus : process(clk) 
begin
	if rising_edge(clk) then
		

		MasterCounter <= MasterCounter + 1;
		
		if MasterCounter < to_unsigned(5,128) then
			Reset <= '0';
		else
			Reset <= '1';
		end if;


	end if;
end process Stimulus;

end;
