library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity USB_Interface_UUT is
end USB_Interface_UUT;

architecture BEHAVIOURAL of USB_Interface_UUT is

        signal USB_DATA            : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
        signal USB_NOT_RXF         : STD_LOGIC := '0';
        signal USB_NOT_TXE         : STD_LOGIC := '0';
        signal USB_NOT_RD          : STD_LOGIC := '0';
        signal USB_NOT_WR          : STD_LOGIC := '0';
        signal USB_NOT_POWERSAVE   : STD_LOGIC := '0';
        signal USB_WAKEUP          : STD_LOGIC := '0';

        -- From USB to the FPGA
        signal FROM_USB_DATA       : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
        signal FROM_USB_READEN     : STD_LOGIC := '0';
        signal FROM_USB_VALID      : STD_LOGIC := '0';

        -- From FPGA to USB
        signal TO_USB_DATA         : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
        signal TO_USB_WRITEEN      : STD_LOGIC := '0';
        signal TO_USB_FULL         : STD_LOGIC := '0';

        signal Reset               : STD_LOGIC := '0';
        
        signal Clk    : std_logic := '0';
        signal MasterCounter : unsigned(127 downto 0) := (others=>'0'); 

begin

    MyUSB_Interface: entity work.USB_Interface
    port MAP (
        USB_DATA                                    => USB_DATA,
        USB_NOT_RXF                                 => USB_NOT_RXF,
        USB_NOT_TXE                                 => USB_NOT_TXE,
        USB_NOT_RD                                  => USB_NOT_RD,
        USB_NOT_WR                                  => USB_NOT_WR,
        USB_NOT_POWERSAVE                           => USB_NOT_POWERSAVE,
        USB_WAKEUP                                  => USB_WAKEUP,

        -- From USB to the FPGA
        FROM_USB_DATA                               => FROM_USB_DATA,
        FROM_USB_READEN                             => FROM_USB_READEN,
        FROM_USB_VALID                              => FROM_USB_VALID,   

        -- From FPGA to USB
        TO_USB_DATA                                 => TO_USB_DATA,     
        TO_USB_WRITEEN                              => TO_USB_WRITEEN,
        TO_USB_FULL                                 => TO_USB_FULL,
        Clk                                         => Clk,
        Reset                                       => Reset
    );


 TheMasterClock : process
begin
	clockloop: for i in 0 to 25000 loop
		clk <= NOT clk;
		wait for 8ns;
	end loop clockloop;
	wait;
end process TheMasterClock; 

Stimulus : process(clk) 
begin
	if rising_edge(clk) then

		MasterCounter <= MasterCounter + 1;
        USB_NOT_RXF <= '1';
        
        
        USB_NOT_TXE <= '1';

		if MasterCounter < to_unsigned(5,128) then
			Reset <= '1';
		else
			Reset <= '0';
		end if;

        --TO_USB_WRITEEN <= '0';
        --FROM_USB_READEN <= '0';
        ---- Test 1: Write to USB module 
        --TO_USB_DATA <= STD_LOGIC_VECTOR(MasterCounter(7 downto 0));
		--if MasterCounter < to_unsigned(20,128) then
			--TO_USB_WRITEEN <= '0';
		--else
			--TO_USB_WRITEEN <= NOT TO_USB_FULL;
		--end if;
--
		--if (MasterCounter > to_unsigned(100,128)) AND (MasterCounter < to_unsigned(300,128)) then
            --USB_NOT_TXE <= '0';
		--elsif (MasterCounter > to_unsigned(320,128)) AND (MasterCounter < to_unsigned(350,128)) then
            --USB_NOT_TXE <= '0';
        --else
            --USB_NOT_TXE <= '1';
        --end if;

--        USB_DATA <= "11110000";
--        USB_NOT_RXF <= '0';
        



	end if;
end process Stimulus;

end;
