-- Version: v11.5 SP3 11.5.3.10
-- File used only for Simulation

library ieee;
use ieee.std_logic_1164.all;
library igloo;
use igloo.all;

entity IGLOO_TOP is

    port( GPIO                : in    std_logic;
          NOT_BUSY            : in    std_logic;
          NOT_BIN             : out   std_logic;
          MISO                : in    std_logic;
          NOT_LDAC            : out   std_logic;
          NOT_CLR             : out   std_logic;
          NOT_RESET_DAC       : out   std_logic;
          NOT_PEC             : in    std_logic;
          MOSI                : out   std_logic;
          SCLK                : out   std_logic;
          CS                  : out   std_logic;
          NOT_OD              : out   std_logic;
          DEBUG_GPIO          : out   std_logic;
          DEBUG_NOT_BUSY      : out   std_logic;
          DEBUG_NOT_BIN       : out   std_logic;
          DEBUG_MISO          : out   std_logic;
          DEBUG_NOT_LDAC      : out   std_logic;
          DEBUG_NOT_CLR       : out   std_logic;
          DEBUG_NOT_RESET_DAC : out   std_logic;
          DEBUG_NOT_PEC       : out   std_logic;
          DEBUG_MOSI          : out   std_logic;
          DEBUG_SCLK          : out   std_logic;
          DEBUG_CS            : out   std_logic;
          Reset               : in    std_logic;
          Clk                 : in    std_logic
        );

end IGLOO_TOP;

architecture DEF_ARCH of IGLOO_TOP is 

  component DFN1E1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          E   : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component AO1
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AO1A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component DFN1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component DFN1E0C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          E   : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component NOR3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR3B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR3C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR3
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AOI1B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XOR2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR3B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component NOR3A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component IOPAD_TRI
    port( D   : in    std_logic := 'U';
          E   : in    std_logic := 'U';
          PAD : out   std_logic
        );
  end component;

  component IOTRI_OB_EB
    port( D    : in    std_logic := 'U';
          E    : in    std_logic := 'U';
          DOUT : out   std_logic;
          EOUT : out   std_logic
        );
  end component;

  component OR2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XA1C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AND3B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component DFN1P0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          PRE : in    std_logic := 'U';
          Q   : out   std_logic
        );
  end component;

  component MX2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OA1A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component IOPAD_IN
    port( PAD : in    std_logic := 'U';
          Y   : out   std_logic
        );
  end component;

  component OA1C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component CLKIO
    port( A : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XO1A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XO1
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OA1B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AX1C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XNOR2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component INV
    port( A : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR3C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XA1B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OA1
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AO1C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component CLKINT
    port( A : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OR3A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component ULSICC_INT
    port( USTDBY : in    std_logic := 'U';
          LPENA  : in    std_logic := 'U'
        );
  end component;

  component AXOI5
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AOI1
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AND3C
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component MX2B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          S : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AO1B
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AO1D
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AOI1A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component FIFO4K18
    port( AEVAL11 : in    std_logic := 'U';
          AEVAL10 : in    std_logic := 'U';
          AEVAL9  : in    std_logic := 'U';
          AEVAL8  : in    std_logic := 'U';
          AEVAL7  : in    std_logic := 'U';
          AEVAL6  : in    std_logic := 'U';
          AEVAL5  : in    std_logic := 'U';
          AEVAL4  : in    std_logic := 'U';
          AEVAL3  : in    std_logic := 'U';
          AEVAL2  : in    std_logic := 'U';
          AEVAL1  : in    std_logic := 'U';
          AEVAL0  : in    std_logic := 'U';
          AFVAL11 : in    std_logic := 'U';
          AFVAL10 : in    std_logic := 'U';
          AFVAL9  : in    std_logic := 'U';
          AFVAL8  : in    std_logic := 'U';
          AFVAL7  : in    std_logic := 'U';
          AFVAL6  : in    std_logic := 'U';
          AFVAL5  : in    std_logic := 'U';
          AFVAL4  : in    std_logic := 'U';
          AFVAL3  : in    std_logic := 'U';
          AFVAL2  : in    std_logic := 'U';
          AFVAL1  : in    std_logic := 'U';
          AFVAL0  : in    std_logic := 'U';
          WD17    : in    std_logic := 'U';
          WD16    : in    std_logic := 'U';
          WD15    : in    std_logic := 'U';
          WD14    : in    std_logic := 'U';
          WD13    : in    std_logic := 'U';
          WD12    : in    std_logic := 'U';
          WD11    : in    std_logic := 'U';
          WD10    : in    std_logic := 'U';
          WD9     : in    std_logic := 'U';
          WD8     : in    std_logic := 'U';
          WD7     : in    std_logic := 'U';
          WD6     : in    std_logic := 'U';
          WD5     : in    std_logic := 'U';
          WD4     : in    std_logic := 'U';
          WD3     : in    std_logic := 'U';
          WD2     : in    std_logic := 'U';
          WD1     : in    std_logic := 'U';
          WD0     : in    std_logic := 'U';
          WW0     : in    std_logic := 'U';
          WW1     : in    std_logic := 'U';
          WW2     : in    std_logic := 'U';
          RW0     : in    std_logic := 'U';
          RW1     : in    std_logic := 'U';
          RW2     : in    std_logic := 'U';
          RPIPE   : in    std_logic := 'U';
          WEN     : in    std_logic := 'U';
          REN     : in    std_logic := 'U';
          WBLK    : in    std_logic := 'U';
          RBLK    : in    std_logic := 'U';
          WCLK    : in    std_logic := 'U';
          RCLK    : in    std_logic := 'U';
          RESET   : in    std_logic := 'U';
          ESTOP   : in    std_logic := 'U';
          FSTOP   : in    std_logic := 'U';
          RD17    : out   std_logic;
          RD16    : out   std_logic;
          RD15    : out   std_logic;
          RD14    : out   std_logic;
          RD13    : out   std_logic;
          RD12    : out   std_logic;
          RD11    : out   std_logic;
          RD10    : out   std_logic;
          RD9     : out   std_logic;
          RD8     : out   std_logic;
          RD7     : out   std_logic;
          RD6     : out   std_logic;
          RD5     : out   std_logic;
          RD4     : out   std_logic;
          RD3     : out   std_logic;
          RD2     : out   std_logic;
          RD1     : out   std_logic;
          RD0     : out   std_logic;
          FULL    : out   std_logic;
          AFULL   : out   std_logic;
          EMPTY   : out   std_logic;
          AEMPTY  : out   std_logic
        );
  end component;

  component IOIN_IB
    port( YIN : in    std_logic := 'U';
          Y   : out   std_logic
        );
  end component;

  component DFI1C0
    port( D   : in    std_logic := 'U';
          CLK : in    std_logic := 'U';
          CLR : in    std_logic := 'U';
          QN  : out   std_logic
        );
  end component;

  component AND2A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component OAI1
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component XA1A
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component AXOI2
    port( A : in    std_logic := 'U';
          B : in    std_logic := 'U';
          C : in    std_logic := 'U';
          Y : out   std_logic
        );
  end component;

  component GND
    port(Y : out std_logic); 
  end component;

  component VCC
    port(Y : out std_logic); 
  end component;

    signal Reset_c, GPIO_c, NOT_BUSY_c, MISO_c, NOT_LDAC_c, 
        NOT_PEC_c, MOSI_c, SCLK_c, CS_c, DEBUG_GPIO_c, 
        DEBUG_NOT_BUSY_c, DEBUG_MISO_c, DEBUG_NOT_LDAC_c, 
        NOT_RESET_DAC_c_c, DEBUG_NOT_RESET_DAC_c, DEBUG_NOT_PEC_c, 
        DEBUG_MOSI_c, DEBUG_SCLK_c, DEBUG_CS_c, Clk_c, 
        \MyDAC/INPUT_DATA_TG[0]\, \MyDAC/INPUT_DATA_TG[1]\, 
        \MyDAC/INPUT_DATA_TG[2]\, \MyDAC/INPUT_DATA_TG[3]\, 
        \MyDAC/INPUT_DATA_TG[4]\, \MyDAC/INPUT_DATA_TG[5]\, 
        \MyDAC/INPUT_DATA_TG[6]\, \MyDAC/INPUT_DATA_TG[7]\, 
        \MyDAC/INPUT_DATA_TG[8]\, \MyDAC/WEBP\, 
        \MyDAC/INPUT_FULL\, \MyDAC/PauseCounter[0]\, 
        \MyDAC/PauseCounter[1]\, \MyDAC/PauseCounter[2]\, 
        \MyDAC/PauseCounter[3]\, \MyDAC/PauseCounter[4]\, 
        \MyDAC/PauseCounter[5]\, \MyDAC/PauseCounter[6]\, 
        \MyDAC/PauseCounter[7]\, \MyDAC/PauseCounter[8]\, 
        \MyDAC/PauseCounter[9]\, \MyDAC/PauseCounter[10]\, 
        \MyDAC/PauseCounter[11]\, \MyDAC/PauseCounter[12]\, 
        \MyDAC/PauseCounter[13]\, \MyDAC/PauseCounter[14]\, 
        \MyDAC/PauseCounter[15]\, \MyDAC/PauseCounter[16]\, 
        \MyDAC/PauseCounter[17]\, \MyDAC/PauseCounter[18]\, 
        \MyDAC/PauseCounter[19]\, \MyDAC/PauseCounter[20]\, 
        \MyDAC/PauseCounter[21]\, \MyDAC/PauseCounter[22]\, 
        \MyDAC/PauseCounter[23]\, \MyDAC/PauseCounter[24]\, 
        \MyDAC/PauseCounter[25]\, \MyDAC/PauseCounter[26]\, 
        \MyDAC/PauseCounter[27]\, \MyDAC/PauseCounter[28]\, 
        \MyDAC/PauseCounter[29]\, \MyDAC/PauseCounter[30]\, 
        \MyDAC/PauseCounter[31]\, \MyDAC/PauseCounter[32]\, 
        \MyDAC/PauseCounter[33]\, \MyDAC/PauseCounter[34]\, 
        \MyDAC/PauseCounter[35]\, \MyDAC/PauseCounter[36]\, 
        \MyDAC/PauseCounter[37]\, \MyDAC/PauseCounter[38]\, 
        \MyDAC/PauseCounter[39]\, 
        \MyDAC/Controller_ChannelID_EXPORT[0]\, 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, 
        \MyDAC/Controller_ChannelID_EXPORT[2]\, 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, 
        \MyDAC/Controller_Value_EXPORT[0]\, 
        \MyDAC/Controller_Value_EXPORT[1]\, 
        \MyDAC/Controller_Value_EXPORT[2]\, 
        \MyDAC/Controller_Value_EXPORT[3]\, 
        \MyDAC/Controller_Value_EXPORT[4]\, 
        \MyDAC/Controller_Value_EXPORT[5]\, 
        \MyDAC/Controller_Value_EXPORT[6]\, 
        \MyDAC/Controller_Value_EXPORT[7]\, 
        \MyDAC/Controller_Value_EXPORT[8]\, 
        \MyDAC/Controller_Value_EXPORT[9]\, 
        \MyDAC/Controller_Value_EXPORT[10]\, 
        \MyDAC/Controller_Value_EXPORT[11]\, 
        \MyDAC/Controller_Value_EXPORT[12]\, 
        \MyDAC/Controller_Value_EXPORT[13]\, 
        \MyDAC/Controller_Value_EXPORT[14]\, 
        \MyDAC/Controller_Value_EXPORT[15]\, 
        \MyDAC/Controller_SetMode_EXPORT[0]\, 
        \MyDAC/Controller_SetMode_EXPORT[1]\, 
        \MyDAC/Controller_Wait_i_0\, 
        \MyDAC/Controller_Valid_EXPORT\, 
        \MyDAC/Controller_SPIACTION\, 
        \MyDAC/TestGen/INPUT_DATA_VALID_RNO_net_1\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_1[1]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_a3_2_0[1]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, 
        \MyDAC/TestGen/N_35\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_0[1]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_2_tz[1]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_0[2]\, 
        \MyDAC/TestGen/N_22\, 
        \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_2[0]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_1_tz[0]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_1_0[0]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_5_1[0]\, 
        \MyDAC/TestGen/N_486_1\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_0[0]\, 
        \MyDAC/TestGen/N_23\, \MyDAC/TestGen/N_64_1\, 
        \MyDAC/TestGen/N_32\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_a3_0[2]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, 
        \MyDAC/TestGen/N_21\, \MyDAC/TestGen/N_20_i\, 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_1\, 
        \MyDAC/TestGen/N_50\, \MyDAC/TestGen/N_49\, 
        \MyDAC/TestGen/N_48\, \MyDAC/TestGen/N_75\, 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_0_0[0]\, 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_2[3]\, 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_a5_2_0[3]\, 
        \MyDAC/TestGen/N_415\, 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_0[3]\, 
        \MyDAC/TestGen/N_411\, \MyDAC/TestGen/N_418\, 
        \MyDAC/TestGen/N_19\, 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_0[1]\, 
        \MyDAC/TestGen/N_412\, \MyDAC/TestGen/N_389\, 
        \MyDAC/TestGen/G_1_0_0_0\, \MyDAC/TestGen/N_34\, 
        \MyDAC/TestGen/INPUT_DATA_15k_0_0_0[0]\, 
        \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_a3_1_0\, 
        \MyDAC/TestGen/G_1_0_0_a3_0\, 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_a2_0\, 
        \MyDAC/TestGen/N_347\, \MyDAC/TestGen/N_388\, 
        \MyDAC/TestGen/N_109\, \MyDAC/TestGen/N_399\, 
        \MyDAC/TestGen/N_419\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[1]_net_1\, 
        \MyDAC/TestGen/N_52\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[49]\, 
        \MyDAC/TestGen/N_391\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[3]_net_1\, 
        \MyDAC/TestGen/N_58\, \MyDAC/TestGen/N_57\, 
        \MyDAC/TestGen/N_33\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns[0]\, 
        \MyDAC/TestGen/N_68\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[2]_net_1\, 
        \MyDAC/TestGen/N_36\, \MyDAC/TestGen/N_39\, 
        \MyDAC/TestGen/N_66\, \MyDAC/TestGen/N_114\, 
        \MyDAC/TestGen/N_398\, \MyDAC/TestGen/N_400\, 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, 
        \MyDAC/TestGen/N_47\, \MyDAC/TestGen/N_46\, 
        \MyDAC/TestGen/N_353\, \MyDAC/TestGen/N_393\, 
        \MyDAC/TestGen/N_69_1\, \MyDAC/TestGen/N_26_i\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_1_0[0]\, 
        \MyDAC/TestGen/N_69\, \MyDAC/TestGen/Counter_n15\, 
        \MyDAC/TestGen/Counter_c14\, 
        \MyDAC/TestGen/Counter[15]_net_1\, 
        \MyDAC/TestGen/Counter_n14\, 
        \MyDAC/TestGen/Counter[13]_net_1\, 
        \MyDAC/TestGen/Counter_c12\, 
        \MyDAC/TestGen/Counter[14]_net_1\, 
        \MyDAC/TestGen/Counter_n13\, \MyDAC/TestGen/Counter_n12\, 
        \MyDAC/TestGen/Counter[11]_net_1\, 
        \MyDAC/TestGen/Counter_c10\, 
        \MyDAC/TestGen/Counter[12]_net_1\, 
        \MyDAC/TestGen/Counter_n11\, \MyDAC/TestGen/Counter_n10\, 
        \MyDAC/TestGen/Counter[9]_net_1\, 
        \MyDAC/TestGen/Counter_c8\, 
        \MyDAC/TestGen/Counter[10]_net_1\, 
        \MyDAC/TestGen/Counter_n9\, \MyDAC/TestGen/Counter_n8\, 
        \MyDAC/TestGen/Counter[7]_net_1\, 
        \MyDAC/TestGen/Counter_c6\, 
        \MyDAC/TestGen/Counter[8]_net_1\, 
        \MyDAC/TestGen/Counter_n7\, \MyDAC/TestGen/Counter_n6\, 
        \MyDAC/TestGen/Counter[5]_net_1\, 
        \MyDAC/TestGen/Counter_c4\, 
        \MyDAC/TestGen/Counter[6]_net_1\, 
        \MyDAC/TestGen/Counter_n5\, \MyDAC/TestGen/Counter_n4\, 
        \MyDAC/TestGen/Counter[3]_net_1\, 
        \MyDAC/TestGen/Counter_c2\, 
        \MyDAC/TestGen/Counter[4]_net_1\, 
        \MyDAC/TestGen/Counter_n3\, \MyDAC/TestGen/Counter_n2\, 
        \MyDAC/TestGen/Counter[1]_net_1\, 
        \MyDAC/TestGen/Counter[0]_net_1\, 
        \MyDAC/TestGen/Counter[2]_net_1\, 
        \MyDAC/TestGen/Counter_e0\, \MyDAC/TestGen/Counter_n1\, 
        \MyDAC/TestGen/INPUT_DATA_15[1]\, \MyDAC/TestGen/N_142\, 
        \MyDAC/TestGen/INPUT_DATA_15[0]\, \MyDAC/TestGen/N_141\, 
        \MyDAC/TestGen/N_417\, \MyDAC/TestGen/N_29\, 
        \MyDAC/TestGen/N_28\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[4]_net_1\, 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[5]_net_1\, 
        \MyDAC/TestGen/N_40\, \MyDAC/TestGen/N_38\, 
        \MyDAC/TestGen/N_143\, \MyDAC/TestGen/N_144\, 
        \MyDAC/TestGen/N_145\, \MyDAC/TestGen/N_146\, 
        \MyDAC/TestGen/N_147\, \MyDAC/TestGen/N_148\, 
        \MyDAC/TestGen/N_392\, \MyDAC/TestGen/N_397\, 
        \MyDAC/TestGen/N_351\, \MyDAC/TestGen/N_409\, 
        \MyDAC/TestGen/N_355\, \MyDAC/TestGen/N_115\, 
        \MyDAC/TestGen/N_113\, \MyDAC/TestGen/INPUT_DATA_15[2]\, 
        \MyDAC/TestGen/INPUT_DATA_15[3]\, 
        \MyDAC/TestGen/INPUT_DATA_15[4]\, 
        \MyDAC/TestGen/INPUT_DATA_15[5]\, 
        \MyDAC/TestGen/INPUT_DATA_15[6]\, 
        \MyDAC/TestGen/INPUT_DATA_15[7]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMNK6M[2]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIAFULJ[4]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIFHFHD[0]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5H1P7[1]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7KS6[1]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7NO4[5]_net_1\, 
        \MyDAC/MyPackageDis/N_732_0\, \MyDAC/MyPackageDis/N_743\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI7BL71[1]_net_1\, 
        \MyDAC/MyPackageDis/Controller_Value_119_e_0\, 
        \MyDAC/MyPackageDis/N_793\, \MyDAC/MyPackageDis/N_761\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_10[1]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNII38Q2[3]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_6[1]\, 
        \MyDAC/MyPackageDis/N_103\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_9[1]\, 
        \MyDAC/MyPackageDis/N_968\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_5[1]\, 
        \MyDAC/MyPackageDis/N_149\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_0[1]\, 
        \MyDAC/MyPackageDis/N_138\, \MyDAC/MyPackageDis/N_153\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_1[1]\, 
        \MyDAC/MyPackageDis/N_146\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_4[1]\, 
        \MyDAC/MyPackageDis/N_147\, \MyDAC/MyPackageDis/N_150\, 
        \MyDAC/MyPackageDis/N_151\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_12[0]\, 
        \MyDAC/MyPackageDis/N_187\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_7[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_10[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_11[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_6[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_5[0]\, 
        \MyDAC/MyPackageDis/N_196\, \MyDAC/MyPackageDis/N_85\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_12_0[0]\, 
        \MyDAC/MyPackageDis/N_191\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_2[0]\, 
        \MyDAC/MyPackageDis/N_189\, \MyDAC/MyPackageDis/N_188\, 
        \MyDAC/MyPackageDis/N_110\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_0_0[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_3[0]\, 
        \MyDAC/MyPackageDis/N_80\, \MyDAC/MyPackageDis/N_822\, 
        \MyDAC/MyPackageDis/N_185\, \MyDAC/MyPackageDis/N_197\, 
        \MyDAC/MyPackageDis/N_193\, \MyDAC/MyPackageDis/N_199\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_3[4]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_3_0[4]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_2_0[4]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_2[4]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_0[4]\, 
        \MyDAC/MyPackageDis/N_163\, \MyDAC/MyPackageDis/N_162\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_0[4]\, 
        \MyDAC/MyPackageDis/N_124\, \MyDAC/MyPackageDis/N_166\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_7[2]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_4_0[2]\, 
        \MyDAC/MyPackageDis/N_183\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_6[2]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_9_0[2]\, 
        \MyDAC/MyPackageDis/N_178\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_5[2]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_3[2]\, 
        \MyDAC/MyPackageDis/N_175\, \MyDAC/MyPackageDis/N_174\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_2_1[2]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_2[2]\, 
        \MyDAC/MyPackageDis/N_176\, \MyDAC/MyPackageDis/N_182\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_1[2]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_6_0[2]\, 
        \MyDAC/MyPackageDis/N_83\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_12[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_3[1]\, 
        \MyDAC/MyPackageDis/Mode_07_Input_m[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_9[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_11[1]\, 
        \MyDAC/MyPackageDis/Mode_09_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_08_Input_m[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_7[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_10[1]\, 
        \MyDAC/MyPackageDis/Mode_05_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_04_Input_m[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_4[1]\, 
        \MyDAC/MyPackageDis/Mode_03_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[25]\, 
        \MyDAC/MyPackageDis/Mode_10_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_02_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[28]\, 
        \MyDAC/MyPackageDis/Mode_06_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_12_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_11_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_01_Input_m[1]\, 
        \MyDAC/MyPackageDis/N_618\, 
        \MyDAC/MyPackageDis/Mode_13_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_1[1]\, 
        \MyDAC/MyPackageDis/Mode_14_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_15_Input_m[1]\, 
        \MyDAC/MyPackageDis/Mode_00_Input_m[1]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_12[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_3[0]\, 
        \MyDAC/MyPackageDis/Mode_02_Input_m[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_9[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_11[0]\, 
        \MyDAC/MyPackageDis/Mode_09_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_08_Input_m[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_7[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_10[0]\, 
        \MyDAC/MyPackageDis/Mode_05_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_04_Input_m[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_4[0]\, 
        \MyDAC/MyPackageDis/Mode_03_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_10_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_07_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[29]\, 
        \MyDAC/MyPackageDis/Mode_06_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_12_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_11_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_01_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_13_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_1[0]\, 
        \MyDAC/MyPackageDis/Mode_14_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_15_Input_m[0]\, 
        \MyDAC/MyPackageDis/Mode_00_Input_m[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_0[5]\, 
        \MyDAC/MyPackageDis/N_84\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_1_0[5]\, 
        \MyDAC/MyPackageDis/N_88\, 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_13_i_3\, 
        \MyDAC/MyPackageDis/N_791\, \MyDAC/MyPackageDis/N_790\, 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_13_i_2\, 
        \MyDAC/MyPackageDis/N_789\, \MyDAC/MyPackageDis/N_792\, 
        \MyDAC/MyPackageDis/N_141\, 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_12_i_0_1\, 
        \MyDAC/MyPackageDis/N_230\, \MyDAC/MyPackageDis/N_231\, 
        \MyDAC/MyPackageDis/N_225\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_10_0[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, 
        \MyDAC/MyPackageDis/N_240\, \MyDAC/MyPackageDis/N_803_1\, 
        \MyDAC/MyPackageDis/N_234\, \MyDAC/MyPackageDis/N_736\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_4_0[1]\, 
        \MyDAC/MyPackageDis/N_104\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_i_2[0]\, 
        \MyDAC/MyPackageDis/N_87\, \MyDAC/MyPackageDis/N_232\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_i_1[0]\, 
        \MyDAC/MyPackageDis/N_205\, \MyDAC/MyPackageDis/N_203\, 
        \MyDAC/MyPackageDis/N_201\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_13_0[1]\, 
        \MyDAC/MyPackageDis/N_728_i\, 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_10_i_o2_0_0\, 
        \MyDAC/MyPackageDis/N_730\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, 
        \MyDAC/MyPackageDis/N_742_i_1\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0[3]\, 
        \MyDAC/MyPackageDis/N_806\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0_2[2]\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0_0[2]\, 
        \MyDAC/MyPackageDis/N_219\, \MyDAC/MyPackageDis/N_220\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7_i_o6_0[15]\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_1[1]\, 
        \MyDAC/MyPackageDis/N_131\, \MyDAC/MyPackageDis/N_97\, 
        \MyDAC/MyPackageDis/N_814\, 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0[1]\, 
        \MyDAC/MyPackageDis/N_241\, \MyDAC/MyPackageDis/N_813\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_3_0[0]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, 
        \MyDAC/MyPackageDis/N_92\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_5_0[1]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s10_i_0\, 
        \MyDAC/MyPackageDis/N_737\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1_tz_1\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1_tz_0\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_8_0[0]\, 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_12_i_o2_0_0\, 
        \MyDAC/MyPackageDis/N_108\, 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_15_i_a6_0\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_0\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1\, 
        \MyDAC/MyPackageDis/N_805\, \MyDAC/MyPackageDis/N_200\, 
        \MyDAC/MyPackageDis/N_224\, \MyDAC/MyPackageDis/N_91\, 
        \MyDAC/MyPackageDis/N_94\, \MyDAC/MyPackageDis/N_247\, 
        \MyDAC/MyPackageDis/N_172\, \MyDAC/MyPackageDis/N_732\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_2[3]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_4[3]\, 
        \MyDAC/MyPackageDis/N_962\, \MyDAC/MyPackageDis/N_725\, 
        \MyDAC/MyPackageDis/N_762\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18[0]\, 
        \MyDAC/MyPackageDis/Controller_SetMode_18[1]\, 
        \MyDAC/MyPackageDis/N_723\, \MyDAC/MyPackageDis/N_807\, 
        \MyDAC/MyPackageDis/N_727\, \MyDAC/MyPackageDis/N_829\, 
        \MyDAC/MyPackageDis/N_629\, \MyDAC/MyPackageDis/N_748\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_net_1\, 
        \MyDAC/MyPackageDis/INPUT_READEN_LAST_net_1\, 
        \MyDAC/MyPackageDis/FIFO_EMPTY\, 
        \MyDAC/MyPackageDis/N_159\, \MyDAC/MyPackageDis/N_158\, 
        \MyDAC/MyPackageDis/N_90\, \MyDAC/MyPackageDis/N_155\, 
        \MyDAC/MyPackageDis/N_148\, \MyDAC/MyPackageDis/N_125\, 
        \MyDAC/MyPackageDis/N_598\, \MyDAC/MyPackageDis/N_740\, 
        \MyDAC/MyPackageDis/N_977\, \MyDAC/MyPackageDis/N_631\, 
        \MyDAC/MyPackageDis/N_794\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_5_1[3]\, 
        \MyDAC/MyPackageDis/N_238\, \MyDAC/MyPackageDis/N_223\, 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_a6_2_0\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_0[3]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_11_0[1]\, 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_12_0[1]\, 
        \MyDAC/MyPackageDis/N_818\, \MyDAC/MyPackageDis/N_86\, 
        \MyDAC/MyPackageDis/N_966\, \MyDAC/MyPackageDis/N_242\, 
        \MyDAC/MyPackageDis/N_233\, 
        \MyDAC/MyPackageDis/dout_m_0[0]\, 
        \MyDAC/MyPackageDis/dout[0]\, \MyDAC/MyPackageDis/N_768\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[8]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[16]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[16]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[19]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[19]\, 
        \MyDAC/MyPackageDis/dout[3]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[21]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[21]\, 
        \MyDAC/MyPackageDis/dout[5]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[22]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[22]\, 
        \MyDAC/MyPackageDis/dout[6]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[23]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[23]\, 
        \MyDAC/MyPackageDis/dout[7]\, 
        \MyDAC/MyPackageDis/dout_m_2[2]\, 
        \MyDAC/MyPackageDis/dout[2]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[26]\, 
        \MyDAC/MyPackageDis/N_749\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[32]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[32]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[36]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[36]\, 
        \MyDAC/MyPackageDis/dout[4]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[39]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[39]\, 
        \MyDAC/MyPackageDis/N_826\, 
        \MyDAC/MyPackageDis/Mode_12_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/N_584\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[0]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[0]\, 
        \MyDAC/MyPackageDis/N_588\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[3]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[3]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[5]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[5]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[6]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[6]\, 
        \MyDAC/MyPackageDis/dout_m_0[5]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[13]\, 
        \MyDAC/MyPackageDis/dout_m_0[7]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[15]\, 
        \MyDAC/MyPackageDis/dout_m_2[7]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[31]\, 
        \MyDAC/MyPackageDis/Mode_00_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_01_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_02_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_04_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_05_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_06_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_08_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_09_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_10_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/N_147_1\, 
        \MyDAC/MyPackageDis/Mode_11_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_14_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_15_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/Mode_00_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_04_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_05_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_06_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_07_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_10_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_11_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_14_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_15_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/N_582\, 
        \MyDAC/MyPackageDis/Mode_12_Input[0]_net_1\, 
        \MyDAC/MyPackageDis/N_122\, \MyDAC/MyPackageDis/N_99\, 
        \MyDAC/MyPackageDis/N_229\, \MyDAC/MyPackageDis/N_963\, 
        \MyDAC/MyPackageDis/N_207\, \MyDAC/MyPackageDis/N_117\, 
        \MyDAC/MyPackageDis/N_95\, \MyDAC/MyPackageDis/N_170\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[2]\, 
        \MyDAC/MyPackageDis/dout_m[2]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[10]\, 
        \MyDAC/MyPackageDis/dout_m_0[2]\, 
        \MyDAC/MyPackageDis/Controller_Valid_RNO_net_1\, 
        \MyDAC/MyPackageDis/Mode_09_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_08_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/Mode_01_Input[1]_net_1\, 
        \MyDAC/MyPackageDis/N_217\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[11]\, 
        \MyDAC/MyPackageDis/dout_m_0[3]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[12]\, 
        \MyDAC/MyPackageDis/dout_m_0[4]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[17]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[17]\, 
        \MyDAC/MyPackageDis/dout[1]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[18]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[18]\, 
        \MyDAC/MyPackageDis/dout_m_2[0]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[24]\, 
        \MyDAC/MyPackageDis/N_734\, 
        \MyDAC/MyPackageDis/dout_m_2[4]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[28]\, 
        \MyDAC/MyPackageDis/dout_m_2[3]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[27]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[35]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[35]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[37]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[37]\, 
        \MyDAC/MyPackageDis/dout_m_0[6]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[14]\, 
        \MyDAC/MyPackageDis/dout_m_2[1]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[25]\, 
        \MyDAC/MyPackageDis/dout_m_2[6]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[30]\, 
        \MyDAC/MyPackageDis/dout_m_2[5]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[29]\, 
        \MyDAC/MyPackageDis/N_965\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[4]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[4]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[38]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[38]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[34]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[34]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[9]\, 
        \MyDAC/MyPackageDis/dout_m_0[1]\, 
        \MyDAC/MyPackageDis/N_192\, \MyDAC/MyPackageDis/N_244\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[7]\, 
        \MyDAC/MyPackageDis/dout_m[7]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[1]\, 
        \MyDAC/MyPackageDis/dout_m[1]\, 
        \MyDAC/MyPackageDis/N_824\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[33]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[33]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[20]\, 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[20]\, 
        \MyDAC/MyPackageDis/N_126\, 
        \MyDAC/MyPackageDis/MyFIFO/N_152\, 
        \MyDAC/MyPackageDis/MyFIFO/N_154\, 
        \MyDAC/MyPackageDis/MyFIFO/N_190\, 
        \MyDAC/MyPackageDis/MyFIFO/N_194\, 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_i_i_0[3]\, 
        \MyDAC/MyPackageDis/MyFIFO/N_168\, 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_i_i_a2_1_0[3]\, 
        \MyDAC/MyPackageDis/MyFIFO/N_171\, 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_0_i_a2_9_0[1]\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[1]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[1]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[1]\\\\\, \GND\, 
        \VCC\, \MyDAC/MyPackageDis/MyFIFO/READ_ENABLE_I\, 
        \MyDAC/MyPackageDis/MyFIFO/WRITE_ENABLE_I\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[0]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[0]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[0]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/FULL\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[2]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[2]\\\\\, 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[2]\\\\\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, 
        \MyDAC/MyAD5360/N_33\, \MyDAC/MyAD5360/N_267_0\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[2]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[1]_net_1\, 
        \MyDAC/MyAD5360/SPI_START_i\, 
        \MyDAC/MyAD5360/SPI_START_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_n19_i_0\, 
        \MyDAC/MyAD5360/N_267\, 
        \MyDAC/MyAD5360/ResetCounter_N_9_mux_2\, 
        \MyDAC/MyAD5360/ResetCounter_n39_i_0_0\, 
        \MyDAC/MyAD5360/N_326\, 
        \MyDAC/MyAD5360/ResetCounter_n30_0_i_0\, 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux\, 
        \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0\, 
        \MyDAC/MyAD5360/ResetCounter[33]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[31]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m1_e_7_0\, 
        \MyDAC/MyAD5360/ResetCounter[32]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0_2\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4\, 
        \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0_0\, 
        \MyDAC/MyAD5360/ResetCounter_n34_i_0_o2_0_0\, 
        \MyDAC/MyAD5360/ResetCounter[35]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_4\, 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_1\, 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_0\, 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_2\, 
        \MyDAC/MyAD5360/ResetCounter[26]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[23]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[24]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[22]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[27]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[25]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_3\, 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_0\, 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_1\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_7\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_4\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_3\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_5\, 
        \MyDAC/MyAD5360/ResetCounter[15]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[20]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_1\, 
        \MyDAC/MyAD5360/ResetCounter[19]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[21]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[16]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[18]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[17]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_n1_i_0_0\, 
        \MyDAC/MyAD5360/ResetCounter[0]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[1]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_n4_i_0_0\, 
        \MyDAC/MyAD5360/ResetCounter[4]_net_1\, 
        \MyDAC/MyAD5360/N_188\, 
        \MyDAC/MyAD5360/ResetCounter_n3_i_0_0\, 
        \MyDAC/MyAD5360/ResetCounter[3]_net_1\, 
        \MyDAC/MyAD5360/N_187\, 
        \MyDAC/MyAD5360/ResetCounter_n2_i_0_0\, 
        \MyDAC/MyAD5360/ResetCounter[2]_net_1\, 
        \MyDAC/MyAD5360/N_186\, 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_5\, 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_2\, 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_3\, 
        \MyDAC/MyAD5360/ResetCounter[14]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[13]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_0[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_2[2]\, 
        \MyDAC/MyAD5360/N_292_8\, \MyDAC/MyAD5360/N_281\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_6\, 
        \MyDAC/MyAD5360/ResetCounter[8]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[9]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_4\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_5\, 
        \MyDAC/MyAD5360/ResetCounter[6]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[7]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_2\, 
        \MyDAC/MyAD5360/ResetCounter[10]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[12]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[5]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[11]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_0[5]\, 
        \MyDAC/MyAD5360/N_38\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_4[1]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_5[1]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_1[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_0[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_1[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_0[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[5]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_2[1]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_1[1]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_0[1]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_12[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_9[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_8[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_10[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_1[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_0[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_6[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_5[5]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_3[5]\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_37\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_31\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_30\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_34\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_17\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_16\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_29\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_33\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_13\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_12\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_27\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_32\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_9\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_8\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_25\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_5\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_4\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_23\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_3\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_2\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_20\, 
        \MyDAC/MyAD5360/un11_resetcounter_4\, 
        \MyDAC/MyAD5360/un11_resetcounter_31\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_19\, 
        \MyDAC/MyAD5360/un11_resetcounter_18\, 
        \MyDAC/MyAD5360/un11_resetcounter_17\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_15\, 
        \MyDAC/MyAD5360/un11_resetcounter_6\, 
        \MyDAC/MyAD5360/un11_resetcounter_7\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_11\, 
        \MyDAC/MyAD5360/un11_resetcounter_37\, 
        \MyDAC/MyAD5360/un11_resetcounter_29\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_7\, 
        \MyDAC/MyAD5360/un11_resetcounter_35\, 
        \MyDAC/MyAD5360/un11_resetcounter_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_NE_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[23]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_32\, 
        \MyDAC/MyAD5360/PauseCounter_Output[9]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_26\, 
        \MyDAC/MyAD5360/PauseCounter_Output[8]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_25\, 
        \MyDAC/MyAD5360/PauseCounter_Output[22]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_24\, 
        \MyDAC/MyAD5360/PauseCounter_Output[15]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_16\, 
        \MyDAC/MyAD5360/PauseCounter_Output[13]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_14\, 
        \MyDAC/MyAD5360/PauseCounter_Output[33]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_11\, 
        \MyDAC/MyAD5360/PauseCounter_Output[3]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_5\, 
        \MyDAC/MyAD5360/PauseCounter_Output[20]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_2\, 
        \MyDAC/MyAD5360/ResetCounter[38]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[38]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_0\, 
        \MyDAC/MyAD5360/ResetCounter[36]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[36]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_10\, 
        \MyDAC/MyAD5360/ResetCounter[28]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[28]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_12\, 
        \MyDAC/MyAD5360/PauseCounter_Output[21]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_27\, 
        \MyDAC/MyAD5360/ResetCounter[39]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[39]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_19\, 
        \MyDAC/MyAD5360/ResetCounter[34]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[34]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_30\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_20[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_9[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_8[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_17[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_19[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_6[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_5[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_15[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_18[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_2[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_1[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_13[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_11[2]\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_4[2]\, 
        \MyDAC/MyAD5360/ResetCounter[37]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[29]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter[30]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_6\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_4\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_5\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_2\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_6\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_0\, 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_5\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_1[1]\, 
        \MyDAC/MyAD5360/un3_controller_busy_1\, 
        \MyDAC/MyAD5360/Busy_i_0\, 
        \MyDAC/MyAD5360/SPI_START_LAST_i_0\, 
        \MyDAC/MyAD5360/Output_Busy_i_0\, \MyDAC/MyAD5360/N_81\, 
        \MyDAC/MyAD5360/N_203\, \MyDAC/MyAD5360/N_86\, 
        \MyDAC/MyAD5360/N_204\, \MyDAC/MyAD5360/N_18\, 
        \MyDAC/MyAD5360/N_202\, \MyDAC/MyAD5360/N_157\, 
        \MyDAC/MyAD5360/N_215\, \MyDAC/MyAD5360/N_159\, 
        \MyDAC/MyAD5360/N_216\, \MyDAC/MyAD5360/N_161\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[3]_net_1\, 
        \MyDAC/MyAD5360/N_366\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[2]_net_1\, 
        \MyDAC/MyAD5360/un11_resetcounter_i\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[0]_net_1\, 
        \MyDAC/MyAD5360/N_294\, \MyDAC/MyAD5360/N_348\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[4]_net_1\, 
        \MyDAC/MyAD5360/N_189\, \MyDAC/MyAD5360/N_64\, 
        \MyDAC/MyAD5360/N_147\, \MyDAC/MyAD5360/N_209\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[6]_net_1\, 
        \MyDAC/MyAD5360/N_191\, \MyDAC/MyAD5360/N_290\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[5]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[8]_net_1\, 
        \MyDAC/MyAD5360/N_192\, \MyDAC/MyAD5360/N_15\, 
        \MyDAC/MyAD5360/N_151\, \MyDAC/MyAD5360/N_211\, 
        \MyDAC/MyAD5360/N_149\, \MyDAC/MyAD5360/N_210\, 
        \MyDAC/MyAD5360/N_20\, \MyDAC/MyAD5360/N_279\, 
        \MyDAC/MyAD5360/N_155\, 
        \MyDAC/MyAD5360/ResetCounter_N_7_mux_0_0\, 
        \MyDAC/MyAD5360/N_68\, 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\, 
        \MyDAC/MyAD5360/N_70\, \MyDAC/MyAD5360/N_199\, 
        \MyDAC/MyAD5360/N_22\, \MyDAC/MyAD5360/N_200\, 
        \MyDAC/MyAD5360/N_29\, 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, 
        \MyDAC/MyAD5360/N_145\, \MyDAC/MyAD5360/N_208\, 
        \MyDAC/MyAD5360/N_306\, \MyDAC/MyAD5360/N_507\, 
        \MyDAC/MyAD5360/N_19\, \MyDAC/MyAD5360/N_305\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[20]_net_1\, 
        \MyDAC/MyAD5360/N_61\, \MyDAC/MyAD5360/N_273\, 
        \MyDAC/MyAD5360/ResetCounter_RNO[11]_net_1\, 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_2\, 
        \MyDAC/MyAD5360/N_50\, \MyDAC/MyAD5360/N_271\, 
        \MyDAC/MyAD5360/N_48\, \MyDAC/MyAD5360/N_193\, 
        \MyDAC/MyAD5360/N_31\, \MyDAC/MyAD5360/N_322\, 
        \MyDAC/MyAD5360/un3_controller_busy\, 
        \MyDAC/MyAD5360/ResetCounter_N_4_mux_0\, 
        \MyDAC/MyAD5360/ResetCounter_N_6_mux_0_2\, 
        \MyDAC/MyAD5360/ResetCounter_N_4_mux_0_0\, 
        \MyDAC/MyAD5360/ResetCounter_N_3_mux_0_0\, 
        \MyDAC/MyAD5360/N_12\, \MyDAC/MyAD5360/N_153\, 
        \MyDAC/MyAD5360/PauseCounter_Output[0]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[1]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[2]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[4]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[5]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[6]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[7]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[10]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[11]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[12]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[14]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[16]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[17]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[18]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[19]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[24]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[25]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[26]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[27]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[29]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[30]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[31]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[32]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[35]_net_1\, 
        \MyDAC/MyAD5360/PauseCounter_Output[37]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, 
        \MyDAC/MyAD5360/N_285\, \MyDAC/MyAD5360/N_27\, 
        \MyDAC/MyAD5360/N_14\, \MyDAC/MyAD5360/N_502\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_0[0]_net_1\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[1]_net_1\, 
        \MyDAC/MyAD5360/N_25\, \MyDAC/MyAD5360/N_501\, 
        \MyDAC/MyAD5360/N_506\, \MyDAC/MyAD5360/N_163\, 
        \MyDAC/MyAD5360/N_16\, \MyDAC/MyAD5360/N_23\, 
        \MyDAC/MyAD5360/N_291\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[5]_net_1\, 
        \MyDAC/MyAD5360/N_21\, \MyDAC/MyAD5360/N_266\, 
        \MyDAC/MyAD5360/N_9\, 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[3]_net_1\, 
        \MyDAC/MyAD5360/N_165\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_0[17]\, 
        \MyDAC/MyAD5360/MyController/Output_Valid_i\, 
        \MyDAC/MyAD5360/MyController/Output_Valid_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_i[19]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[19]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_13[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_6[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_4[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/GPIO_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_i_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[15]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[22]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[22]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[22]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[22]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[22]\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[22]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[22]\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[22]\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[22]\, 
        \MyDAC/MyAD5360/MyController/Mode_12_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_09_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_08_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_13_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_04_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Mode_00_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_01_Output_m[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[23]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[23]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[23]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[23]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[23]\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[23]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[23]\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[23]\, 
        \MyDAC/MyAD5360/MyController/Mode_00_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[23]\, 
        \MyDAC/MyAD5360/MyController/Mode_12_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_08_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_09_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_13_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_04_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_01_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Output_m[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_3[20]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_1[20]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_2[20]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_2[16]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_1[16]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_2[18]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_1[18]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_i_a2_2[17]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_i_a2_1[17]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[15]\, 
        \MyDAC/MyAD5360/MyController/N_1385\, 
        \MyDAC/MyAD5360/MyController/N_1426\, 
        \MyDAC/MyAD5360/MyController/N_1385_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[18]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1[18]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[16]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[0]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[10]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[14]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[22]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv[1]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[2]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[3]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[4]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[5]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[6]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[7]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[8]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[9]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[11]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[12]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[13]\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[23]\, 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, 
        \MyDAC/MyAD5360/MyController/un3_output_busy\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_ns[1]\, 
        \MyDAC/MyAD5360/MyController/N_1388\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIOUN7[17]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_Valid_Last_i_0\, 
        \MyDAC/MyAD5360/MyController/GPIO_RNO_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_01_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_08_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_ns[2]\, 
        \MyDAC/MyAD5360/MyController/N_1390\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_1[4]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[2]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_1[3]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[5]\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Output[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[1]\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_09_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_00_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/N_49\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/N_50\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/N_53\, 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/N_54\, 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, 
        \MyDAC/MyAD5360/MyController/Mode_00_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_00_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_15_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_14_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_13_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_13_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_12_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_12_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_11_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_10_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_09_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_09_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_08_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_08_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_07_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_06_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_05_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_04_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_04_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_03_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_02_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_01_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Mode_01_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[22]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[23]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[16]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[17]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[18]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[19]_net_1\, 
        \MyDAC/MyAD5360/MyController/Output_24BitString[20]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_8\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_280\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_4\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_7\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_281\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_271\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_78\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_6\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_32\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_270_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_2\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_34\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_273\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_276\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_277\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_275\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_4_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_282\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_272\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_ns_0_0_2[0]\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_37\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_39\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_40\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_12_i_0_0_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_283\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_10_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_2\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_11_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[12]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_5_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_2_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_27\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_6_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_6_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/CS_RNO_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_33\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_28\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_36\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_41\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_31\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_285\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[6]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_287\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_30\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_26\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_25\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_12_i\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_ns[0]\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_38\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_DELAYED_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_9_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_8_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[5]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_20\, 
        \MyDAC/MyAD5360/MyController/MyDAC/Busy_RNO_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d_1[27]\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[9]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[8]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[14]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[1]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[20]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[7]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_9_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_13\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i3_mux_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i3_mux\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_14\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_15_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_18\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_23_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i3_mux_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_288\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_289\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[3]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_36_mux\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_293\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_2\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_3\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_38_mux\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_294\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_3_0\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_39_mux\, 
        \MyDAC/MyAD5360/MyController/MyDAC/i6_mux\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[4]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_24\, 
        \MyDAC/MyAD5360/MyController/MyDAC/N_29\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[17]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[16]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[10]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[11]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[18]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[2]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[13]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[15]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[22]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[23]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[19]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[0]_net_1\, 
        \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_net_1\, 
        \MISO_pad/U0/NET1\, \DEBUG_CS_pad/U0/NET1\, 
        \DEBUG_CS_pad/U0/NET2\, \MOSI_pad/U0/NET1\, 
        \MOSI_pad/U0/NET2\, \NOT_BUSY_pad/U0/NET1\, 
        \NOT_OD_pad/U0/NET1\, \NOT_OD_pad/U0/NET2\, 
        \DEBUG_NOT_BIN_pad/U0/NET1\, \DEBUG_NOT_BIN_pad/U0/NET2\, 
        \SCLK_pad/U0/NET1\, \SCLK_pad/U0/NET2\, \Clk_pad/U0/NET1\, 
        \DEBUG_NOT_RESET_DAC_pad/U0/NET1\, 
        \DEBUG_NOT_RESET_DAC_pad/U0/NET2\, 
        \DEBUG_MISO_pad/U0/NET1\, \DEBUG_MISO_pad/U0/NET2\, 
        \DEBUG_GPIO_pad/U0/NET1\, \DEBUG_GPIO_pad/U0/NET2\, 
        \DEBUG_NOT_CLR_pad/U0/NET1\, \DEBUG_NOT_CLR_pad/U0/NET2\, 
        \NOT_LDAC_pad/U0/NET1\, \NOT_LDAC_pad/U0/NET2\, 
        \NOT_CLR_pad/U0/NET1\, \NOT_CLR_pad/U0/NET2\, 
        \NOT_BIN_pad/U0/NET1\, \NOT_BIN_pad/U0/NET2\, 
        \DEBUG_SCLK_pad/U0/NET1\, \DEBUG_SCLK_pad/U0/NET2\, 
        \DEBUG_NOT_PEC_pad/U0/NET1\, \DEBUG_NOT_PEC_pad/U0/NET2\, 
        \Reset_pad/U0/NET1\, \GPIO_pad/U0/NET1\, 
        \NOT_RESET_DAC_pad/U0/NET1\, \NOT_RESET_DAC_pad/U0/NET2\, 
        \CS_pad/U0/NET1\, \CS_pad/U0/NET2\, 
        \DEBUG_NOT_LDAC_pad/U0/NET1\, 
        \DEBUG_NOT_LDAC_pad/U0/NET2\, \NOT_PEC_pad/U0/NET1\, 
        \DEBUG_NOT_BUSY_pad/U0/NET1\, 
        \DEBUG_NOT_BUSY_pad/U0/NET2\, \DEBUG_MOSI_pad/U0/NET1\, 
        \DEBUG_MOSI_pad/U0/NET2\, AFLSDF_VCC, AFLSDF_GND
         : std_logic;
    signal GND_power_net1 : std_logic;
    signal VCC_power_net1 : std_logic;

begin 

    AFLSDF_GND <= GND_power_net1;
    \GND\ <= GND_power_net1;
    \VCC\ <= VCC_power_net1;
    AFLSDF_VCC <= VCC_power_net1;

    \MyDAC/TestGen/Counter[1]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n1\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[14]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[15]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[16]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[0]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[16]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[16]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/MyController/MyDAC/N_12_i\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[2]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[0]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_588\, B => 
        \MyDAC/MyPackageDis/dout[0]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[0]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[0]\);
    
    \MyDAC/MyPackageDis/Controller_Value[2]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[2]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[2]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO[3]\ : NOR3
      port map(A => \MyDAC/MyPackageDis/N_762\, B => 
        \MyDAC/MyPackageDis/N_807\, C => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0[3]\, Y
         => \MyDAC/MyPackageDis/N_723\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI4GBG1[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_87\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_3_0[0]\, C
         => \MyDAC/MyPackageDis/N_80\, Y => 
        \MyDAC/MyPackageDis/N_189\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIRA4H[3]\ : NOR3C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, C => 
        \MyDAC/MyPackageDis/N_742_i_1\, Y => 
        \MyDAC/MyPackageDis/N_182\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[31]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[31]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[31]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[0]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[0]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[0]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_13[0]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_2[1]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_3[1]\, B => 
        \MyDAC/MyPackageDis/Mode_07_Input_m[1]\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_9[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_12[1]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIUNC91[4]\ : AOI1B
      port map(A => \MyDAC/TestGen/N_34\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/G_1_0_0_0\);
    
    \MyDAC/TestGen/Counter_RNO[3]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c2\, B => 
        \MyDAC/TestGen/Counter[3]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n3\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIVJSL[0]\ : OR3B
      port map(A => \MyDAC/MyPackageDis/N_732_0\, B => 
        \MyDAC/MyPackageDis/N_86\, C => 
        \MyDAC/MyPackageDis/N_803_1\, Y => 
        \MyDAC/MyPackageDis/N_126\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI1FHF[1]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, B => 
        \MyDAC/MyPackageDis/N_83\, Y => 
        \MyDAC/MyPackageDis/N_818\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[23]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[23]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[23]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[18]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_1[18]\);
    
    \MyDAC/MyAD5360/MyController/Mode_09_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_09_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[19]\ : NOR3A
      port map(A => \MyDAC/PauseCounter[19]\, B => 
        \MyDAC/MyPackageDis/N_818\, C => 
        \MyDAC/MyPackageDis/N_743\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[19]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_01_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_01_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[3]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[2]_net_1\);
    
    \NOT_BIN_pad/U0/U0\ : IOPAD_TRI
      port map(D => \NOT_BIN_pad/U0/NET1\, E => 
        \NOT_BIN_pad/U0/NET2\, PAD => NOT_BIN);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[33]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[33]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[33]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIRL3N[19]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[19]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[19]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_19\);
    
    \MyDAC/MyPackageDis/Mode_02_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[5]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_02_Input[1]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_3[0]\ : NOR3A
      port map(A => \MyDAC/TestGen/N_75\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_5_1[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[7]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[7]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[19]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[19]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[19]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[0]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_267_0\, B => 
        \MyDAC/MyAD5360/N_366\, C => 
        \MyDAC/MyAD5360/ResetCounter[0]_net_1\, Y => 
        \MyDAC/MyAD5360/N_163\);
    
    \NOT_OD_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => \VCC\, E => \VCC\, DOUT => 
        \NOT_OD_pad/U0/NET1\, EOUT => \NOT_OD_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIFRUD[1]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_737\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIGSUD[1]\ : OR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_736\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[17]\ : OR3
      port map(A => \MyDAC/MyAD5360/MyController/N_1388\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, C => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIOUN7[17]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_ns[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[10]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[10]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[10]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[10]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[9]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[8]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[8]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[0]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[8]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI5R1M[11]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[11]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[16]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_1[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI32T21[0]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_768\, B => 
        \MyDAC/MyPackageDis/N_83\, Y => 
        \MyDAC/MyPackageDis/N_584\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI08I8_0[5]\ : NOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_233\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[10]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[10]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[2]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[12]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[12]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[12]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[12]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[3]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIBRNJ1[4]\ : NOR3B
      port map(A => \MyDAC/TestGen/N_75\, B => 
        \MyDAC/TestGen/N_418\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_49\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIAFULJ[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[10]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[10]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[14]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNICSNJ1[2]\ : NOR3B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/TestGen/N_418\, C => \MyDAC/TestGen/N_36\, Y
         => \MyDAC/TestGen/N_399\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[27]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[3]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[3]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO[1]\ : NOR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_1[1]\, B
         => \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0[1]\, 
        C => \MyDAC/MyPackageDis/N_829\, Y => 
        \MyDAC/MyPackageDis/N_727\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[2]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[2]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[2]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[2]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[9]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[9]_net_1\, B => 
        \MyDAC/MyAD5360/N_193\, C => \MyDAC/MyAD5360/N_267\, Y
         => \MyDAC/MyAD5360/N_48\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI9F2J\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, C => 
        \MyDAC/MyPackageDis/N_94\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/N_171\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[0]\ : 
        AO1
      port map(A => \MyDAC/MyAD5360/MyController/GPIO_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIEQUD_1[0]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_0[4]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/Controller_SetMode_18[0]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyPackageDis/N_629\, Q => 
        \MyDAC/Controller_SetMode_EXPORT[0]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_5[1]\ : AO1
      port map(A => \MyDAC/MyPackageDis/Mode_02_Input[1]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[28]\, C => 
        \MyDAC/MyPackageDis/Mode_06_Input_m[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_7[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI1GNU[2]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[3]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[2]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_2\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[7]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[16]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[16]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[16]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIFRUD[3]\ : XOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_728_i\);
    
    \MyDAC/MyAD5360/ResetCounter[24]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_147\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[24]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[15]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_2[0]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_3[0]\, B => 
        \MyDAC/MyPackageDis/Mode_02_Input_m[0]\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_9[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_12[0]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_10_0\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_10_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa_0_a2_0\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[2]\, B => 
        \MyDAC/Controller_Valid_EXPORT\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[0]\, Y => 
        \MyDAC/MyAD5360/MyController/N_54\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[38]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[38]_net_1\, B
         => \MyDAC/MyAD5360/N_507\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_21\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[2]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[23]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[7]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[23]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[23]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_7[0]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_223\, B => 
        \MyDAC/MyPackageDis/N_232\, C => 
        \MyDAC/MyPackageDis/Mode_04_Input[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_04_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[0]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output_m[0]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[0]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_4[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[3]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[3]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[3]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[3]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIKEGT[1]\ : AND3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/N_131\, C => 
        \MyDAC/MyPackageDis/N_104\, Y => 
        \MyDAC/MyPackageDis/N_148\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_12_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[8]_net_1\);
    
    \DEBUG_NOT_CLR_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => NOT_RESET_DAC_c_c, E => \VCC\, DOUT => 
        \DEBUG_NOT_CLR_pad/U0/NET1\, EOUT => 
        \DEBUG_NOT_CLR_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/CS\ : DFN1P0
      port map(D => 
        \MyDAC/MyAD5360/MyController/MyDAC/CS_RNO_net_1\, CLK => 
        Clk_c, PRE => Reset_c, Q => CS_c);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[24]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[0]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[0]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_12[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_822\, B => 
        \MyDAC/MyPackageDis/Mode_06_Input[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_94\, Y => 
        \MyDAC/MyPackageDis/Mode_06_Input_m[0]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNII0IS2[17]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_18\, B => 
        \MyDAC/MyAD5360/un11_resetcounter_17\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_15\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_27\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[10]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[2]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[2]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[15]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/N_200\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_22\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIE5911[34]\ : NOR3
      port map(A => \MyDAC/MyAD5360/ResetCounter[35]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[34]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[32]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_11[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5V8E3[1]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_0[4]\, B => 
        \MyDAC/MyPackageDis/N_163\, C => 
        \MyDAC/MyPackageDis/N_162\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_2[4]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIARM1C[23]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7KS6[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[8]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[8]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[7]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[7]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[7]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[12]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_01_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[3]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_01_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/GPIO\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/MyController/GPIO_RNO_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/GPIO_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[7]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[7]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[7]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[7]\);
    
    \DEBUG_NOT_BIN_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => \GND\, E => \VCC\, DOUT => 
        \DEBUG_NOT_BIN_pad/U0/NET1\, EOUT => 
        \DEBUG_NOT_BIN_pad/U0/NET2\);
    
    \MyDAC/MyPackageDis/Mode_04_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[1]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_04_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_6\ : 
        MX2
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_24\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_29\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_34\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIOU2U1[4]\ : NOR2A
      port map(A => \MyDAC/TestGen/N_64_1\, B => 
        \MyDAC/TestGen/N_38\, Y => \MyDAC/TestGen/N_398\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[23]\ : NOR3A
      port map(A => \MyDAC/PauseCounter[23]\, B => 
        \MyDAC/MyPackageDis/N_818\, C => 
        \MyDAC/MyPackageDis/N_743\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[23]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[23]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_06_Output_m[1]\, B => 
        \MyDAC/MyAD5360/MyController/Mode_03_Output_m[1]\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[23]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[23]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[10]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[10]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[10]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[10]\);
    
    \MyDAC/MyPackageDis/Mode_14_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[4]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_14_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_0[0]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/N_366\, B => 
        \MyDAC/MyAD5360/ResetCounter[0]_net_1\, Y => 
        \MyDAC/MyAD5360/N_285\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIIDM6\ : 
        NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/N_152\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_3[1]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_240\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_813\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_1[35]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[31]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[32]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m1_e_7_0\);
    
    \MyDAC/MyPackageDis/Controller_Value[7]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[7]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[15]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[25]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[1]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[1]\);
    
    \MyDAC/MyPackageDis/Mode_09_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[2]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_09_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[39]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/N_507\, B => 
        \MyDAC/MyAD5360/ResetCounter[39]_net_1\, Y => 
        \MyDAC/MyAD5360/N_305\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[2]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[2]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[2]_net_1\);
    
    \MyDAC/MyAD5360/Controller_Wait\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_266\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/Controller_Wait_i_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[6]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[6]\);
    
    \MyDAC/MyPackageDis/Mode_01_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[2]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_01_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[0]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_0[0]_net_1\, CLK => 
        Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[18]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[18]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[18]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[0]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_01_Output_m[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[0]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[2]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[2]_net_1\, B => 
        \MyDAC/TestGen/Counter[10]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_143\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_3[0]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_826\, B => 
        \MyDAC/MyPackageDis/N_108\, Y => 
        \MyDAC/MyPackageDis/N_203\);
    
    \MyDAC/MyAD5360/MyController/Mode_15_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_15_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[4]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[4]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[4]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI6IBG1[5]\ : OA1A
      port map(A => \MyDAC/MyPackageDis/N_94\, B => 
        \MyDAC/MyPackageDis/N_80\, C => 
        \MyDAC/MyPackageDis/N_233\, Y => 
        \MyDAC/MyPackageDis/N_175\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[1]\ : AO1
      port map(A => \MyDAC/PauseCounter[1]\, B => 
        \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/dout_m[1]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[23]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[23]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[23]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[23]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[23]\);
    
    \Reset_pad/U0/U0\ : IOPAD_IN
      port map(PAD => Reset, Y => \Reset_pad/U0/NET1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[16]\ : NOR3A
      port map(A => \MyDAC/PauseCounter[16]\, B => 
        \MyDAC/MyPackageDis/N_818\, C => 
        \MyDAC/MyPackageDis/N_743\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[16]\);
    
    \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa_0_a2\ : 
        NOR3A
      port map(A => \MyDAC/MyAD5360/MyController/N_50\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5H1P7[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_1[34]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[33]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[31]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIB9Q52[2]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_791\, B => 
        \MyDAC/MyPackageDis/N_790\, C => 
        \MyDAC/MyPackageDis/N_822\, Y => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_13_i_3\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_5[0]\ : AO1
      port map(A => \MyDAC/MyPackageDis/Mode_07_Input[0]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[29]\, C => 
        \MyDAC/MyPackageDis/Mode_06_Input_m[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_7[0]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIPJ3N[18]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[18]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[18]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_18\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_2\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[1]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_28\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[12]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[12]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[12]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[15]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_16[1]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_14_Input_m[1]\, B
         => \MyDAC/MyPackageDis/Mode_15_Input_m[1]\, C => 
        \MyDAC/MyPackageDis/Mode_00_Input_m[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_1[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIR3C22[22]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m3_0_a2_1\, B
         => \MyDAC/MyAD5360/ResetCounter_m3_0_a2_0\, C => 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_2\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_4\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[6]\ : OA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[5]_net_1\, B => 
        \MyDAC/MyAD5360/N_189\, C => 
        \MyDAC/MyAD5360/ResetCounter[6]_net_1\, Y => 
        \MyDAC/MyAD5360/N_290\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[3]_net_1\);
    
    \Clk_pad/U0/U1\ : CLKIO
      port map(A => \Clk_pad/U0/NET1\, Y => Clk_c);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI26BO2[1]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_35\, B => 
        \MyDAC/MyAD5360/un11_resetcounter_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_20\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[3]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[3]\);
    
    \NOT_BIN_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => \GND\, E => \VCC\, DOUT => 
        \NOT_BIN_pad/U0/NET1\, EOUT => \NOT_BIN_pad/U0/NET2\);
    
    \MOSI_pad/U0/U0\ : IOPAD_TRI
      port map(D => \MOSI_pad/U0/NET1\, E => \MOSI_pad/U0/NET2\, 
        PAD => MOSI);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[12]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[12]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[10]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_07_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[7]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_07_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[26]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[26]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[26]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI32T21[4]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_242\, B => 
        \MyDAC/MyPackageDis/N_732\, Y => 
        \MyDAC/MyPackageDis/N_153\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIGSCR[7]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_2[20]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[1]\ : 
        AO1A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_i_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[1]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_64\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[1]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_02_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[4]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_02_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_15_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_15_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[16]\ : OA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/N_200\, C => 
        \MyDAC/MyAD5360/ResetCounter[16]_net_1\, Y => 
        \MyDAC/MyAD5360/N_279\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[0]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[0]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_12_Output_m[0]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_6[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[19]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[19]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[19]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI2P1L5[21]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_3\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_2\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_20\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_30\);
    
    \MyDAC/MyAD5360/MyController/Output_Valid_Last_RNI36FH\ : 
        NOR3B
      port map(A => \MyDAC/MyAD5360/Output_Busy_i_0\, B => 
        \MyDAC/MyAD5360/MyController/Output_Valid_Last_i_0\, C
         => \MyDAC/MyAD5360/MyController/Output_Valid_net_1\, Y
         => \MyDAC/MyAD5360/MyController/un3_output_busy\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[6]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[8]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI9TGM[0]\ : XO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_97\, Y => 
        \MyDAC/MyPackageDis/N_965\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIUMTR[0]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_131\, B => 
        \MyDAC/MyPackageDis/N_736\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_11_0[1]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIGSUD_0[1]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_234\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[8]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE[1]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_RNO[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIP19P1[1]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/N_234\, B => 
        \MyDAC/MyPackageDis/N_732\, C => 
        \MyDAC/MyPackageDis/N_91\, Y => 
        \MyDAC/MyPackageDis/N_172\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_33\, CLK => Clk_c, CLR => 
        Reset_c, Q => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[2]_net_1\);
    
    \DEBUG_CS\ : DFN1C0
      port map(D => CS_c, CLK => Clk_c, CLR => Reset_c, Q => 
        DEBUG_CS_c);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa_0_a2\ : 
        NOR3A
      port map(A => \MyDAC/MyAD5360/MyController/N_54\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\);
    
    \NOT_BUSY_pad/U0/U0\ : IOPAD_IN
      port map(PAD => NOT_BUSY, Y => \NOT_BUSY_pad/U0/NET1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_ns[2]\, CLK
         => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[3]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[3]\);
    
    \MyDAC/MyPackageDis/Controller_Value[9]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[1]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[7]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI8R183[3]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_85\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_9_0[2]\, C
         => \MyDAC/MyPackageDis/N_178\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_6[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI49O4[1]\ : NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_5_0[1]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIMQP91[20]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[20]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[20]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_2\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_8\);
    
    \MyDAC/MyAD5360/MyController/Mode_15_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_15_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[12]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_1[3]\ : OA1B
      port map(A => \MyDAC/TestGen/N_22\, B => 
        \MyDAC/TestGen/N_34\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/TestGen/N_57\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[34]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[34]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[34]\);
    
    \MyDAC/MyPackageDis/Mode_03_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[7]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_03_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMOTEA[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_187\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_7[0]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_10[0]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_12[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_08_Output_m[14]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[27]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[27]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[27]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_14_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_14_Output_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNIDRIG[2]\ : OA1B
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE[2]_net_1\, C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyAD5360/N_267\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[8]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[8]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[8]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[8]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[32]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[32]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[32]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIUE951[3]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[3]_net_1\, B => 
        \MyDAC/MyAD5360/PauseCounter_Output[3]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_5\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_9\);
    
    \MyDAC/MyAD5360/ResetCounter[8]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[2]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI2O3O[0]\ : XO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_90\, Y => 
        \MyDAC/MyPackageDis/N_122\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[9]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[9]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[5]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[6]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/PauseCounter[6]\, C => \MyDAC/MyPackageDis/N_743\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_11_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_11_Output_m[0]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[6]\ : MX2
      port map(A => \MyDAC/TestGen/N_115\, B => 
        \MyDAC/TestGen/N_147\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[6]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[25]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_734\, B => 
        \MyDAC/PauseCounter[25]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[1]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[25]\);
    
    \MyDAC/MyAD5360/ResetCounter[20]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[20]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[20]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_1[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_205\, B => 
        \MyDAC/MyPackageDis/N_203\, C => 
        \MyDAC/MyPackageDis/N_201\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_i_1[0]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[12]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[1]\, B => 
        \MyDAC/MyAD5360/MyController/N_53\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIB53N[11]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[11]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[11]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_11\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI6I7S[2]\ : 
        NOR2
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_20\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_40\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[9]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE[0]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_ns[0]\, CLK
         => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[28]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_155\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[28]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA[1]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[1]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIVB542[8]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[9]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_4\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_6\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI55L33[24]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_9[2]\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_8[2]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_17[2]\, Y
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_20[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_2\ : 
        OR3
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_276\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_277\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_275\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_2\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI1EMK[2]\ : NOR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_a3_1_0\);
    
    \MyDAC/TestGen/Counter_RNO[6]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[5]_net_1\, B => 
        \MyDAC/TestGen/Counter_c4\, C => 
        \MyDAC/TestGen/Counter[6]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n6\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[8]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[8]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIA35M[30]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[30]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[29]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_0\);
    
    \DEBUG_CS_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_CS_pad/U0/NET1\, E => 
        \DEBUG_CS_pad/U0/NET2\, PAD => DEBUG_CS);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[6]\ : OR2
      port map(A => \MyDAC/TestGen/N_397\, B => 
        \MyDAC/TestGen/N_398\, Y => \MyDAC/TestGen/N_115\);
    
    \MyDAC/MyPackageDis/Mode_15_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[7]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_15_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[4]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_1[4]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[1]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/dout[1]\, B => 
        \MyDAC/MyPackageDis/N_588\, Y => 
        \MyDAC/MyPackageDis/dout_m[1]\);
    
    \MyDAC/MyAD5360/NOT_LDAC\ : DFN1P0
      port map(D => \MyDAC/MyAD5360/N_38\, CLK => Clk_c, PRE => 
        Reset_c, Q => NOT_LDAC_c);
    
    \MyDAC/MyAD5360/ResetCounter_RNI7GS67[15]\ : OR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[16]_net_1\, C => 
        \MyDAC/MyAD5360/N_200\, Y => \MyDAC/MyAD5360/N_202\);
    
    \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/MyAD5360/MyController/N_50\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIBNUD[1]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_240\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[2]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[1]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_i_m[1]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_i_m[1]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[1]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[11]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[11]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[11]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[11]\);
    
    \MyDAC/MyAD5360/ResetCounter[39]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_19\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[39]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[2]\ : AO1
      port map(A => \MyDAC/PauseCounter[2]\, B => 
        \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/dout_m[2]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[19]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[18]_net_1\, B
         => \MyDAC/MyAD5360/N_203\, Y => \MyDAC/MyAD5360/N_204\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[8]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[8]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[2]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[2]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[2]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[24]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[24]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[24]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[6]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[6]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[6]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIHK1V[1]\ : NOR2B
      port map(A => \MyDAC/TestGen/N_486_1\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[35]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[35]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[35]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[19]\ : OA1C
      port map(A => \MyDAC/MyAD5360/N_204\, B => 
        \MyDAC/MyAD5360/ResetCounter[19]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_n19_i_0\, Y => 
        \MyDAC/MyAD5360/N_86\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[5]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[5]\);
    
    \MyDAC/TestGen/Counter_RNO[13]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c12\, B => 
        \MyDAC/TestGen/Counter[13]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n13\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI65T21[5]\ : AND3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/N_97\, C => \MyDAC/MyPackageDis/N_92\, 
        Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_2_1[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[21]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[21]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[21]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[26]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[26]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[26]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[20]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[20]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[20]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[5]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[2]\ : MX2A
      port map(A => \MyDAC/TestGen/N_351\, B => 
        \MyDAC/TestGen/N_143\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[15]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[15]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[15]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[15]\);
    
    \MyDAC/MyPackageDis/Mode_07_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[6]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_07_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7NO4[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNICLHC1[0]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_4_0[1]\, B
         => \MyDAC/MyPackageDis/N_85\, Y => 
        \MyDAC/MyPackageDis/N_149\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_7[1]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_223\, B => 
        \MyDAC/MyPackageDis/N_232\, C => 
        \MyDAC/MyPackageDis/Mode_04_Input[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_04_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIK5FN1[32]\ : NOR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0_0\, B
         => \MyDAC/MyAD5360/ResetCounter[32]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_n34_i_0_o2_0_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0_2\);
    
    \MyDAC/MyAD5360/ResetCounter[21]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_31\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[21]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[15]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[15]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[15]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[11]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[11]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[3]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[11]\);
    
    \MyDAC/MyAD5360/ResetCounter[6]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_07_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_07_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIURP01[1]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/N_80\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[8]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_VALID_RNO\ : NOR3
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, B => 
        \MyDAC/TestGen/N_391\, C => \MyDAC/INPUT_FULL\, Y => 
        \MyDAC/TestGen/INPUT_DATA_VALID_RNO_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[5]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[5]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIN2IN3\ : 
        OR3
      port map(A => 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_i_i_0[3]\, 
        B => \MyDAC/MyPackageDis/MyFIFO/N_168\, C => 
        \MyDAC/MyPackageDis/N_170\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_2[3]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[28]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[28]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[28]_net_1\);
    
    \MyDAC/MyAD5360/SPI_START\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_9\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/SPI_START_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_10_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_10_Output_m[1]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI3HHF[3]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_84\, Y => 
        \MyDAC/MyPackageDis/N_125\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNITP5N[29]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[29]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[29]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_29\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[5]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_5\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_26\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_5_0\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_36\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_275\);
    
    \MyDAC/TestGen/INPUT_DATA[8]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_d[49]\, CLK
         => Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[8]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI029O2[4]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_4\, B => 
        \MyDAC/MyAD5360/un11_resetcounter_31\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_19\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_29\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIAD53[0]\ : OR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_732_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIUD4H[1]\ : OA1C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, C => 
        \MyDAC/MyPackageDis/N_88\, Y => 
        \MyDAC/MyPackageDis/N_163\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_2[2]\ : NOR2B
      port map(A => \MyDAC/TestGen/N_415\, B => 
        \MyDAC/TestGen/N_412\, Y => \MyDAC/TestGen/N_392\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[15]_net_1\);
    
    \DEBUG_NOT_RESET_DAC\ : DFN1C0
      port map(D => NOT_RESET_DAC_c_c, CLK => Clk_c, CLR => 
        Reset_c, Q => DEBUG_NOT_RESET_DAC_c);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_12_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[1]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_12_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/MyAD5360/MyController/N_53\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\);
    
    \DEBUG_NOT_LDAC_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_NOT_LDAC_pad/U0/NET1\, E => 
        \DEBUG_NOT_LDAC_pad/U0/NET2\, PAD => DEBUG_NOT_LDAC);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[4]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI4CQI[3]\ : 
        XNOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_14\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[14]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[1]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIEGFM9[0]\ : OR3
      port map(A => \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_1\, B
         => \MyDAC/TestGen/N_47\, C => \MyDAC/TestGen/N_46\, Y
         => \MyDAC/TestGen/un1_SPIMACHINE_STATE\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[5]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[5]_net_1\, B => 
        \MyDAC/MyAD5360/N_189\, C => \MyDAC/MyAD5360/N_267\, Y
         => \MyDAC/MyAD5360/ResetCounter_RNO[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_Value[5]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[5]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[5]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI29FB1[4]\ : AOI1B
      port map(A => \MyDAC/MyPackageDis/N_87\, B => 
        \MyDAC/MyPackageDis/N_736\, C => 
        \MyDAC/MyPackageDis/N_244\, Y => 
        \MyDAC/MyPackageDis/N_185\);
    
    \MyDAC/MyAD5360/MyController/Output_Valid_Last_RNO\ : INV
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_Valid_net_1\, Y => 
        \MyDAC/MyAD5360/MyController/Output_Valid_i\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[17]\ : 
        OR3C
      port map(A => \MyDAC/MyAD5360/MyController/N_1426\, B => 
        \MyDAC/MyAD5360/MyController/N_1385_1\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_i_a2_2[17]\, 
        Y => \MyDAC/MyAD5360/MyController/N_1385\);
    
    \MyDAC/MyAD5360/MyController/Output_Valid\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/MyController/Output_Valid_3\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/Output_Valid_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[11]_net_1\);
    
    \NOT_RESET_DAC_pad/U0/U0\ : IOPAD_TRI
      port map(D => \NOT_RESET_DAC_pad/U0/NET1\, E => 
        \NOT_RESET_DAC_pad/U0/NET2\, PAD => NOT_RESET_DAC);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[10]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_267\, B => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_2\, C => 
        \MyDAC/MyAD5360/N_271\, Y => \MyDAC/MyAD5360/N_50\);
    
    \MyDAC/MyAD5360/ResetCounter_RNITBNU[1]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[1]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[0]_net_1\, Y => 
        \MyDAC/MyAD5360/N_186\);
    
    \MyDAC/MyAD5360/ResetCounter[16]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_20\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[16]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI6VAE1[21]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[21]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[21]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_27\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_3\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[23]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_04_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_07_Output_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[23]\);
    
    \MyDAC/MyAD5360/MyController/Mode_12_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_12_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[4]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[4]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[4]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[4]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI67Q13\ : 
        OR3
      port map(A => \MyDAC/MyPackageDis/MyFIFO/N_190\, B => 
        \MyDAC/MyPackageDis/MyFIFO/N_194\, C => 
        \MyDAC/MyPackageDis/N_192\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_2[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[3]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[8]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[0]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[0]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[37]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[37]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[37]\);
    
    \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa_0_a2\ : 
        NOR3C
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, C => 
        \MyDAC/MyAD5360/MyController/N_50\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[17]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[17]_net_1\, B
         => \MyDAC/MyAD5360/N_202\, C => \MyDAC/MyAD5360/N_267\, 
        Y => \MyDAC/MyAD5360/N_18\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[14]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE[4]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_RNO[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[18]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[18]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[18]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE[3]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_RNO[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI4GBG1[0]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_80\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_90\, Y => 
        \MyDAC/MyPackageDis/N_188\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[4]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_732_0\, B => 
        \MyDAC/PauseCounter[4]\, C => \MyDAC/MyPackageDis/N_743\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[11]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO[4]\ : MX2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, S => 
        \MyDAC/TestGen/N_28\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[4]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNISKTR[1]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_84\, B => 
        \MyDAC/MyPackageDis/N_736\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_9_0[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[1]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_VALID_RNO_0\ : NOR2B
      port map(A => \MyDAC/TestGen/N_417\, B => 
        \MyDAC/TestGen/N_412\, Y => \MyDAC/TestGen/N_391\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[28]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[4]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[4]\);
    
    \MyDAC/MyPackageDis/Mode_05_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[2]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_05_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMGGT[4]\ : OA1C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_6_0[2]\, C
         => \MyDAC/MyPackageDis/N_83\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_1[2]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNICQPCC[31]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_13_mux\, B => 
        \MyDAC/MyAD5360/ResetCounter[31]_net_1\, Y => 
        \MyDAC/MyAD5360/N_501\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNINL7N[35]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[35]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[35]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_35\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI0OHBB[28]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_7_mux_0_0\, B
         => \MyDAC/MyAD5360/ResetCounter[28]_net_1\, Y => 
        \MyDAC/MyAD5360/N_215\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[6]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[6]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[11]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[11]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[11]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[11]\);
    
    \MyDAC/TestGen/INPUT_DATA[2]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[2]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[4]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNILNQ72[1]\ : MX2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_3_0[4]\, B
         => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_2_0[4]\, S
         => \MyDAC/MyPackageDis/N_85\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_3[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[11]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNILC682[1]\ : OA1B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_0[3]\, B
         => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_5_1[3]\, C
         => \MyDAC/MyPackageDis/N_91\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_4[3]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[15]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[11]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNII38Q2[3]\ : OA1B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_11_0[1]\, 
        B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_12_0[1]\, 
        C => \MyDAC/MyPackageDis/N_85\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNII38Q2[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[13]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIAFULJ[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[12]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[12]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_0\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[8]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_26\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[34]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[34]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[34]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_4[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, C => 
        \MyDAC/MyPackageDis/N_92\, Y => 
        \MyDAC/MyPackageDis/N_201\);
    
    \MyDAC/MyAD5360/ResetCounter[4]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[0]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNICSNJ1[0]\ : NOR3A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/TestGen/N_36\, C => \MyDAC/TestGen/N_34\, Y
         => \MyDAC/TestGen/N_50\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[0]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[0]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[0]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[1]\ : OR3
      port map(A => \MyDAC/TestGen/N_388\, B => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_0[1]\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Y => 
        \MyDAC/TestGen/N_347\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNINH3N[17]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[17]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[17]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_17\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[3]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_1[2]\ : OA1C
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, B
         => \MyDAC/TestGen/N_22\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_0[2]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_4[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_232\, B => 
        \MyDAC/MyPackageDis/Mode_08_Input[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_94\, Y => 
        \MyDAC/MyPackageDis/Mode_08_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNI1NMH[13]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/N_1426\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_05_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_05_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[15]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[15]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[15]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_11_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[7]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_11_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_09_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_09_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[4]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[4]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIT4I8[1]\ : XNOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_87\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[7]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_15\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[15]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_14_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[5]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_14_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIJD6M[38]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[39]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[38]_net_1\, Y => 
        \MyDAC/MyAD5360/N_326\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNITMC91[0]\ : NOR2B
      port map(A => \MyDAC/TestGen/N_417\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/TestGen/N_419\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[33]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[33]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[33]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIIFD51[10]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[10]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[12]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[4]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_4\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[5]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[15]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[15]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[15]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[15]\);
    
    \MyDAC/MyAD5360/ResetCounter[13]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_68\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[13]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA[6]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[6]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[6]\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO_3\ : NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_a6_2_0\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_0[1]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_131\, B => 
        \MyDAC/MyPackageDis/N_97\, C => 
        \MyDAC/MyPackageDis/N_814\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_1[1]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[35]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[35]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[35]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_7\ : 
        NOR3B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[6]_net_1\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_287\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_277\);
    
    \MyDAC/MyAD5360/MyController/Mode_08_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_08_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[1]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[1]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[17]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[1]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[17]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[17]\);
    
    \MyDAC/MyAD5360/MyController/Mode_01_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_01_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNILTIK3[1]\ : AO1
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_0[1]\, B
         => \MyDAC/MyPackageDis/N_138\, C => 
        \MyDAC/MyPackageDis/N_153\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_6[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[13]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIKVRG1[4]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_88\, B => 
        \MyDAC/MyPackageDis/N_742_i_1\, C => 
        \MyDAC/MyPackageDis/N_244\, Y => 
        \MyDAC/MyPackageDis/N_138\);
    
    \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa_0_a2\ : 
        NOR3C
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, C => 
        \MyDAC/MyAD5360/MyController/N_54\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa_0_a2\ : 
        NOR3A
      port map(A => \MyDAC/MyAD5360/MyController/N_49\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNILH5N[25]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[25]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[25]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_25\);
    
    \MyDAC/MyPackageDis/Mode_11_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[6]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_11_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[1]_net_1\);
    
    \Reset_pad/U0/U1\ : CLKIO
      port map(A => \Reset_pad/U0/NET1\, Y => Reset_c);
    
    \MyDAC/MyPackageDis/Controller_Value[15]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[7]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO[0]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_i_2[0]\, 
        B => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_i_1[0]\, 
        C => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[25]\, Y => 
        \MyDAC/MyPackageDis/N_962\);
    
    \MyDAC/MyPackageDis/Controller_Value[8]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[0]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[8]\);
    
    \DEBUG_NOT_PEC_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_NOT_PEC_c, E => \VCC\, DOUT => 
        \DEBUG_NOT_PEC_pad/U0/NET1\, EOUT => 
        \DEBUG_NOT_PEC_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[7]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNILTKI[7]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[7]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[7]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_7\);
    
    \MyDAC/MyAD5360/MyController/Mode_07_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_07_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[14]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI1EAD[1]\ : NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, C => 
        \MyDAC/MyPackageDis/N_966\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_0[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[9]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIR7MK_1[0]\ : NOR2
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/N_412\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNICKD08[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/Controller_Value_119_e_0\, 
        B => \MyDAC/MyPackageDis/N_631\, C => 
        \MyDAC/MyPackageDis/N_794\, Y => 
        \MyDAC/MyPackageDis/N_977\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIS08J1\ : 
        NOR2A
      port map(A => \MyDAC/MyPackageDis/N_126\, B => 
        \MyDAC/MyPackageDis/N_99\, Y => 
        \MyDAC/MyPackageDis/N_968\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_1\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[15]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_27\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIQHMP[5]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_147_1\, B => 
        \MyDAC/MyPackageDis/N_108\, Y => 
        \MyDAC/MyPackageDis/N_147\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[38]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[6]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[38]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[38]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[14]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]\ : 
        DFN1C0
      port map(D => \MyDAC/MyAD5360/MyController/MyDAC/N_23_0\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[11]_net_1\);
    
    \MOSI_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => MOSI_c, E => \VCC\, DOUT => 
        \MOSI_pad/U0/NET1\, EOUT => \MOSI_pad/U0/NET2\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[28]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[28]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[28]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[32]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[32]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[32]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[5]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[5]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[5]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[5]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_8[1]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_12_Input_m[1]\, B
         => \MyDAC/MyPackageDis/Mode_11_Input_m[1]\, C => 
        \MyDAC/MyPackageDis/Mode_01_Input_m[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_4[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[13]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[13]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\, C => 
        \MyDAC/MyAD5360/N_267\, Y => \MyDAC/MyAD5360/N_68\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[3]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI1EAD[5]\ : NOR3C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, C => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_15_i_a6_0\, Y
         => \MyDAC/MyPackageDis/N_793\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[16]\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_1[16]\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_2[16]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[11]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[11]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI5R1M_0[13]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[13]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[14]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_5[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[3]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI97FT1[7]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[5]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[7]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_2\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_5\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_1[0]\ : 
        NOR3A
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_20\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_38\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI8PMA5[12]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_4[1]\, 
        B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_5[1]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_1[2]\, 
        Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_2[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_5[1]\ : 
        XOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_293\);
    
    \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/MyAD5360/MyController/N_49\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_8[0]\ : NOR3A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, C => 
        \MyDAC/TestGen/N_20_i\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_1_0[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNICOUD[0]\ : OR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_732\);
    
    \MyDAC/MyPackageDis/Controller_SPIACTION_INTERNAL_RNO\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_207\, B => 
        \MyDAC/MyPackageDis/N_247\, Y => 
        \MyDAC/MyPackageDis/N_963\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_2[5]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_0[2]\, 
        B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_1[2]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_0[1]\, 
        Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_1[1]\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO_0\ : OA1B
      port map(A => \MyDAC/MyPackageDis/N_803_1\, B => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_a6_2_0\, C
         => \MyDAC/MyPackageDis/N_91\, Y => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_0\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[4]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_33\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_12_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[0]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_12_Input[0]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[0]\ : OR3
      port map(A => \MyDAC/TestGen/INPUT_DATA_15k_0_0_0[0]\, B
         => \MyDAC/TestGen/N_399\, C => \MyDAC/TestGen/N_419\, Y
         => \MyDAC/TestGen/N_109\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[13]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[13]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_2_0\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_2_0\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_2[1]\ : OA1C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_814\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[1]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_267_0\, B => 
        \MyDAC/MyAD5360/N_366\, C => 
        \MyDAC/MyAD5360/ResetCounter_n1_i_0_0\, Y => 
        \MyDAC/MyAD5360/N_64\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIO7LHR[3]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_33\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_32\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_37\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_i\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_02_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_02_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[14]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIVBMK[2]\ : XOR2
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/TestGen/N_20_i\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIQIVO5[13]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_13\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_12\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_27\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_33\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[3]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[3]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[10]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[10]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[3]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_588\, B => 
        \MyDAC/MyPackageDis/dout[3]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[3]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[3]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[14]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[14]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[6]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[14]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/CS_RNO\ : NOR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_33\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/CS_RNO_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[4]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[4]_net_1\, B => 
        \MyDAC/TestGen/Counter[12]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_145\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIGLQC2[4]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[4]_net_1\, B => 
        \MyDAC/MyAD5360/N_188\, Y => \MyDAC/MyAD5360/N_189\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[1]\ : 
        AO1A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_i_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[1]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[1]\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_10\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_285\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_10_0\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_283\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_280\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[13]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[29]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_734\, B => 
        \MyDAC/PauseCounter[29]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[5]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[29]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIQC4D1\ : 
        AO1
      port map(A => 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_i_i_a2_1_0[3]\, 
        B => \MyDAC/MyPackageDis/N_736\, C => 
        \MyDAC/MyPackageDis/MyFIFO/N_171\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_i_i_0[3]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_3\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_2\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_28\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_36\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_273\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[36]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[36]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[36]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[11]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[11]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[11]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[11]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[15]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[5]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[5]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[5]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[5]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNINHGT[4]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_238\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, C => 
        \MyDAC/MyPackageDis/N_223\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_5_1[3]\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNIAH8GB1[0]\ : AO1A
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_i\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[0]_net_1\, C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_0[2]\, Y => 
        \MyDAC/MyAD5360/N_33\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[7]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[7]_net_1\, B => 
        \MyDAC/TestGen/Counter[15]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_148\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[5]\ : OR3
      port map(A => \MyDAC/TestGen/N_398\, B => 
        \MyDAC/TestGen/N_399\, C => \MyDAC/TestGen/N_400\, Y => 
        \MyDAC/TestGen/N_114\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[8]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_0[0]\ : OA1B
      port map(A => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_5_1[0]\, B => 
        \MyDAC/TestGen/N_486_1\, C => \MyDAC/INPUT_FULL\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_1_0[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[21]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_322\, B => 
        \MyDAC/MyAD5360/N_267\, C => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, Y => 
        \MyDAC/MyAD5360/N_31\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_4\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[17]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[16]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_31\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO[1]\ : NOR3
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_0[1]\, 
        B => \MyDAC/TestGen/N_52\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_1[1]\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[12]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[4]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_6\ : 
        AO1
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_32\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_270_1\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_2\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_6\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIR7MK[0]\ : XNOR2
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/TestGen/N_33\);
    
    \MyDAC/MyAD5360/MyController/Mode_03_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_03_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[22]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_06_Output_m[0]\, B => 
        \MyDAC/MyAD5360/MyController/Mode_03_Output_m[0]\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[22]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[22]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[3]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIEO4T2[4]\ : OA1
      port map(A => \MyDAC/TestGen/N_68\, B => 
        \MyDAC/TestGen/N_69\, C => \MyDAC/TestGen/N_33\, Y => 
        \MyDAC/TestGen/N_47\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI903M[25]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[25]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_8[2]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO[0]\ : OR3
      port map(A => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_1_0[0]\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_0[0]\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_2[0]\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI32T21_1[4]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_242\, B => 
        \MyDAC/MyPackageDis/N_83\, Y => 
        \MyDAC/MyPackageDis/N_192\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_LAST_RNI3VS84\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_80\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_2_1[2]\, C
         => \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_2[2]\, Y
         => \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_3[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[6]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[6]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[6]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_1[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_05_Input_m[0]\, B
         => \MyDAC/MyPackageDis/Mode_04_Input_m[0]\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_4[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_10[0]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[0]\ : 
        NOR3C
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_283\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_41\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[11]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_13_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[3]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_13_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[23]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[23]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[23]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[23]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[23]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIDIS91_0[1]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/N_742_i_1\, B => 
        \MyDAC/MyPackageDis/N_88\, C => \MyDAC/MyPackageDis/N_97\, 
        Y => \MyDAC/MyPackageDis/N_197\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[12]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[12]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[4]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[12]\);
    
    \MyDAC/MyAD5360/ResetCounter[2]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[2]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNISFPI2[4]\ : AO1
      port map(A => \MyDAC/TestGen/N_411\, B => 
        \MyDAC/TestGen/N_418\, C => \MyDAC/TestGen/N_66\, Y => 
        \MyDAC/TestGen/N_388\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI95AB1_0\ : 
        NOR2A
      port map(A => \MyDAC/MyPackageDis/N_91\, B => 
        \MyDAC/MyPackageDis/N_732\, Y => 
        \MyDAC/MyPackageDis/N_187\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI6J4C1[12]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[20]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[12]_net_1\, C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_1[1]\, 
        Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_4[1]\);
    
    \MyDAC/MyAD5360/MyController/Mode_04_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_04_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[7]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIN9UK_0[3]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_737\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_768\);
    
    \MyDAC/MyAD5360/MyController/Mode_02_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_02_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5H1P7[1]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_172\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_2[3]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_4[3]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5H1P7[1]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_18[1]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_240\, B => 
        \MyDAC/MyPackageDis/Mode_14_Input[1]_net_1\, C => 
        \MyDAC/MyPackageDis/N_108\, Y => 
        \MyDAC/MyPackageDis/Mode_14_Input_m[1]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[33]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[33]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[33]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[6]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_3[1]\ : MX2
      port map(A => \MyDAC/TestGen/N_69_1\, B => 
        \MyDAC/TestGen/N_411\, S => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_2_tz[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[14]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[14]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[14]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[14]\);
    
    \MyDAC/TestGen/Counter[12]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n12\, CLK => Clk_c, 
        CLR => Reset_c, E => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Q => 
        \MyDAC/TestGen/Counter[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[9]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[9]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI41E82[3]\ : AO1C
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/TestGen/N_38\, C => \MyDAC/TestGen/N_34\, Y
         => \MyDAC/TestGen/N_393\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[1]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[1]_net_1\, B => 
        \MyDAC/TestGen/Counter[9]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_142\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIQVPK1[17]\ : NOR3A
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_5[5]\, B
         => \MyDAC/MyAD5360/ResetCounter[18]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[17]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_9[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[2]_net_1\);
    
    \DEBUG_MOSI\ : DFN1C0
      port map(D => MOSI_c, CLK => Clk_c, CLR => Reset_c, Q => 
        DEBUG_MOSI_c);
    
    \NOT_LDAC_pad/U0/U0\ : IOPAD_TRI
      port map(D => \NOT_LDAC_pad/U0/NET1\, E => 
        \NOT_LDAC_pad/U0/NET2\, PAD => NOT_LDAC);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNILF3N[16]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[16]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[16]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_16\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[4]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[6]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[6]_net_1\, B => 
        \MyDAC/TestGen/Counter[14]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_147\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[14]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[14]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[8]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/N_192\, C => \MyDAC/MyAD5360/N_267\, Y
         => \MyDAC/MyAD5360/ResetCounter_RNO[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[13]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_19[1]\ : NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/Mode_15_Input[1]_net_1\, C => 
        \MyDAC/MyPackageDis/N_108\, Y => 
        \MyDAC/MyPackageDis/Mode_15_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIJVUD_0[5]\ : OR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_88\);
    
    \DEBUG_NOT_PEC\ : DFN1C0
      port map(D => NOT_PEC_c, CLK => Clk_c, CLR => Reset_c, Q
         => DEBUG_NOT_PEC_c);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI27O4[0]\ : NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_803_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Mode_01_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_01_Input[1]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[7]\ : MX2A
      port map(A => \MyDAC/TestGen/N_355\, B => 
        \MyDAC/TestGen/N_148\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[7]\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[3]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_165\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/SPIMACHINE_STATE[3]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNICHQ91[8]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/PauseCounter_Output[8]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_25\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_16\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNISB04[17]\ : 
        CLKINT
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_0[17]\, Y
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[2]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIUMTR[1]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_240\, B => 
        \MyDAC/MyPackageDis/N_88\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_4_0[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]\ : 
        DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNII3NI[1]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_5_0[1]\, B
         => \MyDAC/MyPackageDis/N_92\, Y => 
        \MyDAC/MyPackageDis/N_150\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[26]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_749\, B => 
        \MyDAC/PauseCounter[26]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[2]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[26]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIPBUK[5]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_737\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_740\);
    
    \MyDAC/MyAD5360/ResetCounter[17]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_18\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[17]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIUMAE1[33]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[33]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[33]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_11\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_11\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[19]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[19]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[19]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[8]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[8]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_08_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_08_Output_m[0]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[20]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[20]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[20]\);
    
    \DEBUG_SCLK_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_SCLK_c, E => \VCC\, DOUT => 
        \DEBUG_SCLK_pad/U0/NET1\, EOUT => 
        \DEBUG_SCLK_pad/U0/NET2\);
    
    \MyDAC/TestGen/Counter[11]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n11\, CLK => Clk_c, 
        CLR => Reset_c, E => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Q => 
        \MyDAC/TestGen/Counter[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[3]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[3]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNICNNB[0]\ : NOR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_104\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_4_0[1]\);
    
    \MyDAC/MyAD5360/ResetCounter[34]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_12\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[34]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[6]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[16]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_1[16]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_6[1]\ : 
        XNOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_0\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI4QA33[19]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_4\, B
         => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_3\, C => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_5\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_7\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[6]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIT9MK[2]\ : OR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/N_34\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_16[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_14_Input_m[0]\, B
         => \MyDAC/MyPackageDis/Mode_15_Input_m[0]\, C => 
        \MyDAC/MyPackageDis/Mode_00_Input_m[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_1[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_08_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIQVPK1[8]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[9]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_3\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_5[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[4]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[4]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[4]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[7]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[7]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNITNJ91\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, C => 
        \MyDAC/MyPackageDis/N_117\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/N_168\);
    
    \MyDAC/MyPackageDis/Mode_06_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[5]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_06_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI0L6E1[13]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[13]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[13]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_14\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_12\);
    
    \MyDAC/TestGen/Counter[2]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n2\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[2]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_0_0\ : 
        NOR2A
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_2\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_0\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIDV6N1[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_789\, B => 
        \MyDAC/MyPackageDis/N_792\, C => 
        \MyDAC/MyPackageDis/N_141\, Y => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_13_i_2\);
    
    \MyDAC/TestGen/Counter[8]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n8\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[8]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_3[0]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/N_232\, C => 
        \MyDAC/MyPackageDis/Mode_09_Input[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_09_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[11]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI125J[2]\ : OA1
      port map(A => \MyDAC/MyPackageDis/N_736\, B => 
        \MyDAC/Controller_Wait_i_0\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_13_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[2]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[2]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[2]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[2]\);
    
    \MyDAC/MyPackageDis/Controller_Value[13]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[5]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[13]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[8]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[33]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[1]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[33]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[33]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[5]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[5]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_13[1]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_826\, B => 
        \MyDAC/MyPackageDis/N_829\, C => 
        \MyDAC/MyPackageDis/Mode_12_Input[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_12_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_00_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_00_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO[3]\ : AO1A
      port map(A => \MyDAC/MyAD5360/un3_controller_busy\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[3]_net_1\, C => 
        \MyDAC/MyAD5360/N_266\, Y => \MyDAC/MyAD5360/N_165\);
    
    \DEBUG_NOT_LDAC\ : DFN1C0
      port map(D => NOT_LDAC_c, CLK => Clk_c, CLR => Reset_c, Q
         => DEBUG_NOT_LDAC_c);
    
    \MyDAC/MyPackageDis/Controller_Value[4]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[4]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[5]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/PauseCounter[5]\, C => \MyDAC/MyPackageDis/N_743\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[5]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[20]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[4]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[20]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[20]\);
    
    \NOT_PEC_pad/U0/U0\ : IOPAD_IN
      port map(PAD => NOT_PEC, Y => \NOT_PEC_pad/U0/NET1\);
    
    \MyDAC/TestGen/Counter_RNO[4]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[3]_net_1\, B => 
        \MyDAC/TestGen/Counter_c2\, C => 
        \MyDAC/TestGen/Counter[4]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n4\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI54T21[1]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_86\, B => 
        \MyDAC/MyPackageDis/N_110\, Y => 
        \MyDAC/MyPackageDis/N_151\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNISSF41[3]\ : OR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_83\, C => 
        \MyDAC/MyPackageDis/N_740\, Y => 
        \MyDAC/MyPackageDis/N_598\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIGNUA1[1]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_125\, B => 
        \MyDAC/MyPackageDis/N_80\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_146\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[11]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[7]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIOOO62[3]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_230\, B => 
        \MyDAC/MyPackageDis/N_231\, C => 
        \MyDAC/MyPackageDis/N_225\, Y => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_12_i_0_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[7]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[7]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIN9UK[4]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_223\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_242\);
    
    \MyDAC/MyAD5360/MyController/Mode_03_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_03_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_14_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_14_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[0]_net_1\);
    
    INT_ULSICC_INSTANCE_0 : ULSICC_INT
      port map(USTDBY => \GND\, LPENA => \GND\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[6]\ : NOR3A
      port map(A => \MyDAC/MyAD5360/N_191\, B => 
        \MyDAC/MyAD5360/N_290\, C => \MyDAC/MyAD5360/N_267_0\, Y
         => \MyDAC/MyAD5360/ResetCounter_RNO[6]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[31]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[31]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => \MyDAC/MyAD5360/N_161\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[6]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[6]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[6]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[6]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_15[0]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/N_141\, C => 
        \MyDAC/MyPackageDis/Mode_01_Input[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_01_Input_m[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIAFULJ[4]\ : NOR3
      port map(A => \MyDAC/MyPackageDis/N_155\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_9[1]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_10[1]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIAFULJ[4]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNISMV78[17]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m4_0_a2_5\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_9_mux_2\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[5]\ : MX2
      port map(A => \MyDAC/TestGen/N_114\, B => 
        \MyDAC/TestGen/N_146\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[5]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNICJL19[13]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_19[2]\, B
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_18[2]\, C
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_20[2]\, Y
         => \MyDAC/MyAD5360/N_348\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_2[0]\ : 
        OR3
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_37\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_39\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_40\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_ns_0_0_2[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNICF53[1]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_224\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNITGPI2[4]\ : AO1
      port map(A => \MyDAC/TestGen/G_1_0_0_a3_0\, B => 
        \MyDAC/TestGen/N_34\, C => \MyDAC/TestGen/G_1_0_0_0\, Y
         => \MyDAC/TestGen/N_39\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_1[30]\ : OR2
      port map(A => \MyDAC/MyAD5360/N_267\, B => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux\, Y => 
        \MyDAC/MyAD5360/ResetCounter_n30_0_i_0\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[7]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[7]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[7]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_9_1\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_9_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_3[1]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/N_232\, C => 
        \MyDAC/MyPackageDis/Mode_09_Input[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_09_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[16]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[16]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[16]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[15]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_22\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[1]\ : 
        NOR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[1]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[1]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[1]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[11]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_12\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_36\);
    
    \DEBUG_MOSI_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_MOSI_c, E => \VCC\, DOUT => 
        \DEBUG_MOSI_pad/U0/NET1\, EOUT => 
        \DEBUG_MOSI_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Mode_11_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_11_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[7]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/WRITE_AND\ : OR2
      port map(A => \MyDAC/MyPackageDis/MyFIFO/FULL\, B => 
        \MyDAC/WEBP\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/WRITE_ENABLE_I\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_2[39]\ : NOR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter[38]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[39]_net_1\, C => 
        \MyDAC/MyAD5360/N_507\, Y => \MyDAC/MyAD5360/N_306\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[24]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[24]_net_1\, B
         => \MyDAC/MyAD5360/N_209\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_147\);
    
    \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa_0_a2\ : 
        NOR3C
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, C => 
        \MyDAC/MyAD5360/MyController/N_49\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[2]\ : OR3
      port map(A => \MyDAC/TestGen/N_393\, B => 
        \MyDAC/TestGen/N_409\, C => \MyDAC/TestGen/N_392\, Y => 
        \MyDAC/TestGen/N_351\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIVNTR_1[5]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/MyPackageDis/N_88\, Y => 
        \MyDAC/MyPackageDis/N_225\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[2]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIL7UK_1[4]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_141\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIS8UB5[8]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_17\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_16\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_29\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_34\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNICOUD_0[0]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_84\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIV4FL1[0]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_122\, B => 
        \MyDAC/MyPackageDis/N_99\, Y => 
        \MyDAC/MyPackageDis/N_162\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIVD599[22]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, B
         => \MyDAC/MyAD5360/ResetCounter[22]_net_1\, Y => 
        \MyDAC/MyAD5360/N_208\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[23]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_08_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_09_Output_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[23]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[12]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIGLQ91[9]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[9]_net_1\, B => 
        \MyDAC/MyAD5360/PauseCounter_Output[9]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_26\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_17\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[8]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[8]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[0]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_2[5]\ : NOR3C
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, C => 
        \MyDAC/TestGen/N_415\, Y => \MyDAC/TestGen/N_400\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[6]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_11_0\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_11_0\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_1[2]\ : AXOI5
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0_0[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_06_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_06_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[15]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[15]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[15]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[15]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI317D2[17]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m4_0_a2_2\, B
         => \MyDAC/MyAD5360/ResetCounter_m4_0_a2_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_3\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_5\);
    
    \MyDAC/MyAD5360/ResetCounter[12]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_61\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[12]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[38]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[38]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[38]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[23]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_11_Output_m[1]\, B => 
        \MyDAC/MyAD5360/MyController/Mode_10_Output_m[1]\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[23]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[23]\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO[1]\ : OA1C
      port map(A => \MyDAC/MyAD5360/N_38\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[1]_net_1\, C => 
        \MyDAC/MyAD5360/N_294\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[23]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[23]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[23]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIM8UK_0[5]\ : NOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/N_83\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_12_0[0]\);
    
    \MyDAC/MyPackageDis/Mode_15_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[6]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_15_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIM8UK[5]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_742_i_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_734\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIJ4311[19]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[19]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[18]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_3\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_03_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_03_Output_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[9]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[9]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[9]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[13]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIGDU46[1]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_1[1]\, B => 
        \MyDAC/MyPackageDis/N_146\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_4[1]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_5[1]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[6]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[4]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_588\, B => 
        \MyDAC/MyPackageDis/dout[4]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[4]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[8]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI6MK51[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d_1[27]\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_285\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[12]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA[5]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[5]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[5]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI63TA2[12]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_1[5]\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_0[5]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_6[5]\, Y
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_10[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIUGQG6[14]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[14]_net_1\, B
         => \MyDAC/MyAD5360/N_199\, Y => \MyDAC/MyAD5360/N_200\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[9]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[9]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[9]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[9]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI1EMK[4]\ : NOR2
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_64_1\);
    
    \MyDAC/MyAD5360/ResetCounter[26]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_151\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[26]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[15]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[15]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[15]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[12]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[15]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[15]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[14]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[5]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[5]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[22]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_02_Output_m[0]\, B => 
        \MyDAC/MyAD5360/MyController/Mode_05_Output_m[0]\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[22]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[22]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[0]_net_1\);
    
    \MyDAC/TestGen/Counter[4]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n4\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_01_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_01_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[8]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[8]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[8]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[8]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[29]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[5]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[15]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[15]\);
    
    \NOT_CLR_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => \VCC\, E => \VCC\, DOUT => 
        \NOT_CLR_pad/U0/NET1\, EOUT => \NOT_CLR_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIM46C1[27]\ : NOR3A
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_4[2]\, B
         => \MyDAC/MyAD5360/ResetCounter[27]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[28]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_13[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI88593[5]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_197\, B => 
        \MyDAC/MyPackageDis/N_193\, C => 
        \MyDAC/MyPackageDis/N_199\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_3[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_10_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_10_Output_m[0]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[12]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_273\, B => 
        \MyDAC/MyAD5360/N_267\, C => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\, Y => 
        \MyDAC/MyAD5360/N_61\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIB73V[5]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/N_88\, C => \MyDAC/MyPackageDis/N_83\, 
        Y => \MyDAC/MyPackageDis/N_200\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[3]\ : 
        AOI1
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_36\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_36_mux\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/Busy_RNO\ : NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        B => \MyDAC/MyAD5360/MyController/Output_Valid_net_1\, Y
         => \MyDAC/MyAD5360/MyController/MyDAC/Busy_RNO_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[8]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/OR2_AFULL\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[0]\\\\\, B => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[1]\\\\\, C => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[2]\\\\\, Y => 
        \MyDAC/INPUT_FULL\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[12]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNISHCQ1[5]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_793\, B => 
        \MyDAC/MyPackageDis/N_761\, Y => 
        \MyDAC/MyPackageDis/Controller_Value_119_e_0\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL\ : DFN1C0
      port map(D => \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/MOSI\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25\, 
        CLK => Clk_c, CLR => Reset_c, Q => MOSI_c);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO_2\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_191\, B => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/N_805\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_9[0]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_618\, B => 
        \MyDAC/MyPackageDis/Mode_13_Input[0]_net_1\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_1[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_3[0]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIDB7N[30]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[30]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[30]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_30\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNID73N[12]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[12]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[12]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_12\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/SPI_START_LAST_RNI7KCL\ : NOR3C
      port map(A => \MyDAC/MyAD5360/Busy_i_0\, B => 
        \MyDAC/MyAD5360/SPI_START_LAST_i_0\, C => 
        \MyDAC/MyAD5360/Output_Busy_i_0\, Y => 
        \MyDAC/MyAD5360/un3_controller_busy_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[2]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_267\, B => 
        \MyDAC/MyAD5360/ResetCounter_n2_i_0_0\, C => 
        \MyDAC/MyAD5360/N_366\, Y => 
        \MyDAC/MyAD5360/ResetCounter_RNO[2]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNISGSL[0]\ : OA1A
      port map(A => \MyDAC/MyPackageDis/N_732_0\, B => 
        \MyDAC/MyPackageDis/N_803_1\, C => 
        \MyDAC/MyPackageDis/N_234\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_3_0[4]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[11]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[3]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[8]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[0]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_08_Output_m[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_6[0]\);
    
    \MyDAC/MyAD5360/MyController/Mode_10_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_10_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO[0]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_11[0]\, B
         => \MyDAC/MyPackageDis/Controller_SetMode_18_iv_10[0]\, 
        C => \MyDAC/MyPackageDis/Controller_SetMode_18_iv_12[0]\, 
        Y => \MyDAC/MyPackageDis/Controller_SetMode_18[0]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[37]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[37]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[37]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI32T21_0[0]\ : OR2A
      port map(A => \MyDAC/MyPackageDis/N_742_i_1\, B => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/N_582\);
    
    \MyDAC/TestGen/Counter_RNO[5]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c4\, B => 
        \MyDAC/TestGen/Counter[5]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n5\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5H1P7[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIOJF0B[22]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m3_0_a2_4\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_7_mux_0_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[15]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[10]_net_1\);
    
    \NOT_LDAC_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => NOT_LDAC_c, E => \VCC\, DOUT => 
        \NOT_LDAC_pad/U0/NET1\, EOUT => \NOT_LDAC_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[4]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[4]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_20[1]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/Mode_00_Input[1]_net_1\, 
        B => \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s10_i_0\, Y => 
        \MyDAC/MyPackageDis/Mode_00_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/OR2_FULL\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[0]\\\\\, B => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[1]\\\\\, C => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[2]\\\\\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/FULL\);
    
    \MyDAC/MyAD5360/ResetCounter[30]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_159\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[30]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[12]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNITLTR[0]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_90\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_794\);
    
    \MyDAC/TestGen/Counter_RNO[0]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter[0]_net_1\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Y => 
        \MyDAC/TestGen/Counter_e0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[11]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[11]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[11]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[11]\);
    
    \MyDAC/MyAD5360/ResetCounter[23]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_145\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[23]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_12_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_12_Input[0]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIT33U1[0]\ : XA1B
      port map(A => \MyDAC/TestGen/N_20_i\, B => 
        \MyDAC/TestGen/N_33\, C => \MyDAC/TestGen/N_21\, Y => 
        \MyDAC/TestGen/N_46\);
    
    \MyDAC/MyAD5360/MyController/Mode_12_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_12_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[38]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_21\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[38]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_1[2]\ : 
        MX2
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_1\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_2\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i3_mux_0\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[9]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[14]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIDIS91[1]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_822\, B => 
        \MyDAC/MyPackageDis/N_223\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[28]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI2TCE1[23]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[23]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_32\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_19\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[35]\ : NOR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m1_e_7_0\, B => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux\, C => 
        \MyDAC/MyAD5360/ResetCounter_n34_i_0_o2_0_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_4_mux_0\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI6ASJ1[0]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_965\, B => 
        \MyDAC/MyPackageDis/N_99\, Y => 
        \MyDAC/MyPackageDis/N_159\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[35]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[3]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[35]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[35]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[4]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_Value[11]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[3]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[11]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI826M[35]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[35]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[31]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0_0\);
    
    \MyDAC/MyAD5360/MyController/Mode_14_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_14_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIHF7N[32]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[32]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[32]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_32\);
    
    \NOT_OD_pad/U0/U0\ : IOPAD_TRI
      port map(D => \NOT_OD_pad/U0/NET1\, E => 
        \NOT_OD_pad/U0/NET2\, PAD => NOT_OD);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_4[0]\ : NOR3B
      port map(A => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_0_0[0]\, B => 
        \MyDAC/TestGen/N_20_i\, C => \MyDAC/INPUT_FULL\, Y => 
        \MyDAC/TestGen/N_32\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[22]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[22]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[22]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[22]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[22]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI6CQK1[20]\ : NOR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter[3]_net_1\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_3[5]\, C
         => \MyDAC/MyAD5360/ResetCounter[20]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_8[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNISDJD3[2]\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/N_1385_1\, B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_2[20]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_3[20]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[19]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI0HEV\ : 
        NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_8_0[0]\, B
         => \MyDAC/MyPackageDis/N_742_i_1\, C => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/N_194\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[26]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[26]_net_1\, B
         => \MyDAC/MyAD5360/N_211\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_151\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[6]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_3[2]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_220\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[2]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_0[3]\ : NOR3
      port map(A => \MyDAC/TestGen/N_22\, B => 
        \MyDAC/TestGen/N_34\, C => \MyDAC/TestGen/N_21\, Y => 
        \MyDAC/TestGen/N_58\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[20]\ : NOR3A
      port map(A => \MyDAC/PauseCounter[20]\, B => 
        \MyDAC/MyPackageDis/N_818\, C => 
        \MyDAC/MyPackageDis/N_743\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[20]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIDHTH7[17]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[17]_net_1\, B
         => \MyDAC/MyAD5360/N_202\, Y => \MyDAC/MyAD5360/N_203\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO[3]\ : 
        MX2C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_36_mux\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_289\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[3]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[34]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_4_mux_0_0\, B
         => \MyDAC/MyAD5360/ResetCounter[34]_net_1\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => \MyDAC/MyAD5360/N_12\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIFSKA2\ : 
        OR3
      port map(A => \MyDAC/MyPackageDis/N_148\, B => 
        \MyDAC/MyPackageDis/MyFIFO/N_152\, C => 
        \MyDAC/MyPackageDis/MyFIFO/N_154\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_1[1]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_0[5]\ : OR3
      port map(A => \MyDAC/TestGen/N_22\, B => 
        \MyDAC/TestGen/N_23\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/TestGen/N_29\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI38O4[1]\ : AO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_10_i_o2_0_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[23]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_01_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_02_Output_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[23]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_1[4]\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_2[0]\ : AND3C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_736\, Y => 
        \MyDAC/MyPackageDis/N_205\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[9]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[9]\);
    
    \MyDAC/TestGen/Counter_RNO[2]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[1]_net_1\, B => 
        \MyDAC/TestGen/Counter[0]_net_1\, C => 
        \MyDAC/TestGen/Counter[2]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n2\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[34]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0\, B
         => \MyDAC/MyAD5360/ResetCounter[32]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_4_mux_0_0\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[34]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[34]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[34]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[9]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[9]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[23]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_13_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_15_Output_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[23]\);
    
    \MyDAC/MyAD5360/MyController/Mode_00_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_00_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[6]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_1[5]\ : OA1C
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_40\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[38]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[38]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[38]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[0]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[5]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_588\, B => 
        \MyDAC/MyPackageDis/dout[5]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[5]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[5]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIKEGT[2]\ : OA1B
      port map(A => \MyDAC/MyPackageDis/N_223\, B => 
        \MyDAC/MyPackageDis/N_234\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_176\);
    
    \MyDAC/MyAD5360/MyController/Mode_13_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_13_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[31]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[31]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[31]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIDSNU[8]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[9]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_5[5]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[36]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[36]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[36]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_13_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[30]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[30]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[30]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[6]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI2AI8[5]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_108\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI3LG61[2]\ : NOR3B
      port map(A => \MyDAC/Controller_Wait_i_0\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_10_0[0]\, 
        C => \MyDAC/MyPackageDis/N_90\, Y => 
        \MyDAC/MyPackageDis/N_196\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNID33E1[2]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[2]_net_1\, B => 
        \MyDAC/MyAD5360/N_186\, Y => \MyDAC/MyAD5360/N_187\);
    
    \MyDAC/MyAD5360/ResetCounter[31]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_161\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[31]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[20]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[20]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[20]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[2]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI7E4Q[0]\ : NOR3A
      port map(A => \MyDAC/Controller_Wait_i_0\, B => 
        \MyDAC/MyPackageDis/N_90\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_183\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI4CQI_0[3]\ : 
        OR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_20\);
    
    \MyDAC/MyAD5360/MyController/Mode_02_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_02_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_01_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_01_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_15_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_15_Output_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[13]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[13]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[13]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[10]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_6[1]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_232\, B => 
        \MyDAC/MyPackageDis/Mode_05_Input[1]_net_1\, C => 
        \MyDAC/MyPackageDis/N_97\, Y => 
        \MyDAC/MyPackageDis/Mode_05_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_5\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[20]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[7]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_32\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[14]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNII4UK[1]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_83\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_110\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIJF5N[24]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[24]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[24]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_24\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\);
    
    \DEBUG_NOT_CLR\ : DFN1C0
      port map(D => \VCC\, CLK => Clk_c, CLR => Reset_c, Q => 
        NOT_RESET_DAC_c_c);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO[5]\ : OA1C
      port map(A => \MyDAC/TestGen/N_29\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, C => 
        \MyDAC/TestGen/N_40\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[5]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[26]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[2]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[2]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/N_727\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/MyPackageDis/N_629\, Q => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[11]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[11]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[38]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[38]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[38]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[20]\ : 
        INV
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[19]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_i[19]\);
    
    \MyDAC/TestGen/Counter_RNO[7]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c6\, B => 
        \MyDAC/TestGen/Counter[7]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n7\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIFRUD[0]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_241\);
    
    \DEBUG_CS_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_CS_c, E => \VCC\, DOUT => 
        \DEBUG_CS_pad/U0/NET1\, EOUT => \DEBUG_CS_pad/U0/NET2\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO_4\ : AO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, C => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1_tz_0\, Y
         => \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1_tz_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[0]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_4[0]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_4[1]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_9_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[8]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIFHFHD[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\);
    
    \MyDAC/MyAD5360/SPI_START_RNI374P\ : NOR2A
      port map(A => \MyDAC/MyAD5360/un3_controller_busy_1\, B => 
        \MyDAC/MyAD5360/SPI_START_net_1\, Y => 
        \MyDAC/MyAD5360/un3_controller_busy\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[4]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO[2]\ : OA1C
      port map(A => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_a3_0[2]\, B => 
        \MyDAC/TestGen/N_22\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_0[2]\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_10_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_10_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[14]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_06_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[4]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_06_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_06_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_06_Output_m[1]\);
    
    \MyDAC/MyPackageDis/Mode_03_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[6]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_03_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[10]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[10]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[17]\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_i_a2_1[17]\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_i_a2_2[17]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_1[3]\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[2]\);
    
    \MyDAC/MyPackageDis/Controller_Value[10]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[2]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Mode_13_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_13_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[2]\ : 
        MX2B
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_15_0\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_270_1\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_18\);
    
    \MyDAC/MyPackageDis/MyFIFO/OR2_EMPTY\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[0]\\\\\, B => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[1]\\\\\, C => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[2]\\\\\, Y => 
        \MyDAC/MyPackageDis/FIFO_EMPTY\);
    
    \MyDAC/MyPackageDis/Mode_00_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[1]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_00_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[5]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[5]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[1]\ : 
        MX2
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_3\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_38_mux\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i3_mux_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[4]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_Value[12]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[4]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[12]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE[5]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_RNO[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[13]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_3[1]\ : NOR2
      port map(A => \MyDAC/TestGen/N_34\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_389\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIDIS91_1[1]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_822\, B => 
        \MyDAC/MyPackageDis/N_97\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[25]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[21]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[5]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[21]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[21]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[18]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[18]_net_1\, B
         => \MyDAC/MyAD5360/N_203\, C => \MyDAC/MyAD5360/N_267\, 
        Y => \MyDAC/MyAD5360/N_81\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_LAST_RNIOFQP\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_net_1\, B => 
        \MyDAC/MyPackageDis/INPUT_READEN_LAST_net_1\, C => 
        \MyDAC/MyPackageDis/FIFO_EMPTY\, Y => 
        \MyDAC/MyPackageDis/N_80\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[10]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[10]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[10]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_3[5]\ : NOR2
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[4]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_01_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI804M[26]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[22]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[26]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIFRUD_0[1]\ : NOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_8_0[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[8]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[8]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[14]_net_1\);
    
    \MyDAC/TestGen/Counter_RNO[9]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c8\, B => 
        \MyDAC/TestGen/Counter[9]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n9\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[11]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[3]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\);
    
    \DEBUG_SCLK_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_SCLK_pad/U0/NET1\, E => 
        \DEBUG_SCLK_pad/U0/NET2\, PAD => DEBUG_SCLK);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7NO4[5]\ : NOR3
      port map(A => \MyDAC/MyPackageDis/N_159\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_0[5]\, C => 
        \MyDAC/MyPackageDis/N_158\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7NO4[5]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO[0]\ : AO1
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/MyAD5360/un11_resetcounter_i\, C => 
        \MyDAC/MyAD5360/N_285\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_0[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[3]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIVGG61[3]\ : NOR3A
      port map(A => \MyDAC/Controller_Wait_i_0\, B => 
        \MyDAC/MyPackageDis/N_90\, C => \MyDAC/MyPackageDis/N_84\, 
        Y => \MyDAC/MyPackageDis/N_247\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_00_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_00_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[36]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[36]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_3_mux_0_0\, C => 
        \MyDAC/MyAD5360/N_267\, Y => \MyDAC/MyAD5360/N_25\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI9M4C1[20]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[20]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_5\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[10]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_6[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_232\, B => 
        \MyDAC/MyPackageDis/Mode_05_Input[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_97\, Y => 
        \MyDAC/MyPackageDis/Mode_05_Input_m[0]\);
    
    \DEBUG_NOT_BIN_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_NOT_BIN_pad/U0/NET1\, E => 
        \DEBUG_NOT_BIN_pad/U0/NET2\, PAD => DEBUG_NOT_BIN);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIGSUD[2]\ : NOR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_10_0[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIO74H[1]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/N_84\, Y => 
        \MyDAC/MyPackageDis/N_147_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[25]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[25]_net_1\, B
         => \MyDAC/MyAD5360/N_210\, C => \MyDAC/MyAD5360/N_267\, 
        Y => \MyDAC/MyAD5360/N_149\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[13]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[13]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[13]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI113C\ : 
        NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, C => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_i_i_a2_1_0[3]\);
    
    \MyDAC/MyAD5360/ResetCounter[27]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_153\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[27]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[9]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[30]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[30]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[30]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[13]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI3BQI[0]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d_1[27]\);
    
    \CS_pad/U0/U0\ : IOPAD_TRI
      port map(D => \CS_pad/U0/NET1\, E => \CS_pad/U0/NET2\, PAD
         => CS);
    
    \MyDAC/MyAD5360/MyController/Mode_03_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_03_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[10]_net_1\);
    
    \DEBUG_MOSI_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_MOSI_pad/U0/NET1\, E => 
        \DEBUG_MOSI_pad/U0/NET2\, PAD => DEBUG_MOSI);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5AO4[0]\ : AO1B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_12_i_o2_0_0\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI53SM2[0]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_85\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_4_0[2]\, C
         => \MyDAC/MyPackageDis/N_183\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_7[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[3]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[3]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIR32D1[3]\ : AO1D
      port map(A => \MyDAC/MyPackageDis/N_740\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, C => 
        \MyDAC/MyPackageDis/N_824\, Y => 
        \MyDAC/MyPackageDis/N_761\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_7\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[19]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[0]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_24\);
    
    \NOT_CLR_pad/U0/U0\ : IOPAD_TRI
      port map(D => \NOT_CLR_pad/U0/NET1\, E => 
        \NOT_CLR_pad/U0/NET2\, PAD => NOT_CLR);
    
    \MyDAC/MyPackageDis/Mode_08_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[1]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_08_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI3ARK2[2]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_99\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_13_0[1]\, 
        C => \MyDAC/MyPackageDis/N_229\, Y => 
        \MyDAC/MyPackageDis/N_103\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIBJKI[2]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[2]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[2]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_2\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNICOCR[0]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/N_1385_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[11]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[2]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_05_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_05_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[22]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[22]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[22]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[22]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[22]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[4]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7NO4[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa_0_a2_1\ : 
        NOR3C
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[2]\, B => 
        \MyDAC/Controller_Valid_EXPORT\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[0]\, Y => 
        \MyDAC/MyAD5360/MyController/N_49\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[9]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[1]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[6]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[9]_net_1\);
    
    \MyDAC/TestGen/Counter_RNI6LOD2[4]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[3]_net_1\, B => 
        \MyDAC/TestGen/Counter_c2\, C => 
        \MyDAC/TestGen/Counter[4]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c4\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIFHFHD[0]\ : NOR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_6[2]\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_5[2]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_7[2]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIFHFHD[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI5FO91[10]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[6]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[10]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[4]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_4\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[2]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[2]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[2]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[1]_net_1\);
    
    \DEBUG_NOT_RESET_DAC_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_NOT_RESET_DAC_c, E => \VCC\, DOUT => 
        \DEBUG_NOT_RESET_DAC_pad/U0/NET1\, EOUT => 
        \DEBUG_NOT_RESET_DAC_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[13]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[13]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[13]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[13]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[20]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_i[19]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[20]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[11]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIHK1V[2]\ : NOR2
      port map(A => \MyDAC/TestGen/N_36\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/TestGen/N_411\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[1]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_i_m[1]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_i_m[1]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[1]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[1]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIP19P1\ : 
        AOI1A
      port map(A => \MyDAC/MyPackageDis/N_736\, B => 
        \MyDAC/MyPackageDis/N_732\, C => 
        \MyDAC/MyPackageDis/N_99\, Y => 
        \MyDAC/MyPackageDis/N_174\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIOUN7[17]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        B => \MyDAC/MyAD5360/SPI_START_net_1\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIOUN7[17]_net_1\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO_5\ : AO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1_tz_0\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_0[3]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_807\);
    
    \MyDAC/TestGen/Counter_RNO_0[15]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[13]_net_1\, B => 
        \MyDAC/TestGen/Counter_c12\, C => 
        \MyDAC/TestGen/Counter[14]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c14\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMNK6M[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_07_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_07_Output_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIJLCQ[11]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[5]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[11]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_2\);
    
    \MyDAC/MyAD5360/MyController/Mode_06_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_06_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNILLUD[4]\ : NOR2B
      port map(A => \MyDAC/Controller_SPIACTION\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyAD5360/N_266\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[7]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[7]_net_1\, B => 
        \MyDAC/MyAD5360/N_191\, C => \MyDAC/MyAD5360/N_267\, Y
         => \MyDAC/MyAD5360/N_15\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIRIP56[13]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\, B
         => \MyDAC/MyAD5360/ResetCounter[13]_net_1\, Y => 
        \MyDAC/MyAD5360/N_199\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI7T1M[10]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[19]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[10]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_4[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[4]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMNK6M[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[1]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[4]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_18[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_240\, B => 
        \MyDAC/MyPackageDis/Mode_14_Input[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_108\, Y => 
        \MyDAC/MyPackageDis/Mode_14_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[10]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[8]_net_1\);
    
    \DEBUG_GPIO\ : DFN1C0
      port map(D => GPIO_c, CLK => Clk_c, CLR => Reset_c, Q => 
        DEBUG_GPIO_c);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[7]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[7]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[7]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[7]\);
    
    \DEBUG_MISO_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_MISO_pad/U0/NET1\, E => 
        \DEBUG_MISO_pad/U0/NET2\, PAD => DEBUG_MISO);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[17]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_i_a2_1[17]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_3[2]\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_2[1]\ : MX2B
      port map(A => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_a3_2_0[1]\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, S => 
        \MyDAC/TestGen/N_35\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_1[1]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIVNTR_0[5]\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_86\, B => 
        \MyDAC/MyPackageDis/N_84\, Y => 
        \MyDAC/MyPackageDis/N_822\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[11]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_0[0]\ : AO1C
      port map(A => \MyDAC/MyPackageDis/N_87\, B => 
        \MyDAC/MyPackageDis/N_232\, C => 
        \MyDAC/MyPackageDis/N_618\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_i_2[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[7]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[3]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[5]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[5]_net_1\, B => 
        \MyDAC/TestGen/Counter[13]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_146\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIVNTR[5]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_742_i_1\, B => 
        \MyDAC/MyPackageDis/N_86\, Y => 
        \MyDAC/MyPackageDis/N_232\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[7]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_02_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_02_Output_m[1]\);
    
    \MyDAC/TestGen/INPUT_DATA[3]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[3]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[3]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO[1]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_11[1]\, B
         => \MyDAC/MyPackageDis/Controller_SetMode_18_iv_10[1]\, 
        C => \MyDAC/MyPackageDis/Controller_SetMode_18_iv_12[1]\, 
        Y => \MyDAC/MyPackageDis/Controller_SetMode_18[1]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_7\, B => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_6\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_8\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[29]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[29]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[29]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[6]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[0]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_8_0\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[5]_net_1\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_20\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_8_0\);
    
    \MyDAC/MyAD5360/ResetCounter[25]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_149\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[25]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[10]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIH2NI[3]\ : OR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_736\, C => 
        \MyDAC/MyPackageDis/N_732_0\, Y => 
        \MyDAC/MyPackageDis/N_618\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_3\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[11]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_30\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[27]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_734\, B => 
        \MyDAC/PauseCounter[27]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[3]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[27]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[19]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[19]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[19]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[2]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/dout[2]\, B => 
        \MyDAC/MyPackageDis/N_588\, Y => 
        \MyDAC/MyPackageDis/dout_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[16]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[16]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[16]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[4]\ : OR2
      port map(A => \MyDAC/TestGen/N_388\, B => 
        \MyDAC/TestGen/N_398\, Y => \MyDAC/TestGen/N_113\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNITKR29[3]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_6[0]\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_5[0]\, C => 
        \MyDAC/MyPackageDis/N_196\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_11[0]\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNILLUD_0[4]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, B
         => \MyDAC/Controller_SPIACTION\, Y => 
        \MyDAC/MyAD5360/N_281\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[7]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[7]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[7]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIGP4A[0]\ : OA1C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_15_i_a6_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[10]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[10]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[10]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[8]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI98IH[1]\ : NOR2A
      port map(A => \MyDAC/Controller_Wait_i_0\, B => 
        \MyDAC/MyPackageDis/N_97\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_1_0[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_14_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_14_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[4]\);
    
    \MyDAC/TestGen/Counter[6]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n6\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNIVUNRE[1]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/N_348\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_12[5]\, C
         => \MyDAC/MyAD5360/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyAD5360/N_366\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIILDQ[21]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[21]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[3]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_0[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI80GD1[5]\ : AO1C
      port map(A => \MyDAC/MyPackageDis/N_84\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_1_0[5]\, C
         => \MyDAC/MyPackageDis/N_88\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_0[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[3]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[3]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[3]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[15]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[39]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[39]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[39]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_DELAYED\ : 
        DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_net_1\, CLK
         => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_DELAYED_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[22]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_29\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[22]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_07_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_07_Output[1]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI1EMK_0[2]\ : NOR2
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_a2_0\);
    
    \DEBUG_NOT_BUSY_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_NOT_BUSY_pad/U0/NET1\, E => 
        \DEBUG_NOT_BUSY_pad/U0/NET2\, PAD => DEBUG_NOT_BUSY);
    
    \MyDAC/TestGen/Counter_RNIVE6V4[12]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[11]_net_1\, B => 
        \MyDAC/TestGen/Counter_c10\, C => 
        \MyDAC/TestGen/Counter[12]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c12\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI6GKJ2[6]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_6\, B => 
        \MyDAC/MyAD5360/un11_resetcounter_7\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_11\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_25\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[1]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_i_m[1]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_i_m[1]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[1]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIL2BN1[23]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_0\, B
         => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_6\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[5]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[5]\);
    
    \MyDAC/MyAD5360/MyController/Mode_05_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_05_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[39]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[7]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[39]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[39]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNISB4H[2]\ : NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, C => 
        \MyDAC/MyPackageDis/N_94\, Y => 
        \MyDAC/MyPackageDis/N_166\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI5R1M[13]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[14]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[13]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[14]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIK6UK[3]\ : OR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_742_i_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_i_m[1]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIOAUK[3]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_736\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_90\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI9HKI[1]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[1]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[1]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNI3QSK[5]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[4]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_0[2]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[35]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_4_mux_0\, B
         => \MyDAC/MyAD5360/ResetCounter[35]_net_1\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => \MyDAC/MyAD5360/N_27\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[2]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[2]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[2]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[2]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIDACFE[37]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[37]_net_1\, B
         => \MyDAC/MyAD5360/N_506\, Y => \MyDAC/MyAD5360/N_507\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI80GD1[4]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_247\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_155\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[5]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_Valid_Last_RNIHJ0R\ : 
        NOR3A
      port map(A => \MyDAC/MyAD5360/MyController/un3_output_busy\, 
        B => \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, C => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Output_Valid_3\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[10]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_2[3]\ : AO1B
      port map(A => \MyDAC/TestGen/N_411\, B => 
        \MyDAC/TestGen/N_418\, C => \MyDAC/TestGen/N_19\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_0[3]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[9]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[11]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[4]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[3]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI32T21[3]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_768\, B => 
        \MyDAC/MyPackageDis/N_732\, Y => 
        \MyDAC/MyPackageDis/N_588\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[11]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[14]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_19[0]\ : NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, B => 
        \MyDAC/MyPackageDis/Mode_15_Input[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_108\, Y => 
        \MyDAC/MyPackageDis/Mode_15_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa_0_a2\ : 
        NOR3A
      port map(A => \MyDAC/MyAD5360/MyController/N_53\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI6D9V9[24]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[24]_net_1\, B
         => \MyDAC/MyAD5360/N_209\, Y => \MyDAC/MyAD5360/N_210\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[2]\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[24]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_734\, B => 
        \MyDAC/PauseCounter[24]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[0]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[24]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[8]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIJS4A[0]\ : XO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_966\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[2]\ : DFN1E1C0
      port map(D => \MyDAC/MyAD5360/SPIMACHINE_STATE[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/un3_controller_busy\, Q => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[7]_net_1\);
    
    \DEBUG_MISO\ : DFN1C0
      port map(D => MISO_c, CLK => Clk_c, CLR => Reset_c, Q => 
        DEBUG_MISO_c);
    
    \MyDAC/MyPackageDis/Controller_ChannelID[2]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/N_725\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/MyPackageDis/N_629\, Q => 
        \MyDAC/Controller_ChannelID_EXPORT[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_05_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_05_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[22]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_09_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_08_Output_m[0]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[22]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_3[0]\ : 
        OA1A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_Valid_net_1\, B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_285\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_37\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[2]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIVBMK_0[2]\ : NOR2B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/TestGen/N_75\);
    
    \MyDAC/TestGen/Counter[7]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n7\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_1[1]\ : 
        MX2B
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_40\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_9_0\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_293\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/i3_mux\);
    
    \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa_0_a2_1\ : 
        NOR3A
      port map(A => \MyDAC/Controller_Valid_EXPORT\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[2]\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[0]\, Y => 
        \MyDAC/MyAD5360/MyController/N_50\);
    
    \MyDAC/MyPackageDis/Controller_Valid_RNO\ : NOR2
      port map(A => \MyDAC/MyPackageDis/N_629\, B => 
        \MyDAC/MyPackageDis/N_91\, Y => 
        \MyDAC/MyPackageDis/Controller_Valid_RNO_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[7]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_00_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[0]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_584\, Q => 
        \MyDAC/MyPackageDis/Mode_00_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_LAST\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_net_1\, CLK => 
        Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/INPUT_READEN_LAST_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIOSE53[13]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_6[2]\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_5[2]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_15[2]\, Y
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_19[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[22]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_11_Output_m[0]\, B => 
        \MyDAC/MyAD5360/MyController/Mode_10_Output_m[0]\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[22]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[22]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[3]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIEQUD_0[1]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_97\);
    
    \DEBUG_NOT_BUSY\ : DFN1C0
      port map(D => NOT_BUSY_c, CLK => Clk_c, CLR => Reset_c, Q
         => DEBUG_NOT_BUSY_c);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_2[1]\ : AO1
      port map(A => \MyDAC/TestGen/N_64_1\, B => 
        \MyDAC/TestGen/N_412\, C => \MyDAC/TestGen/N_389\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_0[1]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[30]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[6]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_03_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_03_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[15]_net_1\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO_1\ : OA1C
      port map(A => \MyDAC/MyPackageDis/N_732_0\, B => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1_tz_1\, C
         => \MyDAC/MyPackageDis/N_91\, Y => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIQ3UK1[6]\ : NOR3A
      port map(A => \MyDAC/MyAD5360/N_326\, B => 
        \MyDAC/MyAD5360/ResetCounter[5]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[6]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_15[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[11]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_0[4]\ : OR3A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/TestGen/N_22\, C => \MyDAC/TestGen/N_23\, Y
         => \MyDAC/TestGen/N_28\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[29]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[29]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[29]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[1]\ : MX2A
      port map(A => \MyDAC/TestGen/N_347\, B => 
        \MyDAC/TestGen/N_142\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[1]\);
    
    \MyDAC/TestGen/Counter_RNI9BSC3[6]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[5]_net_1\, B => 
        \MyDAC/TestGen/Counter_c4\, C => 
        \MyDAC/TestGen/Counter[6]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c6\);
    
    \MyDAC/MyAD5360/SPI_START_RNO\ : NOR2B
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/MyAD5360/un3_controller_busy\, Y => 
        \MyDAC/MyAD5360/N_9\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[17]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[17]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[17]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[3]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[18]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[2]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[18]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[18]\);
    
    \MyDAC/MyPackageDis/Controller_Value[6]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[6]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[6]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[22]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[6]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[22]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[22]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI8CL71[1]\ : OR3A
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_10_i_o2_0_0\, C
         => \MyDAC/MyPackageDis/N_734\, Y => 
        \MyDAC/MyPackageDis/N_749\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[29]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[29]_net_1\, B
         => \MyDAC/MyAD5360/N_215\, C => \MyDAC/MyAD5360/N_267\, 
        Y => \MyDAC/MyAD5360/N_157\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI936M[34]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[34]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[33]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_n34_i_0_o2_0_0\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_ns[1]\, CLK
         => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_0[17]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[3]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[3]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[3]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[3]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[36]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[4]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[36]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[36]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_15[1]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/N_141\, C => 
        \MyDAC/MyPackageDis/Mode_01_Input[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_01_Input_m[1]\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[5]\ : NOR2
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, Y => 
        \MyDAC/MyAD5360/N_291\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[1]\ : 
        AO1A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_i_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[14]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI74IK_0[0]\ : OR2
      port map(A => \MyDAC/INPUT_FULL\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/TestGen/N_22\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[8]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[8]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[13]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[13]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[13]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[13]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_1[4]\ : 
        OA1C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_3_0\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_39_mux\);
    
    \MyDAC/MyAD5360/MyController/Mode_08_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_08_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[17]\ : NOR2A
      port map(A => \MyDAC/PauseCounter[17]\, B => 
        \MyDAC/MyPackageDis/N_818\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[17]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIRP7N[37]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[37]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[37]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_37\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[25]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[25]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[25]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI26AA4[8]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/N_192\, Y => \MyDAC/MyAD5360/N_193\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIC8UQ3[7]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[7]_net_1\, B => 
        \MyDAC/MyAD5360/N_191\, Y => \MyDAC/MyAD5360/N_192\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_14[1]\ : NOR3C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/N_147_1\, C => 
        \MyDAC/MyPackageDis/Mode_11_Input[1]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_11_Input_m[1]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_12[1]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_822\, B => 
        \MyDAC/MyPackageDis/Mode_06_Input[1]_net_1\, C => 
        \MyDAC/MyPackageDis/N_94\, Y => 
        \MyDAC/MyPackageDis/Mode_06_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[2]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_1[0]\ : AO1A
      port map(A => \MyDAC/TestGen/N_23\, B => 
        \MyDAC/TestGen/N_64_1\, C => \MyDAC/TestGen/N_32\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_0[0]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI6U3M[22]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[24]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[22]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[8]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[8]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[8]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[8]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[13]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[0]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[7]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[7]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[7]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[7]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[17]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[17]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[17]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_1[3]\ : AO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, C => 
        \MyDAC/MyPackageDis/N_806\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0[3]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[0]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[0]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIU06PD[32]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m1_0_a2_0_2\, B
         => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4\, C => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_3_mux_0_0\);
    
    \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[1]\, B => 
        \MyDAC/MyAD5360/MyController/N_50\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[36]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[36]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[36]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[12]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_2[6]\ : AOI1B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, C => 
        \MyDAC/TestGen/N_415\, Y => \MyDAC/TestGen/N_397\);
    
    \MyDAC/MyPackageDis/Mode_09_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[3]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_09_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIE0411[19]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[19]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[21]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[16]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_4\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[3]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[3]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[3]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[3]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[22]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_04_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_07_Output_m[0]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[22]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_6[0]\ : NOR2B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, B
         => \MyDAC/TestGen/N_21\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_0_0[0]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI3K7R4[0]\ : OR3
      port map(A => \MyDAC/TestGen/N_50\, B => 
        \MyDAC/TestGen/N_49\, C => \MyDAC/TestGen/N_48\, Y => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[14]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[6]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[6]\);
    
    \MyDAC/MyPackageDis/MyFIFO/_FIFOBLOCK[1]_\ : FIFO4K18
      port map(AEVAL11 => \GND\, AEVAL10 => \GND\, AEVAL9 => 
        \GND\, AEVAL8 => \GND\, AEVAL7 => \GND\, AEVAL6 => \GND\, 
        AEVAL5 => \GND\, AEVAL4 => \GND\, AEVAL3 => \GND\, AEVAL2
         => \VCC\, AEVAL1 => \GND\, AEVAL0 => \GND\, AFVAL11 => 
        \VCC\, AFVAL10 => \VCC\, AFVAL9 => \VCC\, AFVAL8 => \VCC\, 
        AFVAL7 => \VCC\, AFVAL6 => \VCC\, AFVAL5 => \VCC\, AFVAL4
         => \VCC\, AFVAL3 => \GND\, AFVAL2 => \GND\, AFVAL1 => 
        \GND\, AFVAL0 => \GND\, WD17 => \GND\, WD16 => \GND\, 
        WD15 => \GND\, WD14 => \GND\, WD13 => \GND\, WD12 => 
        \GND\, WD11 => \GND\, WD10 => \GND\, WD9 => \GND\, WD8
         => \GND\, WD7 => \GND\, WD6 => \GND\, WD5 => \GND\, WD4
         => \GND\, WD3 => \MyDAC/INPUT_DATA_TG[7]\, WD2 => 
        \MyDAC/INPUT_DATA_TG[6]\, WD1 => \MyDAC/INPUT_DATA_TG[5]\, 
        WD0 => \MyDAC/INPUT_DATA_TG[4]\, WW0 => \GND\, WW1 => 
        \VCC\, WW2 => \GND\, RW0 => \GND\, RW1 => \VCC\, RW2 => 
        \GND\, RPIPE => \VCC\, WEN => 
        \MyDAC/MyPackageDis/MyFIFO/WRITE_ENABLE_I\, REN => 
        \MyDAC/MyPackageDis/MyFIFO/READ_ENABLE_I\, WBLK => \GND\, 
        RBLK => \GND\, WCLK => Clk_c, RCLK => Clk_c, RESET => 
        Reset_c, ESTOP => \VCC\, FSTOP => \VCC\, RD17 => OPEN, 
        RD16 => OPEN, RD15 => OPEN, RD14 => OPEN, RD13 => OPEN, 
        RD12 => OPEN, RD11 => OPEN, RD10 => OPEN, RD9 => OPEN, 
        RD8 => OPEN, RD7 => OPEN, RD6 => OPEN, RD5 => OPEN, RD4
         => OPEN, RD3 => \MyDAC/MyPackageDis/dout[7]\, RD2 => 
        \MyDAC/MyPackageDis/dout[6]\, RD1 => 
        \MyDAC/MyPackageDis/dout[5]\, RD0 => 
        \MyDAC/MyPackageDis/dout[4]\, FULL => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[1]\\\\\, AFULL
         => \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[1]\\\\\, 
        EMPTY => \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[1]\\\\\, 
        AEMPTY => OPEN);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIHTUD[5]\ : NOR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_238\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[3]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[9]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[9]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[1]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[2]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[2]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI7FQI_0[4]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_287\);
    
    \MyDAC/MyAD5360/MyController/Mode_15_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_15_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[13]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[7]\ : OR3
      port map(A => \MyDAC/TestGen/N_393\, B => 
        \MyDAC/TestGen/N_409\, C => \MyDAC/TestGen/N_486_1\, Y
         => \MyDAC/TestGen/N_355\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[30]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_734\, B => 
        \MyDAC/PauseCounter[30]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[6]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[30]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[13]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[13]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[13]_net_1\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_6_0\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_6_0\);
    
    \MyDAC/MyPackageDis/Mode_13_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[2]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_217\, Q => 
        \MyDAC/MyPackageDis/Mode_13_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[19]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_86\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[19]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[13]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[13]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[13]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[13]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNID32M[17]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[18]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[17]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_3\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI804M_0[26]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[26]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[22]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_9[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[11]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_Value[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[1]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[12]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_11[1]\ : AO1
      port map(A => \MyDAC/MyPackageDis/Mode_03_Input[1]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[25]\, C => 
        \MyDAC/MyPackageDis/Mode_10_Input_m[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_9[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[5]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[13]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[5]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[5]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI5594E[36]\ : OR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_3_mux_0_0\, B
         => \MyDAC/MyAD5360/ResetCounter[36]_net_1\, Y => 
        \MyDAC/MyAD5360/N_506\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[9]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[9]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[9]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[9]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[3]\ : AO1A
      port map(A => \MyDAC/MyAD5360/ResetCounter[3]_net_1\, B => 
        \MyDAC/MyAD5360/N_187\, C => \MyDAC/MyAD5360/N_267\, Y
         => \MyDAC/MyAD5360/ResetCounter_n3_i_0_0\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI3BQI[2]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_285\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[9]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_48\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_09_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_09_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[8]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[15]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[7]\, B => 
        \MyDAC/MyPackageDis/N_84\, C => 
        \MyDAC/MyPackageDis/N_768\, Y => 
        \MyDAC/MyPackageDis/dout_m_0[7]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI90E61\ : 
        NOR3C
      port map(A => 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_0_i_a2_9_0[1]\, 
        B => \MyDAC/MyPackageDis/N_223\, C => 
        \MyDAC/MyPackageDis/N_742_i_1\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/N_154\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[9]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[9]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNITSL93[3]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_244\, B => 
        \MyDAC/MyPackageDis/N_736\, C => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_12_i_0_1\, Y => 
        \MyDAC/MyPackageDis/N_629\);
    
    \MyDAC/MyPackageDis/Mode_10_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[5]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_10_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[11]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[4]\ : MX2
      port map(A => \MyDAC/TestGen/N_113\, B => 
        \MyDAC/TestGen/N_145\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[4]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[20]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[20]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_9_mux_2\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_RNO[20]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[5]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[5]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[5]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[5]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIJVUD[5]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_86\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[27]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_6_mux_0_2\, B
         => \MyDAC/MyAD5360/ResetCounter[27]_net_1\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => \MyDAC/MyAD5360/N_153\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[0]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[0]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[0]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_13[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[0]\);
    
    \MyDAC/MyAD5360/SPI_START_LAST_RNO\ : INV
      port map(A => \MyDAC/MyAD5360/SPI_START_net_1\, Y => 
        \MyDAC/MyAD5360/SPI_START_i\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[12]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_10[1]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/Mode_07_Input[1]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[29]\, Y => 
        \MyDAC/MyPackageDis/Mode_07_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_78\ : 
        OA1
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_9_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_8_0\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_283\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_78\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_2[0]\ : MX2
      port map(A => \MyDAC/TestGen/N_486_1\, B => 
        \MyDAC/TestGen/N_64_1\, S => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_0_0[0]\);
    
    \MyDAC/TestGen/Counter_RNI73LE1[2]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[1]_net_1\, B => 
        \MyDAC/TestGen/Counter[0]_net_1\, C => 
        \MyDAC/TestGen/Counter[2]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c2\);
    
    \MyDAC/MyPackageDis/Controller_Value[14]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[6]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_977\, Q => 
        \MyDAC/Controller_Value_EXPORT[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[9]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[13]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIOAUK[4]\ : OR2A
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7_i_o6_0[15]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIU5I8[3]\ : OR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_124\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[10]_net_1\);
    
    \NOT_RESET_DAC_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => NOT_RESET_DAC_c_c, E => \VCC\, DOUT => 
        \NOT_RESET_DAC_pad/U0/NET1\, EOUT => 
        \NOT_RESET_DAC_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]\ : 
        DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_ns[0]\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIH2NI[5]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_224\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, C => 
        \MyDAC/MyPackageDis/N_742_i_1\, Y => 
        \MyDAC/MyPackageDis/N_193\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO[5]\ : AOI1
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_2[1]\, 
        B => \MyDAC/MyAD5360/N_292_8\, C => 
        \MyDAC/MyAD5360/N_291\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[11]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[7]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/dout[7]\, B => 
        \MyDAC/MyPackageDis/N_588\, Y => 
        \MyDAC/MyPackageDis/dout_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[22]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_13_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_15_Output_m[0]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[22]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[13]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[13]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[13]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[13]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[22]\ : NOR3A
      port map(A => \MyDAC/PauseCounter[22]\, B => 
        \MyDAC/MyPackageDis/N_818\, C => 
        \MyDAC/MyPackageDis/N_743\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[22]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[17]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        B => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/N_1388\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[0]_net_1\);
    
    \MyDAC/TestGen/Counter[5]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n5\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[5]_net_1\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_LAST_RNIPG713\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_80\, B => 
        \MyDAC/MyPackageDis/N_822\, C => 
        \MyDAC/MyPackageDis/N_185\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_5[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[15]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[15]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[15]\);
    
    \DEBUG_NOT_PEC_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_NOT_PEC_pad/U0/NET1\, E => 
        \DEBUG_NOT_PEC_pad/U0/NET2\, PAD => DEBUG_NOT_PEC);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI32T21_0[4]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_242\, B => 
        \MyDAC/MyPackageDis/N_84\, Y => 
        \MyDAC/MyPackageDis/N_217\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[5]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[5]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[5]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[12]\);
    
    \MyDAC/MyAD5360/MyController/Mode_02_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_02_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/_FIFOBLOCK[2]_\ : FIFO4K18
      port map(AEVAL11 => \GND\, AEVAL10 => \GND\, AEVAL9 => 
        \GND\, AEVAL8 => \GND\, AEVAL7 => \GND\, AEVAL6 => \GND\, 
        AEVAL5 => \GND\, AEVAL4 => \GND\, AEVAL3 => \GND\, AEVAL2
         => \VCC\, AEVAL1 => \GND\, AEVAL0 => \GND\, AFVAL11 => 
        \VCC\, AFVAL10 => \VCC\, AFVAL9 => \VCC\, AFVAL8 => \VCC\, 
        AFVAL7 => \VCC\, AFVAL6 => \VCC\, AFVAL5 => \VCC\, AFVAL4
         => \VCC\, AFVAL3 => \GND\, AFVAL2 => \GND\, AFVAL1 => 
        \GND\, AFVAL0 => \GND\, WD17 => \GND\, WD16 => \GND\, 
        WD15 => \GND\, WD14 => \GND\, WD13 => \GND\, WD12 => 
        \GND\, WD11 => \GND\, WD10 => \GND\, WD9 => \GND\, WD8
         => \GND\, WD7 => \GND\, WD6 => \GND\, WD5 => \GND\, WD4
         => \GND\, WD3 => \GND\, WD2 => \GND\, WD1 => \GND\, WD0
         => \MyDAC/INPUT_DATA_TG[8]\, WW0 => \GND\, WW1 => \VCC\, 
        WW2 => \GND\, RW0 => \GND\, RW1 => \VCC\, RW2 => \GND\, 
        RPIPE => \VCC\, WEN => 
        \MyDAC/MyPackageDis/MyFIFO/WRITE_ENABLE_I\, REN => 
        \MyDAC/MyPackageDis/MyFIFO/READ_ENABLE_I\, WBLK => \GND\, 
        RBLK => \GND\, WCLK => Clk_c, RCLK => Clk_c, RESET => 
        Reset_c, ESTOP => \VCC\, FSTOP => \VCC\, RD17 => OPEN, 
        RD16 => OPEN, RD15 => OPEN, RD14 => OPEN, RD13 => OPEN, 
        RD12 => OPEN, RD11 => OPEN, RD10 => OPEN, RD9 => OPEN, 
        RD8 => OPEN, RD7 => OPEN, RD6 => OPEN, RD5 => OPEN, RD4
         => OPEN, RD3 => OPEN, RD2 => OPEN, RD1 => OPEN, RD0 => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, FULL => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[2]\\\\\, AFULL
         => \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[2]\\\\\, 
        EMPTY => \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[2]\\\\\, 
        AEMPTY => OPEN);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_20[0]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/Mode_00_Input[0]_net_1\, 
        B => \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s10_i_0\, Y => 
        \MyDAC/MyPackageDis/Mode_00_Input_m[0]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_1[39]\ : OR2
      port map(A => \MyDAC/MyAD5360/N_326\, B => 
        \MyDAC/MyAD5360/N_267\, Y => 
        \MyDAC/MyAD5360/ResetCounter_n39_i_0_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[36]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_25\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[36]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[17]\ : 
        DFN1E1C0
      port map(D => \MyDAC/MyAD5360/MyController/N_1385\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[17]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_05_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_05_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_13[0]\ : NOR3C
      port map(A => \MyDAC/MyPackageDis/N_826\, B => 
        \MyDAC/MyPackageDis/N_829\, C => 
        \MyDAC/MyPackageDis/Mode_12_Input[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_12_Input_m[0]\);
    
    \MISO_pad/U0/U0\ : IOPAD_IN
      port map(PAD => MISO, Y => \MISO_pad/U0/NET1\);
    
    \MyDAC/TestGen/Counter_RNIG50C4[8]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[7]_net_1\, B => 
        \MyDAC/TestGen/Counter_c6\, C => 
        \MyDAC/TestGen/Counter[8]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c8\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[6]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[6]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI6FHK5[17]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_9[5]\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_8[5]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_10[5]\, Y
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_12[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[15]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[27]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[27]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[27]\);
    
    \MyDAC/MyAD5360/ResetCounter[3]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[3]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIGJ1V[4]\ : NOR3A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_66\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIN9UK[2]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, B => 
        \MyDAC/MyPackageDis/N_736\, Y => 
        \MyDAC/MyPackageDis/N_791\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[12]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[12]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[12]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[12]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[3]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIJMDQ[2]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[2]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_1[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[39]\ : NOR3
      port map(A => \MyDAC/MyAD5360/N_305\, B => 
        \MyDAC/MyAD5360/ResetCounter_n39_i_0_0\, C => 
        \MyDAC/MyAD5360/N_306\, Y => \MyDAC/MyAD5360/N_19\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIHTCR[3]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_1[20]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[5]_net_1\);
    
    \NOT_PEC_pad/U0/U1\ : IOIN_IB
      port map(YIN => \NOT_PEC_pad/U0/NET1\, Y => NOT_PEC_c);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_4[1]\ : NOR2
      port map(A => \MyDAC/TestGen/N_21\, B => 
        \MyDAC/TestGen/N_20_i\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_a3_2_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[12]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI8CL71[2]\ : AO1
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_0[4]\, B
         => \MyDAC/MyPackageDis/N_124\, C => 
        \MyDAC/MyPackageDis/N_166\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_0[4]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIPLOQ5[6]\ : NOR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_6\, B
         => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_5\, C => 
        \MyDAC/MyAD5360/N_188\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[18]\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/N_1426\, B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1[18]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_2[18]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[18]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[5]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIB12M[17]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[16]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[17]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m4_0_a2_2\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_4[2]\ : 
        AOI1
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_2\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_0[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_09_Input_m[0]\, B
         => \MyDAC/MyPackageDis/Mode_08_Input_m[0]\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_7[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_11[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[8]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_4[3]\ : NOR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_a5_2_0[3]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIPARN1[4]\ : OR3A
      port map(A => \MyDAC/MyPackageDis/N_84\, B => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7_i_o6_0[15]\, 
        C => \MyDAC/MyPackageDis/N_730\, Y => 
        \MyDAC/MyPackageDis/N_748\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIPTEQ[33]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[33]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[7]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_6[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIIUUD[3]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_6_0[2]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIB73V[1]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_822\, B => 
        \MyDAC/MyPackageDis/N_224\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[29]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[23]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[23]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[23]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[7]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_1[1]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_05_Input_m[1]\, B
         => \MyDAC/MyPackageDis/Mode_04_Input_m[1]\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_4[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_10[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[10]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[13]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[13]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[5]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_06_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_06_Output_m[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIEQUD[1]\ : OR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_94\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[10]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[10]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[10]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[10]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIQJC91[0]\ : NOR3C
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, C => 
        \MyDAC/TestGen/N_20_i\, Y => \MyDAC/TestGen/N_409\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI4RTLG[8]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_31\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_30\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_34\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_37\);
    
    \MyDAC/MyPackageDis/Controller_Value[3]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[3]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[3]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[8]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[8]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_8[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_12_Input_m[0]\, B
         => \MyDAC/MyPackageDis/Mode_11_Input_m[0]\, C => 
        \MyDAC/MyPackageDis/Mode_01_Input_m[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_4[0]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]\ : 
        DFN1C0
      port map(D => \MyDAC/MyAD5360/MyController/MyDAC/N_13\, CLK
         => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIFNKI[4]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[4]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[4]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_4\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[2]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[1]\ : 
        AO1A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_i_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[13]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[33]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_14\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[33]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[4]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[12]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[12]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[12]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA[4]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[4]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[4]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO[1]\ : 
        MX2A
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/i3_mux_1\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/i3_mux\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_13\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIIBG82[8]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[8]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[9]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_4\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_6\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[5]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[5]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[23]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, B
         => \MyDAC/MyAD5360/N_208\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_145\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[1]\ : 
        AO1A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output_i_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[1]\);
    
    \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa_0_a2\ : 
        NOR3C
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, C => 
        \MyDAC/MyAD5360/MyController/N_53\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[23]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_12_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_14_Output_m[1]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[23]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_RNO\ : OR3
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_33\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_287\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_12_i_0_0_1\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_12_i\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[11]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[11]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[14]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[14]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_08_Output_m[14]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[21]\ : AOI1
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_9_mux_2\, B
         => \MyDAC/MyAD5360/ResetCounter[20]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[21]_net_1\, Y => 
        \MyDAC/MyAD5360/N_322\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[1]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/N_38\, B => 
        \MyDAC/MyAD5360/ResetCounter[0]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_0[5]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIPL5N[27]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[27]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[27]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_27\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIEQUD_1[1]\ : NOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[1]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_223\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[4]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[4]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[4]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[4]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[4]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[30]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[29]_net_1\, B
         => \MyDAC/MyAD5360/N_215\, Y => \MyDAC/MyAD5360/N_216\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_7\ : 
        OR3
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_281\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_271\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_78\, Y
         => \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_7\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_17[1]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/Mode_10_Input[1]_net_1\, 
        B => \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/N_90\, Y => 
        \MyDAC/MyPackageDis/Mode_10_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[30]\ : OA1C
      port map(A => \MyDAC/MyAD5360/N_216\, B => 
        \MyDAC/MyAD5360/ResetCounter[30]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_n30_0_i_0\, Y => 
        \MyDAC/MyAD5360/N_159\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIHB3N[14]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[14]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[14]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_14\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI933N[10]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[10]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[10]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_10\);
    
    \MyDAC/MyAD5360/MyController/Mode_07_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_07_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_Valid_Last\ : DFN1P0
      port map(D => \MyDAC/MyAD5360/MyController/Output_Valid_i\, 
        CLK => Clk_c, PRE => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/Output_Valid_Last_i_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[9]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIFHHO2[27]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_2[2]\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_1[2]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_13[2]\, Y
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_18[2]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[37]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[37]_net_1\, B
         => \MyDAC/MyAD5360/N_506\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_23\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[12]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[12]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[22]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[22]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[22]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI12G41[2]\ : MX2A
      port map(A => \MyDAC/MyPackageDis/N_95\, B => 
        \MyDAC/MyPackageDis/N_86\, S => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_117\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNI6E2PF[4]\ : AO1
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_2[2]\, 
        B => \MyDAC/MyAD5360/N_292_8\, C => 
        \MyDAC/MyAD5360/N_281\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_0[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_3[1]\ : 
        MX2C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_0\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_3_0\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_294\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_38_mux\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[0]_net_1\);
    
    \MyDAC/TestGen/Counter[3]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n3\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[3]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNITF3U8[19]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_5_7\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNI0PPM1[2]\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_1[20]\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_0_i_a2_3[20]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[14]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[14]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[5]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[5]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[5]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[5]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[10]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_2[3]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_732\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_806\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[4]\);
    
    \MyDAC/TestGen/Counter_RNO[8]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[7]_net_1\, B => 
        \MyDAC/TestGen/Counter_c6\, C => 
        \MyDAC/TestGen/Counter[8]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n8\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[9]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[11]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[11]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_1\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_4_1\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_282\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_272\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[9]_net_1\);
    
    \DEBUG_NOT_BUSY_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_NOT_BUSY_c, E => \VCC\, DOUT => 
        \DEBUG_NOT_BUSY_pad/U0/NET1\, EOUT => 
        \DEBUG_NOT_BUSY_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Mode_06_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_06_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[10]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIO3O49[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_968\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_5[1]\, C => 
        \MyDAC/MyPackageDis/N_149\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_9[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI914M[24]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[25]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[24]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output_i_m[1]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE[2]\ : DFN1C0
      port map(D => \MyDAC/TestGen/SPIMACHINE_STATE_RNO[2]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\);
    
    \MyDAC/TestGen/Counter[9]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n9\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, 
        Q => \MyDAC/TestGen/Counter[9]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIN9UK[3]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_737\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s10_i_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[13]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_VALID\ : DFI1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_VALID_RNO_net_1\, 
        CLK => Clk_c, CLR => Reset_c, QN => \MyDAC/WEBP\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[12]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[12]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_7[0]\ : XNOR2
      port map(A => \MyDAC/TestGen/N_20_i\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/N_26_i\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIL7UK_0[4]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, B => 
        \MyDAC/MyPackageDis/N_732\, Y => 
        \MyDAC/MyPackageDis/N_244\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[13]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[13]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIOUM45[7]\ : NOR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_5\, B
         => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_17_6\, C => 
        \MyDAC/MyAD5360/N_186\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_13_mux_2\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI2SC91[4]\ : NOR3B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_a2_0\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_68\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_8\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_1\, B => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_280\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_4\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_8\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_14[0]\ : NOR3C
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/N_147_1\, C => 
        \MyDAC/MyPackageDis/Mode_11_Input[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/Mode_11_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[7]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/N_962\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/MyPackageDis/N_629\, Q => 
        \MyDAC/Controller_ChannelID_EXPORT[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[12]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[12]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[12]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[12]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNI5RMH[15]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1[18]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[15]_net_1\);
    
    \DEBUG_SCLK\ : DFN1C0
      port map(D => SCLK_c, CLK => Clk_c, CLR => Reset_c, Q => 
        DEBUG_SCLK_c);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[16]\ : AO1
      port map(A => \MyDAC/MyAD5360/SPI_START_net_1\, B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/N_1390\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_ns[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_6\ : 
        NOR3C
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_6_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_6_0\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_25\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_276\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_5_0\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_5_0\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[13]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[13]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[13]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_2[0]\ : MX2
      port map(A => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_1_tz[0]\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, S => 
        \MyDAC/INPUT_FULL\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_2[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI5A5C2[2]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_176\, B => 
        \MyDAC/MyPackageDis/N_182\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_1[2]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_2[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[3]\, B => 
        \MyDAC/MyAD5360/MyController/N_54\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[1]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[13]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI95AB1\ : 
        NOR2
      port map(A => \MyDAC/MyPackageDis/N_99\, B => 
        \MyDAC/MyPackageDis/N_83\, Y => 
        \MyDAC/MyPackageDis/N_191\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_4_1\ : 
        NOR3C
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_27\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_4_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[13]_net_1\);
    
    \CS_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => CS_c, E => \VCC\, DOUT => \CS_pad/U0/NET1\, 
        EOUT => \CS_pad/U0/NET2\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_0[1]\ : OR3
      port map(A => \MyDAC/MyPackageDis/Mode_09_Input_m[1]\, B
         => \MyDAC/MyPackageDis/Mode_08_Input_m[1]\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_7[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_11[1]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[3]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_1[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[12]_net_1\);
    
    \GPIO_pad/U0/U0\ : IOPAD_IN
      port map(PAD => GPIO, Y => \GPIO_pad/U0/NET1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIURET1[3]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[3]_net_1\, B => 
        \MyDAC/MyAD5360/N_187\, Y => \MyDAC/MyAD5360/N_188\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2_8\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[18]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[2]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_29\);
    
    \GPIO_pad/U0/U1\ : IOIN_IB
      port map(YIN => \GPIO_pad/U0/NET1\, Y => GPIO_c);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI43T21[3]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_742_i_1\, B => 
        \MyDAC/MyPackageDis/N_90\, Y => 
        \MyDAC/MyPackageDis/N_207\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[2]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[2]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[6]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[6]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[6]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[6]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[12]\ : AOI1
      port map(A => \MyDAC/MyAD5360/ResetCounter_N_13_mux_2\, B
         => \MyDAC/MyAD5360/ResetCounter[11]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[12]_net_1\, Y => 
        \MyDAC/MyAD5360/N_273\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_05_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_05_Output_m[1]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[14]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[14]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[8]_net_1\);
    
    \MyDAC/TestGen/Counter_RNO[14]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[13]_net_1\, B => 
        \MyDAC/TestGen/Counter_c12\, C => 
        \MyDAC/TestGen/Counter[14]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n14\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_m2\ : 
        MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[22]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[23]_net_1\, 
        S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_25\);
    
    \MyDAC/MyAD5360/MyController/Mode_11_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_11_Output[0]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[7]\ : AO1
      port map(A => \MyDAC/PauseCounter[7]\, B => 
        \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/dout_m[7]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[7]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[0]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[0]_net_1\, B => 
        \MyDAC/TestGen/Counter[8]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_141\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[9]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[2]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_3[9]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[14]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[7]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIR7MK_0[0]\ : NOR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/TestGen/N_418\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIJRKI[6]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[6]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[6]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_6\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[0]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_732_0\, B => 
        \MyDAC/PauseCounter[0]\, C => \MyDAC/MyPackageDis/N_743\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_2\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_30\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_2_0\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_283\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_272\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[13]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_10_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[4]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_10_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[9]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA[7]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[7]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_1[3]\ : 
        MX2B
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_288\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_14\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_289\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI9VC0A[1]\ : NOR3A
      port map(A => \MyDAC/MyAD5360/N_348\, B => 
        \MyDAC/MyAD5360/ResetCounter[0]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[1]_net_1\, Y => 
        \MyDAC/MyAD5360/N_292_8\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[6]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI0UP01_0[3]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_80\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_170\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI2RAE1[22]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[22]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[22]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_24\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_15\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_17[0]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/Mode_10_Input[0]_net_1\, 
        B => \MyDAC/MyPackageDis/N_732_0\, C => 
        \MyDAC/MyPackageDis/N_90\, Y => 
        \MyDAC/MyPackageDis/Mode_10_Input_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[9]_net_1\);
    
    \SCLK_pad/U0/U0\ : IOPAD_TRI
      port map(D => \SCLK_pad/U0/NET1\, E => \SCLK_pad/U0/NET2\, 
        PAD => SCLK);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI3KEV\ : 
        NOR3B
      port map(A => \MyDAC/MyPackageDis/MyFIFO/dout[8]\, B => 
        \MyDAC/MyPackageDis/N_736\, C => 
        \MyDAC/MyPackageDis/N_131\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/N_190\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[6]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_588\, B => 
        \MyDAC/MyPackageDis/dout[6]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[6]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[6]\);
    
    \MyDAC/MyAD5360/MyController/Mode_08_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_08_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[12]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[31]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_749\, B => 
        \MyDAC/PauseCounter[31]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[7]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[31]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[33]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[33]_net_1\, B
         => \MyDAC/MyAD5360/N_502\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_14\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[5]\);
    
    \MyDAC/MyAD5360/MyController/Mode_13_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_13_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNI86O92[5]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_0[2]\, 
        B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_11_1[2]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_0[2]\, 
        Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a3_0_1[2]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[15]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_748\, B => 
        \MyDAC/PauseCounter[15]\, C => 
        \MyDAC/MyPackageDis/dout_m_0[7]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[15]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[11]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[11]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[12]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIKEGT[5]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_818\, B => 
        \MyDAC/MyPackageDis/N_86\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_12_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[14]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[14]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[14]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[4]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIL7UK[4]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_742_i_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_790\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_0[1]\ : AO1A
      port map(A => \MyDAC/TestGen/N_35\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_2_tz[1]\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_0[1]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_9[1]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_618\, B => 
        \MyDAC/MyPackageDis/Mode_13_Input[1]_net_1\, C => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_1[1]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_3[1]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIQJBE1[39]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[39]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[39]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_19\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_2\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_1[19]\ : OR2
      port map(A => \MyDAC/MyAD5360/N_267\, B => 
        \MyDAC/MyAD5360/ResetCounter_N_9_mux_2\, Y => 
        \MyDAC/MyAD5360/ResetCounter_n19_i_0\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[27]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m2_0_a2_3\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_N_6_mux_0_2\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[21]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[21]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[21]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]\ : 
        DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[6]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[6]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[6]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_14_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_14_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[4]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[21]\ : NOR3A
      port map(A => \MyDAC/PauseCounter[21]\, B => 
        \MyDAC/MyPackageDis/N_818\, C => 
        \MyDAC/MyPackageDis/N_743\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[21]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[18]\ : NOR2A
      port map(A => \MyDAC/PauseCounter[18]\, B => 
        \MyDAC/MyPackageDis/N_818\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[18]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[39]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[39]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[39]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNILNCQ[2]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[2]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[16]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_3[5]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[37]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_23\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[37]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[9]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[9]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[9]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[9]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[5]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNISD4P1[6]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[6]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[7]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_2\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_11_5\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[23]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[23]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[23]\);
    
    \MyDAC/MyAD5360/MyController/Mode_04_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_04_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[5]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIS8MK[2]\ : OR2B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/TestGen/N_19\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[11]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[11]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_2\, C => 
        \MyDAC/MyAD5360/N_267\, Y => 
        \MyDAC/MyAD5360/ResetCounter_RNO[11]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[3]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_732_0\, B => 
        \MyDAC/PauseCounter[3]\, C => \MyDAC/MyPackageDis/N_743\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[3]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[5]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[5]\);
    
    \NOT_BUSY_pad/U0/U1\ : IOIN_IB
      port map(YIN => \NOT_BUSY_pad/U0/NET1\, Y => NOT_BUSY_c);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[1]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_1[1]\ : OA1B
      port map(A => \MyDAC/TestGen/N_68\, B => 
        \MyDAC/TestGen/N_69\, C => \MyDAC/TestGen/N_35\, Y => 
        \MyDAC/TestGen/N_52\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[4]\ : NOR3A
      port map(A => \MyDAC/MyAD5360/N_189\, B => 
        \MyDAC/MyAD5360/ResetCounter_n4_i_0_0\, C => 
        \MyDAC/MyAD5360/N_366\, Y => 
        \MyDAC/MyAD5360/ResetCounter_RNO[4]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[0]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_163\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_6[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[9]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_00_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_00_Output_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_0[5]\ : NOR3C
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_4[1]\, 
        B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_13_5[1]\, 
        C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_1[1]\, 
        Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_2[1]\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_0[3]\ : OR3
      port map(A => \MyDAC/TestGen/N_393\, B => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_0[3]\, C => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_2[3]\, Y => 
        \MyDAC/TestGen/N_353\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNICSNJ1[3]\ : NOR3A
      port map(A => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE_0_0_a3_1_0\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, C => 
        \MyDAC/TestGen/N_33\, Y => \MyDAC/TestGen/N_48\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNINJ5N[26]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[26]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[26]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_26\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNICOUD_2[0]\ : NOR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_742_i_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[10]\ : OA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[9]_net_1\, B => 
        \MyDAC/MyAD5360/N_193\, C => 
        \MyDAC/MyAD5360/ResetCounter[10]_net_1\, Y => 
        \MyDAC/MyAD5360/N_271\);
    
    \MyDAC/MyPackageDis/Controller_Value[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[0]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_631\, Q => 
        \MyDAC/Controller_Value_EXPORT[0]\);
    
    \MyDAC/MyAD5360/MyController/Mode_11_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_11_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_09_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_09_Output[0]_net_1\);
    
    \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_RNO\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_0\, B => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4_0_1\, C => 
        \MyDAC/MyPackageDis/N_805\, Y => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_4\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[12]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[12]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[11]_net_1\);
    
    \MyDAC/MyPackageDis/Mode_08_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/dout[0]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_153\, Q => 
        \MyDAC/MyPackageDis/Mode_08_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIGJ1V_0[4]\ : NOR2B
      port map(A => \MyDAC/TestGen/N_20_i\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_415\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[7]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[7]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[10]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[10]_net_1\);
    
    \DEBUG_NOT_LDAC_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_NOT_LDAC_c, E => \VCC\, DOUT => 
        \DEBUG_NOT_LDAC_pad/U0/NET1\, EOUT => 
        \DEBUG_NOT_LDAC_pad/U0/NET2\);
    
    \MyDAC/TestGen/Counter_RNO[12]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[11]_net_1\, B => 
        \MyDAC/TestGen/Counter_c10\, C => 
        \MyDAC/TestGen/Counter[12]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n12\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNINGC91[2]\ : OR2A
      port map(A => \MyDAC/TestGen/N_19\, B => 
        \MyDAC/TestGen/N_412\, Y => \MyDAC/TestGen/N_38\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIBTAN1[5]\ : OA1B
      port map(A => \MyDAC/MyPackageDis/N_85\, B => 
        \MyDAC/MyPackageDis/N_110\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_158\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO[2]\ : 
        MX2B
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_18\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/i3_mux_0\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_23_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[4]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[4]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[4]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[4]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_0_1\ : 
        NOR2A
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_36\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_20\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_270_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/READ_AND\ : AND2A
      port map(A => \MyDAC/MyPackageDis/FIFO_EMPTY\, B => 
        \MyDAC/MyPackageDis/INPUT_READEN_INTERNAL_net_1\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/READ_ENABLE_I\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[9]\);
    
    \MyDAC/MyAD5360/ResetCounter[14]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_70\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[16]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]_net_1\, 
        B => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/N_1390\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[5]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_0[2]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0_0[2]\, 
        B => \MyDAC/MyPackageDis/N_219\, C => 
        \MyDAC/MyPackageDis/N_220\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0_2[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_12_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_12_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_4[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d_1[27]\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_39\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIHA5M[37]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[37]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[29]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_2[2]\);
    
    \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[1]\, B => 
        \MyDAC/MyAD5360/MyController/N_54\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNICOUD_1[0]\ : OR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_83\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[15]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_2[2]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/N_234\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_219\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[9]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI08I8[5]\ : XNOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_104\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[8]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[8]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[8]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[8]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[13]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[6]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_3[3]\ : AO1
      port map(A => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_a5_2_0[3]\, B => 
        \MyDAC/TestGen/N_415\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15k_0_a2_i_2[3]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNID1HM[0]\ : NOR3A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, C => 
        \MyDAC/MyPackageDis/N_736\, Y => 
        \MyDAC/MyPackageDis/N_829\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[5]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[8]\ : AND3B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, C => 
        \MyDAC/TestGen/N_419\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[49]\);
    
    \MyDAC/MyAD5360/ResetCounter[29]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_157\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[29]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[5]_net_1\);
    
    \DEBUG_GPIO_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_GPIO_c, E => \VCC\, DOUT => 
        \DEBUG_GPIO_pad/U0/NET1\, EOUT => 
        \DEBUG_GPIO_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[10]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIGJ1V[2]\ : NOR2A
      port map(A => \MyDAC/TestGen/N_64_1\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/TestGen/N_417\);
    
    \MyDAC/MyAD5360/ResetCounter[35]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_27\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[35]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[39]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[39]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[39]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[0]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[32]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/PauseCounter[32]\, C => \MyDAC/MyPackageDis/N_740\, 
        Y => \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[32]\);
    
    \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa_0_a2_0\ : 
        NOR3B
      port map(A => \MyDAC/Controller_Valid_EXPORT\, B => 
        \MyDAC/Controller_ChannelID_EXPORT[0]\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[2]\, Y => 
        \MyDAC/MyAD5360/MyController/N_53\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[5]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIHPAF2[1]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_147\, B => 
        \MyDAC/MyPackageDis/N_150\, C => 
        \MyDAC/MyPackageDis/N_151\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_4[1]\);
    
    \MyDAC/MyPackageDis/MyFIFO/_FIFOBLOCK[0]_\ : FIFO4K18
      port map(AEVAL11 => \GND\, AEVAL10 => \GND\, AEVAL9 => 
        \GND\, AEVAL8 => \GND\, AEVAL7 => \GND\, AEVAL6 => \GND\, 
        AEVAL5 => \GND\, AEVAL4 => \GND\, AEVAL3 => \GND\, AEVAL2
         => \VCC\, AEVAL1 => \GND\, AEVAL0 => \GND\, AFVAL11 => 
        \VCC\, AFVAL10 => \VCC\, AFVAL9 => \VCC\, AFVAL8 => \VCC\, 
        AFVAL7 => \VCC\, AFVAL6 => \VCC\, AFVAL5 => \VCC\, AFVAL4
         => \VCC\, AFVAL3 => \GND\, AFVAL2 => \GND\, AFVAL1 => 
        \GND\, AFVAL0 => \GND\, WD17 => \GND\, WD16 => \GND\, 
        WD15 => \GND\, WD14 => \GND\, WD13 => \GND\, WD12 => 
        \GND\, WD11 => \GND\, WD10 => \GND\, WD9 => \GND\, WD8
         => \GND\, WD7 => \GND\, WD6 => \GND\, WD5 => \GND\, WD4
         => \GND\, WD3 => \MyDAC/INPUT_DATA_TG[3]\, WD2 => 
        \MyDAC/INPUT_DATA_TG[2]\, WD1 => \MyDAC/INPUT_DATA_TG[1]\, 
        WD0 => \MyDAC/INPUT_DATA_TG[0]\, WW0 => \GND\, WW1 => 
        \VCC\, WW2 => \GND\, RW0 => \GND\, RW1 => \VCC\, RW2 => 
        \GND\, RPIPE => \VCC\, WEN => 
        \MyDAC/MyPackageDis/MyFIFO/WRITE_ENABLE_I\, REN => 
        \MyDAC/MyPackageDis/MyFIFO/READ_ENABLE_I\, WBLK => \GND\, 
        RBLK => \GND\, WCLK => Clk_c, RCLK => Clk_c, RESET => 
        Reset_c, ESTOP => \VCC\, FSTOP => \VCC\, RD17 => OPEN, 
        RD16 => OPEN, RD15 => OPEN, RD14 => OPEN, RD13 => OPEN, 
        RD12 => OPEN, RD11 => OPEN, RD10 => OPEN, RD9 => OPEN, 
        RD8 => OPEN, RD7 => OPEN, RD6 => OPEN, RD5 => OPEN, RD4
         => OPEN, RD3 => \MyDAC/MyPackageDis/dout[3]\, RD2 => 
        \MyDAC/MyPackageDis/dout[2]\, RD1 => 
        \MyDAC/MyPackageDis/dout[1]\, RD0 => 
        \MyDAC/MyPackageDis/dout[0]\, FULL => 
        \MyDAC/MyPackageDis/MyFIFO/Z\\\\FULLX_I[0]\\\\\, AFULL
         => \MyDAC/MyPackageDis/MyFIFO/Z\\\\AFULLX_I[0]\\\\\, 
        EMPTY => \MyDAC/MyPackageDis/MyFIFO/Z\\\\EMPTYX_I[0]\\\\\, 
        AEMPTY => OPEN);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_4[1]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_232\, B => 
        \MyDAC/MyPackageDis/Mode_08_Input[1]_net_1\, C => 
        \MyDAC/MyPackageDis/N_94\, Y => 
        \MyDAC/MyPackageDis/Mode_08_Input_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNITCBT_0\ : 
        OR2
      port map(A => \MyDAC/MyPackageDis/MyFIFO/dout[8]\, B => 
        \MyDAC/MyPackageDis/N_80\, Y => \MyDAC/MyPackageDis/N_91\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[4]\ : 
        OAI1
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i6_mux\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[4]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[4]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI7BL71_0[1]\ : 
        CLKINT
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI7BL71[1]_net_1\, 
        Y => \MyDAC/MyPackageDis/N_743\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[1]\ : XNOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[0]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[1]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_n1_i_0_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[11]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[11]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[9]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[9]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[9]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[5]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_2[3]\ : 
        NOR2
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_2\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_288\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI8T6E1[15]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[15]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[15]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_16\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_13\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIE7H26[0]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_2[0]\, B => 
        \MyDAC/MyPackageDis/N_189\, C => 
        \MyDAC/MyPackageDis/N_188\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_7[0]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[37]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[5]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[37]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[37]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[32]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_16\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[32]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIRA4H[0]\ : NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, B => 
        \MyDAC/MyPackageDis/N_826\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_792\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[1]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[1]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[14]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_06_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_06_Input[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIC8AB1[3]\ : NOR3B
      port map(A => \MyDAC/MyPackageDis/N_91\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_178\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7KS6[1]\ : NOR3
      port map(A => \MyDAC/MyPackageDis/N_247\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_2[4]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_3[4]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7KS6[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[15]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[7]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[0]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[0]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[22]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[22]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_13_mux_0\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => \MyDAC/MyAD5360/N_29\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_20[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa_0_a2\ : 
        NOR3B
      port map(A => \MyDAC/Controller_ChannelID_EXPORT[1]\, B => 
        \MyDAC/MyAD5360/MyController/N_49\, C => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\, Y => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_0[2]\ : XA1A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/TestGen/N_21\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_i_0_a3_0[2]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO[2]\ : NOR2
      port map(A => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0_2[2]\, 
        B => \MyDAC/MyPackageDis/N_762\, Y => 
        \MyDAC/MyPackageDis/N_725\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[9]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_09_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_09_Output_m[1]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[12]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[12]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/Busy\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/MyDAC/Busy_RNO_net_1\, CLK
         => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/Output_Busy_i_0\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO[3]\ : NOR3
      port map(A => \MyDAC/TestGen/N_58\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, C => 
        \MyDAC/TestGen/N_57\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_RNO[3]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[6]\ : DFN1P0
      port map(D => \GND\, CLK => Clk_c, PRE => Reset_c, Q => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO[0]\ : 
        OR3
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_41\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_38\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_ns_0_0_2[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_ns[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[11]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[11]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[22]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[22]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[22]_net_1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_2[1]\ : 
        AXOI2
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/i5_mux_3\);
    
    \MyDAC/MyPackageDis/Mode_04_Input[0]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[0]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_04_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO_0[5]\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNIDRIG_0[2]\ : OA1B
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[6]_net_1\, B
         => \MyDAC/MyAD5360/SPIMACHINE_STATE[2]_net_1\, C => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/MyAD5360/N_267_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[8]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNITS821[2]\ : OR2A
      port map(A => \MyDAC/MyPackageDis/N_88\, B => 
        \MyDAC/MyPackageDis/N_230\, Y => 
        \MyDAC/MyPackageDis/N_762\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[5]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[5]_net_1\, CLK => 
        Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[8]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[37]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[37]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[37]\);
    
    \MyDAC/MyPackageDis/Controller_SPIACTION_INTERNAL\ : DFN1E1C0
      port map(D => \MyDAC/MyPackageDis/N_207\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/MyPackageDis/N_963\, Q => 
        \MyDAC/Controller_SPIACTION\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[33]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[32]_net_1\, B
         => \MyDAC/MyAD5360/N_501\, Y => \MyDAC/MyAD5360/N_502\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[16]\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/N_1426\, B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1[18]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_2[16]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[16]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[10]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNIFDGA\ : 
        NOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, B => 
        \MyDAC/MyPackageDis/MyFIFO/dout[8]\, Y => 
        \MyDAC/MyPackageDis/MyFIFO/SPIMACHINE_STATE_ns_0_i_a2_9_0[1]\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID[3]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/N_723\, CLK => Clk_c, CLR
         => Reset_c, E => \MyDAC/MyPackageDis/N_629\, Q => 
        \MyDAC/Controller_ChannelID_EXPORT[3]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIDBJ33[23]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_6\, B
         => \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_5\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[17]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[17]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[17]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIFHFHD[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI914M[26]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[26]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_2\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[7]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMNK6M[2]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_103\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_11[0]\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_12[0]\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIMNK6M[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[12]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[12]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[15]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[0]\ : MX2
      port map(A => \MyDAC/TestGen/N_109\, B => 
        \MyDAC/TestGen/N_141\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Mode_10_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_10_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIQPN25[3]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_9\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_8\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_25\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_32\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI3F7S[0]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_33\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[22]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_00_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_01_Output_m[0]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[22]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[6]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI2RAE1[36]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[36]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[36]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_10\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_5\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[15]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[15]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[26]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[25]_net_1\, B
         => \MyDAC/MyAD5360/N_210\, Y => \MyDAC/MyAD5360/N_211\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[23]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_11_Output[1]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_11_Output_m[1]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI4CQI[0]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_283\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[10]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[10]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI4BS91[38]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[38]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[38]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_0\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_7\);
    
    \MyDAC/MyAD5360/ResetCounter_RNILODQ[23]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[4]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[23]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_6[5]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[8]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[8]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO[4]\ : 
        MX2C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/i6_mux\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_39_mux\, S => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_0[4]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[14]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[14]_net_1\, B
         => \MyDAC/MyAD5360/N_199\, C => \MyDAC/MyAD5360/N_267\, 
        Y => \MyDAC/MyAD5360/N_70\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[4]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[4]\);
    
    \MyDAC/MyAD5360/MyController/Mode_13_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_13_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[5]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[5]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[5]_net_1\);
    
    \SCLK_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => SCLK_c, E => \VCC\, DOUT => 
        \SCLK_pad/U0/NET1\, EOUT => \SCLK_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[11]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNITC4H[5]\ : NOR3B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[5]_net_1\, B => 
        \MyDAC/MyPackageDis/N_94\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_789\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[3]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[3]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[8]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[8]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_00_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_00_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[0]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[0]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/Controller_SetMode_18[1]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyPackageDis/N_629\, Q => 
        \MyDAC/Controller_SetMode_EXPORT[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[10]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[10]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[10]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[10]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[7]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[7]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[7]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[34]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[2]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[34]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[34]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_01_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[3]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[3]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_DELAYED_RNI0D5B\ : 
        NOR3C
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_DELAYED_net_1\, 
        B => Reset_c, C => Clk_c, Y => SCLK_c);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI7FKI[0]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[0]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[0]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[4]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[4]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI3GMK[4]\ : OR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/TestGen/N_21\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[15]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[15]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[11]\);
    
    \MyDAC/MyAD5360/SPI_START_LAST\ : DFN1P0
      port map(D => \MyDAC/MyAD5360/SPI_START_i\, CLK => Clk_c, 
        PRE => Reset_c, Q => \MyDAC/MyAD5360/SPI_START_LAST_i_0\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIAJHC1[0]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/N_803_1\, B => 
        \MyDAC/MyPackageDis/N_736\, C => 
        \MyDAC/MyPackageDis/N_80\, Y => 
        \MyDAC/MyPackageDis/N_199\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI4CQI_2[3]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_3_0\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[6]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[6]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_d[27]\, 
        Q => 
        \MyDAC/MyAD5360/MyController/MyDAC/DATABUFFER[6]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP84H[1]\ : AOI1
      port map(A => \MyDAC/MyPackageDis/N_83\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[1]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_a2_2_0[4]\);
    
    \Clk_pad/U0/U0\ : IOPAD_IN
      port map(PAD => Clk, Y => \Clk_pad/U0/NET1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIABM39[1]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNII38Q2[3]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_6[1]\, C
         => \MyDAC/MyPackageDis/N_103\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_10[1]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_14[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_15_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_15_Output_m[0]\);
    
    \MISO_pad/U0/U1\ : IOIN_IB
      port map(YIN => \MISO_pad/U0/NET1\, Y => MISO_c);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI3GMK_0[4]\ : NOR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/TestGen/N_486_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[4]\ : OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[4]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[4]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[4]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIFRUD_0[0]\ : NOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_3_0[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[12]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[12]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[12]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[12]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_6_1\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_6_1\);
    
    \MyDAC/TestGen/Counter_RNO[15]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c14\, B => 
        \MyDAC/TestGen/Counter[15]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n15\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIRA4H_0[3]\ : AOI1
      port map(A => \MyDAC/MyPackageDis/N_83\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_824\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[14]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[14]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[11]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[11]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[11]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[11]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[11]\);
    
    \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[7]\ : MX2
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        S => \MyDAC/MyAD5360/MyController/un3_output_busy\, Y => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNO[7]_net_1\);
    
    \DEBUG_NOT_RESET_DAC_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_NOT_RESET_DAC_pad/U0/NET1\, E => 
        \DEBUG_NOT_RESET_DAC_pad/U0/NET2\, PAD => 
        DEBUG_NOT_RESET_DAC);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI8V8E1[28]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[28]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[28]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_12\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_4\);
    
    \MyDAC/MyAD5360/MyController/Mode_02_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_02_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIGJDQ[21]\ : NOR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[1]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[21]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_0[5]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIL7UK[5]\ : OR2
      port map(A => \MyDAC/MyPackageDis/N_240\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_730\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO[3]\ : MX2A
      port map(A => \MyDAC/TestGen/N_353\, B => 
        \MyDAC/TestGen/N_144\, S => \MyDAC/TestGen/N_39\, Y => 
        \MyDAC/TestGen/INPUT_DATA_15[3]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIHPKI[5]\ : XOR2
      port map(A => \MyDAC/MyAD5360/PauseCounter_Output[5]_net_1\, 
        B => \MyDAC/MyAD5360/ResetCounter[5]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_5\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[11]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[11]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[11]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[11]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[0]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[0]_net_1\);
    
    \MyDAC/TestGen/Counter[10]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n10\, CLK => Clk_c, 
        CLR => Reset_c, E => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Q => 
        \MyDAC/TestGen/Counter[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_3[11]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[11]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[16]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[16]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[16]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_06_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[10]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[10]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_18[11]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[11]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_02_Output_m[11]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[11]\);
    
    \MyDAC/MyAD5360/MyController/Mode_04_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_04_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[13]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[13]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[24]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[24]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[24]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI2D7K9[23]\ : OR2A
      port map(A => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, B
         => \MyDAC/MyAD5360/N_208\, Y => \MyDAC/MyAD5360/N_209\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[5]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[5]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[5]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNIFD7N[31]\ : XOR2
      port map(A => 
        \MyDAC/MyAD5360/PauseCounter_Output[31]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[31]_net_1\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_31\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[3]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[3]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[3]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[3]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[3]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[7]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[32]\ : AO1
      port map(A => \MyDAC/MyPackageDis/N_200\, B => 
        \MyDAC/MyPackageDis/dout[0]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[32]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[32]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[35]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[35]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[35]_net_1\);
    
    \MyDAC/MyAD5360/MyController/GPIO_RNO\ : AX1C
      port map(A => \MyDAC/MyAD5360/MyController/un3_output_busy\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[16]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/GPIO_net_1\, Y => 
        \MyDAC/MyAD5360/MyController/GPIO_RNO_net_1\);
    
    \MyDAC/TestGen/Counter[14]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n14\, CLK => Clk_c, 
        CLR => Reset_c, E => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Q => 
        \MyDAC/TestGen/Counter[14]_net_1\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNISU9O2[29]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_37\, B => 
        \MyDAC/MyAD5360/un11_resetcounter_29\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_7\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_23\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI2VEE1[34]\ : XO1
      port map(A => \MyDAC/MyAD5360/ResetCounter[34]_net_1\, B
         => \MyDAC/MyAD5360/PauseCounter_Output[34]_net_1\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_30\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[7]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_07_Output_m[7]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[22]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[22]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[22]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[7]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[7]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[7]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[7]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[4]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[18]\ : 
        NOR3A
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_1[18]\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        C => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[14]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_1_iv_0_0_a2_2[18]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_00_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_00_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Input[1]_net_1\);
    
    \DEBUG_MISO_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => DEBUG_MISO_c, E => \VCC\, DOUT => 
        \DEBUG_MISO_pad/U0/NET1\, EOUT => 
        \DEBUG_MISO_pad/U0/NET2\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_0[1]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/N_348\, B => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_12[5]\, C
         => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a3_0_0[5]\, 
        Y => \MyDAC/MyAD5360/N_294\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_09_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[10]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_50\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output[12]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[1]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI720T[3]\ : AOI1
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[4]_net_1\, C => 
        \MyDAC/MyPackageDis/N_80\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_0_0[0]\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_10[0]\ : NOR2B
      port map(A => \MyDAC/MyPackageDis/Mode_02_Input[0]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[28]\, Y => 
        \MyDAC/MyPackageDis/Mode_02_Input_m[0]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[18]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[18]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_0[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[18]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIF3HM[3]\ : NOR2A
      port map(A => \MyDAC/MyPackageDis/N_95\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_231\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_7[1]\ : 
        NOR2
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_Valid_net_1\, B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[2]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_294\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[6]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI4CQI_1[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_2\);
    
    \MyDAC/MyAD5360/ResetCounter[18]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/N_81\, CLK => Clk_c, CLR => 
        Reset_c, Q => \MyDAC/MyAD5360/ResetCounter[18]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI1N1M[12]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[12]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[11]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_0_0_a2_1[5]\);
    
    
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNI7FQI[4]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[4]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/MyDAC/N_282\);
    
    \MyDAC/MyAD5360/MyController/Mode_03_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_03_Input[0]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIEQUD[0]\ : XNOR2
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_92\);
    
    \MyDAC/MyPackageDis/Controller_SetMode_RNO_11[0]\ : AO1
      port map(A => \MyDAC/MyPackageDis/Mode_03_Input[0]_net_1\, 
        B => \MyDAC/MyPackageDis/SPIMACHINE_STATE_d[25]\, C => 
        \MyDAC/MyPackageDis/Mode_10_Input_m[0]\, Y => 
        \MyDAC/MyPackageDis/Controller_SetMode_18_iv_9[0]\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE_RNIH4LU[2]\ : OR2B
      port map(A => \MyDAC/MyAD5360/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/MyAD5360/un3_controller_busy\, Y => 
        \MyDAC/MyAD5360/N_38\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[6]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[6]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI2JHI7[5]\ : OR3
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_3[2]\, B => 
        \MyDAC/MyPackageDis/N_175\, C => 
        \MyDAC/MyPackageDis/N_174\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_0_i_5[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[3]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_ChannelID_RNO_1[1]\ : AO1A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_241\, C => 
        \MyDAC/MyPackageDis/N_813\, Y => 
        \MyDAC/MyPackageDis/Controller_ChannelID_18_0_i_0[1]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[15]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNI0UP01[3]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, B => 
        \MyDAC/MyPackageDis/N_80\, Y => \MyDAC/MyPackageDis/N_85\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO[14]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[14]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[14]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[14]\);
    
    \MyDAC/MyAD5360/MyController/Mode_14_Output[1]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_14_Input[1]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_14_Output[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_02_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[5]\);
    
    \MyDAC/MyAD5360/MyController/Busy\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE_RNIOUN7[17]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/Busy_i_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_02_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[7]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[32]\ : XA1C
      port map(A => \MyDAC/MyAD5360/ResetCounter[32]_net_1\, B
         => \MyDAC/MyAD5360/N_501\, C => \MyDAC/MyAD5360/N_267_0\, 
        Y => \MyDAC/MyAD5360/N_16\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI74IK[0]\ : OR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[0]_net_1\, B
         => \MyDAC/INPUT_FULL\, Y => \MyDAC/TestGen/N_35\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNI5RA41\ : 
        NOR2A
      port map(A => \MyDAC/MyPackageDis/MyFIFO/dout[8]\, B => 
        \MyDAC/MyPackageDis/N_85\, Y => 
        \MyDAC/MyPackageDis/N_229\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[19]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_598\, B => 
        \MyDAC/MyPackageDis/dout[3]\, C => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_m[19]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[19]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[11]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[5]\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO[28]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_734\, B => 
        \MyDAC/PauseCounter[28]\, C => 
        \MyDAC/MyPackageDis/dout_m_2[4]\, Y => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[28]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_11[23]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_00_Output_m[1]\, B => 
        \MyDAC/MyAD5360/MyController/Mode_05_Output_m[1]\, C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[23]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_8[23]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[14]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[14]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[14]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[14]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[14]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_07_Input[13]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[13]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_07_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Input[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_17[3]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[3]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_05_Output_m[3]\);
    
    \DEBUG_NOT_CLR_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_NOT_CLR_pad/U0/NET1\, E => 
        \DEBUG_NOT_CLR_pad/U0/NET2\, PAD => DEBUG_NOT_CLR);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_1[8]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output_m[8]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[8]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[8]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_10[8]\);
    
    \MyDAC/TestGen/Counter_RNO[11]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter_c10\, B => 
        \MyDAC/TestGen/Counter[11]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n11\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[2]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIT9MK_0[2]\ : OR2
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[1]_net_1\, Y => 
        \MyDAC/TestGen/N_23\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[12]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[12]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[2]\ : XOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[2]_net_1\, B => 
        \MyDAC/MyAD5360/N_186\, Y => 
        \MyDAC/MyAD5360/ResetCounter_n2_i_0_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[4]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Output[4]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[4]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[4]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[14]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[14]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[14]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_12[9]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[9]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[1]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[9]\);
    
    \MyDAC/TestGen/Counter_RNO[1]\ : XOR2
      port map(A => \MyDAC/TestGen/Counter[0]_net_1\, B => 
        \MyDAC/TestGen/Counter[1]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n1\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE_RNO_2[2]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/SPIMACHINE_STATE[0]_net_1\, 
        B => \MyDAC/MyAD5360/MyController/MyDAC/N_14\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_15_0\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[15]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[15]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_4[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIC44M[27]\ : NOR2B
      port map(A => \MyDAC/MyAD5360/ResetCounter[27]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[25]_net_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m3_0_a2_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[1]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[1]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[1]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[1]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[1]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIP7KS6[1]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\);
    
    \MyDAC/TestGen/INPUT_DATA_RNO_1[3]\ : MX2
      port map(A => \MyDAC/TestGen/Counter[3]_net_1\, B => 
        \MyDAC/TestGen/Counter[11]_net_1\, S => 
        \MyDAC/TestGen/un1_SPIMACHINE_STATE\, Y => 
        \MyDAC/TestGen/N_144\);
    
    \MyDAC/MyAD5360/PauseCounter_Output[22]\ : DFN1E1C0
      port map(D => \MyDAC/PauseCounter[22]\, CLK => Clk_c, CLR
         => Reset_c, E => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[4]_net_1\, Q => 
        \MyDAC/MyAD5360/PauseCounter_Output[22]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_10_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_10_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_10_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[18]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36[18]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[18]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_5[22]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_12_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[3]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Mode_14_Output_m[0]\, Y
         => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[22]\);
    
    \MyDAC/MyAD5360/MyController/Mode_08_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_08_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[13]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[13]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_05_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_05_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[25]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[25]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[25]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNINBIB3[6]\ : OR3B
      port map(A => \MyDAC/MyAD5360/ResetCounter[5]_net_1\, B => 
        \MyDAC/MyAD5360/ResetCounter[6]_net_1\, C => 
        \MyDAC/MyAD5360/N_189\, Y => \MyDAC/MyAD5360/N_191\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_10[12]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_05_Output[12]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[10]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[12]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[12]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_11_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Input[8]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIEQUD_0[0]\ : OR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[0]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_131\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_4\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_0\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_34\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_273\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_4\);
    
    \MyDAC/MyPackageDis/Mode_05_Input[1]\ : DFN1E0C0
      port map(D => \MyDAC/MyPackageDis/dout[3]\, CLK => Clk_c, 
        CLR => Reset_c, E => \MyDAC/MyPackageDis/N_582\, Q => 
        \MyDAC/MyPackageDis/Mode_05_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[28]\ : XA1B
      port map(A => \MyDAC/MyAD5360/ResetCounter[28]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter_N_7_mux_0_0\, C => 
        \MyDAC/MyAD5360/N_267_0\, Y => \MyDAC/MyAD5360/N_155\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIOAUK_0[4]\ : OR2A
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[4]_net_1\, B => 
        \MyDAC/MyPackageDis/N_241\, Y => 
        \MyDAC/MyPackageDis/N_95\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI1F3R4[3]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_110\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_0_0[0]\, C
         => \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_3[0]\, Y
         => \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_6[0]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNI826M[30]\ : NOR2
      port map(A => \MyDAC/MyAD5360/ResetCounter[30]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[36]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_1[2]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_1\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_282\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_31\, C => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_285\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_271\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[0]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[0]\, 
        B => \MyDAC/MyAD5360/MyController/Buffer_14_Output_m[0]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[0]\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI2FMK_0[5]\ : NOR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/TestGen/G_1_0_0_a3_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_9[0]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_02_Output[0]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[13]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_04_Output_m[0]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_2[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_13[6]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[6]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[6]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[6]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_06_Output[4]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Input[4]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_06_Output[4]_net_1\);
    
    \MyDAC/TestGen/Counter[15]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n15\, CLK => Clk_c, 
        CLR => Reset_c, E => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Q => 
        \MyDAC/TestGen/Counter[15]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIFRUD_0[3]\ : NOR2B
      port map(A => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[3]_net_1\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE[2]_net_1\, Y => 
        \MyDAC/MyPackageDis/N_826\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL[4]\ : DFN1E0C0
      port map(D => 
        \MyDAC/MyPackageDis/PauseCounter_INTERNAL_7[4]\, CLK => 
        Clk_c, CLR => Reset_c, E => \MyDAC/MyPackageDis/N_743\, Q
         => \MyDAC/PauseCounter[4]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[16]\ : NOR3A
      port map(A => \MyDAC/MyAD5360/N_202\, B => 
        \MyDAC/MyAD5360/N_279\, C => \MyDAC/MyAD5360/N_267_0\, Y
         => \MyDAC/MyAD5360/N_20\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Input[1]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[1]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_03_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter[11]\ : DFN1C0
      port map(D => \MyDAC/MyAD5360/ResetCounter_RNO[11]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/ResetCounter[11]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIK4EN1[24]\ : NOR3A
      port map(A => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_11[2]\, B
         => \MyDAC/MyAD5360/ResetCounter[24]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter[31]_net_1\, Y => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_ns_i_a2_i_0_a2_17[2]\);
    
    \MyDAC/MyAD5360/PauseCounter_Output_RNI6PTK5[28]\ : OR3
      port map(A => \MyDAC/MyAD5360/un11_resetcounter_NE_5\, B
         => \MyDAC/MyAD5360/un11_resetcounter_NE_4\, C => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_23\, Y => 
        \MyDAC/MyAD5360/un11_resetcounter_NE_31\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO[3]\ : NOR3A
      port map(A => \MyDAC/MyAD5360/N_188\, B => 
        \MyDAC/MyAD5360/ResetCounter_n3_i_0_0\, C => 
        \MyDAC/MyAD5360/N_366\, Y => 
        \MyDAC/MyAD5360/ResetCounter_RNO[3]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIHK1V[5]\ : NOR2B
      port map(A => \MyDAC/TestGen/N_69_1\, B => 
        \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, Y => 
        \MyDAC/TestGen/N_69\);
    
    \MyDAC/MyAD5360/SPIMACHINE_STATE[1]\ : DFN1C0
      port map(D => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE_RNO_1[1]_net_1\, CLK => 
        Clk_c, CLR => Reset_c, Q => 
        \MyDAC/MyAD5360/SPIMACHINE_STATE[1]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_11_Input[0]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_SetMode_EXPORT[0]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_11_Input_0_sqmuxa\, Q
         => \MyDAC/MyAD5360/MyController/Mode_11_Input[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_09_Output[15]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Input[15]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_09_Output[15]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[8]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[8]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[8]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_13_Input[3]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[3]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_13_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_13_Input[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_08_Input[9]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[9]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_08_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Input[9]_net_1\);
    
    \MyDAC/MyPackageDis/Controller_Valid\ : DFN1C0
      port map(D => 
        \MyDAC/MyPackageDis/Controller_Valid_RNO_net_1\, CLK => 
        Clk_c, CLR => Reset_c, Q => 
        \MyDAC/Controller_Valid_EXPORT\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_16[1]\ : 
        NOR2A
      port map(A => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output[1]_net_1\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Buffer_07_Output_i_m[1]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SCLK_GATE_RNO_0\ : OR2
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_282\, B
         => \MyDAC/MyAD5360/MyController/MyDAC/N_283\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_12_i_0_0_1\);
    
    \MyDAC/MyAD5360/MyController/Mode_04_Output[0]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input[0]_net_1\, CLK
         => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Mode_04_Output[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[6]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[6]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[6]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_01_Output[12]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Input[12]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_01_Output[12]_net_1\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNI2FMK[5]\ : OR2B
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[5]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/TestGen/N_36\);
    
    \MyDAC/TestGen/INPUT_DATA[0]\ : DFN1C0
      port map(D => \MyDAC/TestGen/INPUT_DATA_15[0]\, CLK => 
        Clk_c, CLR => Reset_c, Q => \MyDAC/INPUT_DATA_TG[0]\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_RNIVB213[5]\ : AO1A
      port map(A => \MyDAC/MyPackageDis/N_85\, B => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_a2_12_0[0]\, 
        C => \MyDAC/MyPackageDis/N_191\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_ns_i_i_10[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_12_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_12_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_12_Input[2]_net_1\);
    
    \MyDAC/TestGen/Counter_RNO[10]\ : AX1C
      port map(A => \MyDAC/TestGen/Counter[9]_net_1\, B => 
        \MyDAC/TestGen/Counter_c8\, C => 
        \MyDAC/TestGen/Counter[10]_net_1\, Y => 
        \MyDAC/TestGen/Counter_n10\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIJC3A5[0]\ : OR3
      port map(A => \MyDAC/MyPackageDis/N_761\, B => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_13_i_2\, C => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_13_i_3\, Y => 
        \MyDAC/MyPackageDis/N_631\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI7BL71[1]\ : OR3A
      port map(A => \MyDAC/MyPackageDis/N_728_i\, B => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_10_i_o2_0_0\, C
         => \MyDAC/MyPackageDis/N_730\, Y => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNI7BL71[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNIO88C1[27]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter[27]_net_1\, B
         => \MyDAC/MyAD5360/ResetCounter[28]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_0\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m6_0_a2_4_5\);
    
    \MyDAC/MyAD5360/MyController/Buffer_04_Input[2]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[2]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_04_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_04_Input[2]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Buffer_03_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[3]_net_1\);
    
    \MyDAC/MyPackageDis/SPIMACHINE_STATE_0_RNIAT9K[2]\ : OA1C
      port map(A => \MyDAC/MyPackageDis/N_737\, B => 
        \MyDAC/MyPackageDis/un1_SPIMACHINE_STATE_12_i_o2_0_0\, C
         => \MyDAC/MyPackageDis/SPIMACHINE_STATE_0[2]_net_1\, Y
         => \MyDAC/MyPackageDis/N_230\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[15]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[15]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[15]\);
    
    \MyDAC/MyPackageDis/MyFIFO/\\\\FIFOBLOCK[2]\\\\_RNITCBT\ : 
        OR2A
      port map(A => \MyDAC/MyPackageDis/MyFIFO/dout[8]\, B => 
        \MyDAC/MyPackageDis/N_80\, Y => \MyDAC/MyPackageDis/N_99\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[2]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[2]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[2]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[2]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[2]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_10_Output[7]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Input[7]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_10_Output[7]_net_1\);
    
    \MyDAC/TestGen/Counter_RNI2SOS4[10]\ : NOR3C
      port map(A => \MyDAC/TestGen/Counter[9]_net_1\, B => 
        \MyDAC/TestGen/Counter_c8\, C => 
        \MyDAC/TestGen/Counter[10]_net_1\, Y => 
        \MyDAC/TestGen/Counter_c10\);
    
    \MyDAC/TestGen/Counter[13]\ : DFN1E1C0
      port map(D => \MyDAC/TestGen/Counter_n13\, CLK => Clk_c, 
        CLR => Reset_c, E => 
        \MyDAC/TestGen/SPIMACHINE_STATE_d[16]\, Q => 
        \MyDAC/TestGen/Counter[13]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_8[13]\ : 
        AO1
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_08_Output[13]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[7]_net_1\, 
        C => \MyDAC/MyAD5360/MyController/Buffer_09_Output_m[13]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_5[13]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_19[14]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Output[14]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[0]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_15_Output_m[14]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_0[9]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_11_Output_m[9]\, B
         => \MyDAC/MyAD5360/MyController/Buffer_10_Output_m[9]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_7[9]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_11[9]\);
    
    \MyDAC/MyAD5360/MyController/MyDAC/SPIFSM.MOSI_25_iv_0_a2_11\ : 
        NOR3C
      port map(A => \MyDAC/MyAD5360/MyController/MyDAC/N_282\, B
         => 
        \MyDAC/MyAD5360/MyController/MyDAC/MOSI_25_iv_0_a2_11_0\, 
        C => \MyDAC/MyAD5360/MyController/MyDAC/N_36\, Y => 
        \MyDAC/MyAD5360/MyController/MyDAC/N_281\);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNIVBMK_1[2]\ : NOR2A
      port map(A => \MyDAC/TestGen/SPIMACHINE_STATE[2]_net_1\, B
         => \MyDAC/TestGen/SPIMACHINE_STATE[3]_net_1\, Y => 
        \MyDAC/TestGen/N_69_1\);
    
    \MyDAC/MyPackageDis/PauseCounter_INTERNAL_RNO_0[31]\ : NOR3A
      port map(A => \MyDAC/MyPackageDis/dout[7]\, B => 
        \MyDAC/MyPackageDis/N_740\, C => 
        \MyDAC/MyPackageDis/SPIMACHINE_STATE_s13_i_0\, Y => 
        \MyDAC/MyPackageDis/dout_m_2[7]\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_1[27]\ : NOR3C
      port map(A => \MyDAC/MyAD5360/ResetCounter_m2_0_a2_0\, B
         => \MyDAC/MyAD5360/ResetCounter[23]_net_1\, C => 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_1\, Y => 
        \MyDAC/MyAD5360/ResetCounter_m2_0_a2_3\);
    
    \MyDAC/MyAD5360/MyController/Buffer_15_Input[10]\ : DFN1E1C0
      port map(D => \MyDAC/Controller_Value_EXPORT[10]\, CLK => 
        Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Mode_15_Input_0_sqmuxa\, Q
         => 
        \MyDAC/MyAD5360/MyController/Buffer_15_Input[10]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_2[6]\ : 
        OR3
      port map(A => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_1[6]\, 
        B => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_0[6]\, 
        C => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_9[6]\, 
        Y => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv_12[6]\);
    
    \MyDAC/TestGen/Counter[0]\ : DFN1C0
      port map(D => \MyDAC/TestGen/Counter_e0\, CLK => Clk_c, CLR
         => Reset_c, Q => \MyDAC/TestGen/Counter[0]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString[1]\ : 
        DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Output_24BitString_36_iv[1]\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/Output_Valid_3\, Q => 
        \MyDAC/MyAD5360/MyController/Output_24BitString[1]_net_1\);
    
    \MyDAC/MyAD5360/ResetCounter_RNO_0[4]\ : AO1A
      port map(A => \MyDAC/MyAD5360/ResetCounter[4]_net_1\, B => 
        \MyDAC/MyAD5360/N_188\, C => \MyDAC/MyAD5360/N_267_0\, Y
         => \MyDAC/MyAD5360/ResetCounter_n4_i_0_0\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[22]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Mode_07_Output[0]_net_1\, B
         => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[8]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Mode_07_Output_m[0]\);
    
    \MyDAC/MyAD5360/MyController/Buffer_14_Output[3]\ : DFN1E1C0
      port map(D => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Input[3]_net_1\, 
        CLK => Clk_c, CLR => Reset_c, E => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[17]_net_1\, 
        Q => 
        \MyDAC/MyAD5360/MyController/Buffer_14_Output[3]_net_1\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_7[2]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_03_Output[2]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[12]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_03_Output_m[2]\);
    
    \DEBUG_GPIO_pad/U0/U0\ : IOPAD_TRI
      port map(D => \DEBUG_GPIO_pad/U0/NET1\, E => 
        \DEBUG_GPIO_pad/U0/NET2\, PAD => DEBUG_GPIO);
    
    \MyDAC/TestGen/SPIMACHINE_STATE_RNO_5[0]\ : AO1D
      port map(A => \MyDAC/TestGen/N_21\, B => 
        \MyDAC/TestGen/N_26_i\, C => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_a3_1_0[0]\, Y => 
        \MyDAC/TestGen/SPIMACHINE_STATE_ns_0_0_1_tz[0]\);
    
    \MyDAC/MyAD5360/MyController/Output_24BitString_RNO_15[5]\ : 
        NOR2B
      port map(A => 
        \MyDAC/MyAD5360/MyController/Buffer_00_Output[5]_net_1\, 
        B => 
        \MyDAC/MyAD5360/MyController/SPIMACHINE_STATE[15]_net_1\, 
        Y => \MyDAC/MyAD5360/MyController/Buffer_00_Output_m[5]\);
    
    GND_power_inst1 : GND
      port map( Y => GND_power_net1);

    VCC_power_inst1 : VCC
      port map( Y => VCC_power_net1);


end DEF_ARCH; 
